/* sudoku-game.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libsudoku.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define SUDOKU_GAME_TYPE_UNDO_ITEM (sudoku_game_undo_item_get_type ())
typedef struct _SudokuGameUndoItem SudokuGameUndoItem;
enum  {
	SUDOKU_GAME_0_PROPERTY,
	SUDOKU_GAME_BOARD_PROPERTY,
	SUDOKU_GAME_MODE_PROPERTY,
	SUDOKU_GAME_PAUSED_PROPERTY,
	SUDOKU_GAME_NUM_PROPERTIES
};
static GParamSpec* sudoku_game_properties[SUDOKU_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _sudoku_game_undo_item_free0(var) ((var == NULL) ? NULL : (var = (sudoku_game_undo_item_free (var), NULL)))
enum  {
	SUDOKU_GAME_TICK_SIGNAL,
	SUDOKU_GAME_PAUSED_CHANGED_SIGNAL,
	SUDOKU_GAME_NUM_SIGNALS
};
static guint sudoku_game_signals[SUDOKU_GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuGameUndoItem {
	gint row;
	gint col;
	gint val;
	gboolean* earmarks;
	gint earmarks_length1;
	gint _earmarks_size_;
};

struct _SudokuGamePrivate {
	SudokuBoard* _board;
	GameMode _mode;
	GTimer* timer;
	guint clock_timeout;
	gboolean _paused;
	GeeList* undostack;
	GeeList* redostack;
};

static gint SudokuGame_private_offset;
static gpointer sudoku_game_parent_class = NULL;

static GType sudoku_game_undo_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SudokuGameUndoItem* sudoku_game_undo_item_dup (const SudokuGameUndoItem* self);
static void sudoku_game_undo_item_free (SudokuGameUndoItem* self);
static void sudoku_game_undo_item_copy (const SudokuGameUndoItem* self,
                                 SudokuGameUndoItem* dest);
static void sudoku_game_undo_item_destroy (SudokuGameUndoItem* self);
static void sudoku_game_set_board (SudokuGame* self,
                            SudokuBoard* value);
static void sudoku_game_apply_stack (SudokuGame* self,
                              GeeList* from,
                              GeeList* to);
static void sudoku_game_add_to_stack (SudokuGame* self,
                               GeeList* stack,
                               gint r,
                               gint c,
                               gint v,
                               gboolean* e,
                               gint e_length1);
static gboolean* _vala_array_dup10 (gboolean* self,
                             gssize length);
static gboolean sudoku_game_timeout_cb (SudokuGame* self);
static gboolean _sudoku_game_timeout_cb_gsource_func (gpointer self);
static gboolean* _vala_array_dup11 (gboolean* self,
                             gssize length);
static void sudoku_game_finalize (GObject * obj);
static GType sudoku_game_get_type_once (void);
static void _vala_sudoku_game_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_game_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sudoku_game_get_instance_private (SudokuGame* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuGame_private_offset);
}

gboolean
sudoku_game_is_undostack_null (SudokuGame* self)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 57 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 59 "../lib/sudoku-game.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 59 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 59 "../lib/sudoku-game.vala"
	result = _tmp2_ == 0;
#line 59 "../lib/sudoku-game.vala"
	return result;
#line 151 "sudoku-game.c"
}

gboolean
sudoku_game_is_redostack_null (SudokuGame* self)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 62 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 64 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->redostack;
#line 64 "../lib/sudoku-game.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 64 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 64 "../lib/sudoku-game.vala"
	result = _tmp2_ == 0;
#line 64 "../lib/sudoku-game.vala"
	return result;
#line 173 "sudoku-game.c"
}

SudokuGame*
sudoku_game_construct (GType object_type,
                       SudokuBoard* board)
{
	SudokuGame * self = NULL;
	GTimer* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 67 "../lib/sudoku-game.vala"
	g_return_val_if_fail (board != NULL, NULL);
#line 67 "../lib/sudoku-game.vala"
	self = (SudokuGame*) g_object_new (object_type, NULL);
#line 69 "../lib/sudoku-game.vala"
	sudoku_game_set_board (self, board);
#line 70 "../lib/sudoku-game.vala"
	sudoku_game_set_mode (self, GAME_MODE_PLAY);
#line 71 "../lib/sudoku-game.vala"
	_tmp0_ = g_timer_new ();
#line 71 "../lib/sudoku-game.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 71 "../lib/sudoku-game.vala"
	self->priv->timer = _tmp0_;
#line 72 "../lib/sudoku-game.vala"
	_tmp1_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GDestroyNotify) sudoku_game_undo_item_free, NULL, NULL, NULL);
#line 72 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->undostack);
#line 72 "../lib/sudoku-game.vala"
	self->priv->undostack = (GeeList*) _tmp1_;
#line 73 "../lib/sudoku-game.vala"
	_tmp2_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GDestroyNotify) sudoku_game_undo_item_free, NULL, NULL, NULL);
#line 73 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->redostack);
#line 73 "../lib/sudoku-game.vala"
	self->priv->redostack = (GeeList*) _tmp2_;
#line 67 "../lib/sudoku-game.vala"
	return self;
#line 212 "sudoku-game.c"
}

SudokuGame*
sudoku_game_new (SudokuBoard* board)
{
#line 67 "../lib/sudoku-game.vala"
	return sudoku_game_construct (TYPE_SUDOKU_GAME, board);
#line 220 "sudoku-game.c"
}

void
sudoku_game_enable_earmark (SudokuGame* self,
                            gint row,
                            gint col,
                            gint k_no)
{
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp0_;
	gint _tmp1_ = 0;
	gboolean* _tmp2_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp3_;
#line 76 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 78 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 78 "../lib/sudoku-game.vala"
	_tmp2_ = sudoku_board_get_earmarks (_tmp0_, row, col, &_tmp1_);
#line 78 "../lib/sudoku-game.vala"
	old_earmarks = _tmp2_;
#line 78 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp1_;
#line 78 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 79 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, 0, old_earmarks, (gint) old_earmarks_length1);
#line 81 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->_board;
#line 81 "../lib/sudoku-game.vala"
	sudoku_board_enable_earmark (_tmp3_, row, col, k_no);
#line 76 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 256 "sudoku-game.c"
}

void
sudoku_game_disable_earmark (SudokuGame* self,
                             gint row,
                             gint col,
                             gint k_no)
{
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp0_;
	gint _tmp1_ = 0;
	gboolean* _tmp2_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp3_;
#line 84 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 86 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 86 "../lib/sudoku-game.vala"
	_tmp2_ = sudoku_board_get_earmarks (_tmp0_, row, col, &_tmp1_);
#line 86 "../lib/sudoku-game.vala"
	old_earmarks = _tmp2_;
#line 86 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp1_;
#line 86 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 87 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, 0, old_earmarks, (gint) old_earmarks_length1);
#line 89 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->_board;
#line 89 "../lib/sudoku-game.vala"
	sudoku_board_disable_earmark (_tmp3_, row, col, k_no);
#line 84 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 292 "sudoku-game.c"
}

void
sudoku_game_disable_all_earmarks (SudokuGame* self,
                                  gint row,
                                  gint col)
{
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp0_;
	gint _tmp1_ = 0;
	gboolean* _tmp2_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp3_;
#line 92 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 94 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 94 "../lib/sudoku-game.vala"
	_tmp2_ = sudoku_board_get_earmarks (_tmp0_, row, col, &_tmp1_);
#line 94 "../lib/sudoku-game.vala"
	old_earmarks = _tmp2_;
#line 94 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp1_;
#line 94 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 95 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, 0, old_earmarks, (gint) old_earmarks_length1);
#line 97 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->_board;
#line 97 "../lib/sudoku-game.vala"
	sudoku_board_disable_all_earmarks (_tmp3_, row, col);
#line 92 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 327 "sudoku-game.c"
}

void
sudoku_game_insert (SudokuGame* self,
                    gint row,
                    gint col,
                    gint val)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp4_;
	SudokuBoard* _tmp5_;
#line 100 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 102 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 102 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 103 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->_board;
#line 103 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 103 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 103 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 103 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 104 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 106 "../lib/sudoku-game.vala"
	_tmp4_ = self->priv->_board;
#line 106 "../lib/sudoku-game.vala"
	sudoku_board_disable_all_earmarks (_tmp4_, row, col);
#line 107 "../lib/sudoku-game.vala"
	_tmp5_ = self->priv->_board;
#line 107 "../lib/sudoku-game.vala"
	sudoku_board_insert (_tmp5_, row, col, val, FALSE);
#line 100 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 374 "sudoku-game.c"
}

void
sudoku_game_remove (SudokuGame* self,
                    gint row,
                    gint col)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp4_;
#line 110 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 112 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 112 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 113 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->_board;
#line 113 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 113 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 113 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 113 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 114 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 116 "../lib/sudoku-game.vala"
	_tmp4_ = self->priv->_board;
#line 116 "../lib/sudoku-game.vala"
	sudoku_board_remove (_tmp4_, row, col);
#line 110 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 415 "sudoku-game.c"
}

gboolean
sudoku_game_is_empty (SudokuGame* self)
{
	GameMode _tmp0_;
	gboolean result;
#line 119 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 121 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_mode;
#line 121 "../lib/sudoku-game.vala"
	if (_tmp0_ == GAME_MODE_CREATE) {
#line 429 "sudoku-game.c"
		SudokuBoard* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 122 "../lib/sudoku-game.vala"
		_tmp1_ = self->priv->_board;
#line 122 "../lib/sudoku-game.vala"
		_tmp2_ = sudoku_board_get_filled (_tmp1_);
#line 122 "../lib/sudoku-game.vala"
		_tmp3_ = _tmp2_;
#line 122 "../lib/sudoku-game.vala"
		result = _tmp3_ == 0;
#line 122 "../lib/sudoku-game.vala"
		return result;
#line 443 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp4_;
#line 124 "../lib/sudoku-game.vala"
		_tmp4_ = self->priv->_board;
#line 124 "../lib/sudoku-game.vala"
		result = sudoku_board_is_empty (_tmp4_);
#line 124 "../lib/sudoku-game.vala"
		return result;
#line 452 "sudoku-game.c"
	}
}

void
sudoku_game_undo (SudokuGame* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 127 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 129 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 129 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->redostack;
#line 129 "../lib/sudoku-game.vala"
	sudoku_game_apply_stack (self, _tmp0_, _tmp1_);
#line 469 "sudoku-game.c"
}

void
sudoku_game_redo (SudokuGame* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 132 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 134 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->redostack;
#line 134 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->undostack;
#line 134 "../lib/sudoku-game.vala"
	sudoku_game_apply_stack (self, _tmp0_, _tmp1_);
#line 485 "sudoku-game.c"
}

void
sudoku_game_reset (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	GTimer* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	gint* cells = NULL;
	SudokuBoard* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint* _tmp7_;
	gint cells_length1;
	gint cells_length2;
	SudokuBoard* _tmp23_;
	GeeSet* _tmp24_;
	GeeSet* _tmp25_;
#line 137 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 139 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 139 "../lib/sudoku-game.vala"
	sudoku_board_set_previous_played_time (_tmp0_, (gdouble) 0);
#line 140 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->timer;
#line 140 "../lib/sudoku-game.vala"
	g_timer_start (_tmp1_);
#line 141 "../lib/sudoku-game.vala"
	_tmp2_ = self->priv->undostack;
#line 141 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp2_);
#line 142 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->redostack;
#line 142 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp3_);
#line 143 "../lib/sudoku-game.vala"
	_tmp4_ = self->priv->_board;
#line 143 "../lib/sudoku-game.vala"
	_tmp7_ = sudoku_board_get_cells (_tmp4_, &_tmp5_, &_tmp6_);
#line 143 "../lib/sudoku-game.vala"
	cells = _tmp7_;
#line 143 "../lib/sudoku-game.vala"
	cells_length1 = _tmp5_;
#line 143 "../lib/sudoku-game.vala"
	cells_length2 = _tmp6_;
#line 533 "sudoku-game.c"
	{
		gint l1 = 0;
#line 144 "../lib/sudoku-game.vala"
		l1 = 0;
#line 538 "sudoku-game.c"
		{
			gboolean _tmp8_ = FALSE;
#line 144 "../lib/sudoku-game.vala"
			_tmp8_ = TRUE;
#line 144 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 545 "sudoku-game.c"
				SudokuBoard* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
#line 144 "../lib/sudoku-game.vala"
				if (!_tmp8_) {
#line 551 "sudoku-game.c"
					gint _tmp9_;
#line 144 "../lib/sudoku-game.vala"
					_tmp9_ = l1;
#line 144 "../lib/sudoku-game.vala"
					l1 = _tmp9_ + 1;
#line 557 "sudoku-game.c"
				}
#line 144 "../lib/sudoku-game.vala"
				_tmp8_ = FALSE;
#line 144 "../lib/sudoku-game.vala"
				_tmp10_ = self->priv->_board;
#line 144 "../lib/sudoku-game.vala"
				_tmp11_ = sudoku_board_get_rows (_tmp10_);
#line 144 "../lib/sudoku-game.vala"
				_tmp12_ = _tmp11_;
#line 144 "../lib/sudoku-game.vala"
				if (!(l1 < _tmp12_)) {
#line 144 "../lib/sudoku-game.vala"
					break;
#line 571 "sudoku-game.c"
				}
				{
					gint l2 = 0;
#line 146 "../lib/sudoku-game.vala"
					l2 = 0;
#line 577 "sudoku-game.c"
					{
						gboolean _tmp13_ = FALSE;
#line 146 "../lib/sudoku-game.vala"
						_tmp13_ = TRUE;
#line 146 "../lib/sudoku-game.vala"
						while (TRUE) {
#line 584 "sudoku-game.c"
							SudokuBoard* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							SudokuBoard* _tmp18_;
							gint* _tmp19_;
							gint _tmp19__length1;
							gint _tmp19__length2;
							gint _tmp20_;
#line 146 "../lib/sudoku-game.vala"
							if (!_tmp13_) {
#line 595 "sudoku-game.c"
								gint _tmp14_;
#line 146 "../lib/sudoku-game.vala"
								_tmp14_ = l2;
#line 146 "../lib/sudoku-game.vala"
								l2 = _tmp14_ + 1;
#line 601 "sudoku-game.c"
							}
#line 146 "../lib/sudoku-game.vala"
							_tmp13_ = FALSE;
#line 146 "../lib/sudoku-game.vala"
							_tmp15_ = self->priv->_board;
#line 146 "../lib/sudoku-game.vala"
							_tmp16_ = sudoku_board_get_cols (_tmp15_);
#line 146 "../lib/sudoku-game.vala"
							_tmp17_ = _tmp16_;
#line 146 "../lib/sudoku-game.vala"
							if (!(l2 < _tmp17_)) {
#line 146 "../lib/sudoku-game.vala"
								break;
#line 615 "sudoku-game.c"
							}
#line 148 "../lib/sudoku-game.vala"
							_tmp18_ = self->priv->_board;
#line 148 "../lib/sudoku-game.vala"
							if (sudoku_board_get_is_fixed (_tmp18_, l1, l2)) {
#line 149 "../lib/sudoku-game.vala"
								continue;
#line 623 "sudoku-game.c"
							}
#line 151 "../lib/sudoku-game.vala"
							_tmp19_ = cells;
#line 151 "../lib/sudoku-game.vala"
							_tmp19__length1 = cells_length1;
#line 151 "../lib/sudoku-game.vala"
							_tmp19__length2 = cells_length2;
#line 151 "../lib/sudoku-game.vala"
							_tmp20_ = _tmp19_[(l1 * _tmp19__length2) + l2];
#line 151 "../lib/sudoku-game.vala"
							if (_tmp20_ > 0) {
#line 635 "sudoku-game.c"
								SudokuBoard* _tmp21_;
#line 152 "../lib/sudoku-game.vala"
								_tmp21_ = self->priv->_board;
#line 152 "../lib/sudoku-game.vala"
								sudoku_board_remove (_tmp21_, l1, l2);
#line 641 "sudoku-game.c"
							} else {
								SudokuBoard* _tmp22_;
#line 154 "../lib/sudoku-game.vala"
								_tmp22_ = self->priv->_board;
#line 154 "../lib/sudoku-game.vala"
								sudoku_board_disable_all_earmarks (_tmp22_, l1, l2);
#line 648 "sudoku-game.c"
							}
						}
					}
				}
			}
		}
	}
#line 157 "../lib/sudoku-game.vala"
	_tmp23_ = self->priv->_board;
#line 157 "../lib/sudoku-game.vala"
	_tmp24_ = sudoku_board_get_broken_coords (_tmp23_);
#line 157 "../lib/sudoku-game.vala"
	_tmp25_ = _tmp24_;
#line 157 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp25_);
#line 137 "../lib/sudoku-game.vala"
	cells = (g_free (cells), NULL);
#line 666 "sudoku-game.c"
}

void
sudoku_game_update_undo (SudokuGame* self,
                         gint row,
                         gint col,
                         gint old_val,
                         gboolean* old_earmarks,
                         gint old_earmarks_length1)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 161 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 163 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 163 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, _tmp0_, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 164 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->redostack;
#line 164 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp1_);
#line 689 "sudoku-game.c"
}

static gboolean*
_vala_array_dup10 (gboolean* self,
                   gssize length)
{
#line 169 "../lib/sudoku-game.vala"
	if (length > 0) {
#line 169 "../lib/sudoku-game.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 700 "sudoku-game.c"
	}
#line 169 "../lib/sudoku-game.vala"
	return NULL;
#line 704 "sudoku-game.c"
}

static void
sudoku_game_add_to_stack (SudokuGame* self,
                          GeeList* stack,
                          gint r,
                          gint c,
                          gint v,
                          gboolean* e,
                          gint e_length1)
{
	SudokuGameUndoItem step = {0};
	gboolean* _tmp0_;
	gint _tmp0__length1;
	SudokuGameUndoItem _tmp1_ = {0};
	SudokuGameUndoItem _tmp2_;
#line 167 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 167 "../lib/sudoku-game.vala"
	g_return_if_fail (stack != NULL);
#line 169 "../lib/sudoku-game.vala"
	_tmp0_ = (e != NULL) ? _vala_array_dup10 (e, e_length1) : e;
#line 169 "../lib/sudoku-game.vala"
	_tmp0__length1 = e_length1;
#line 169 "../lib/sudoku-game.vala"
	_tmp1_.row = r;
#line 169 "../lib/sudoku-game.vala"
	_tmp1_.col = c;
#line 169 "../lib/sudoku-game.vala"
	_tmp1_.val = v;
#line 169 "../lib/sudoku-game.vala"
	_tmp1_.earmarks = (g_free (_tmp1_.earmarks), NULL);
#line 169 "../lib/sudoku-game.vala"
	_tmp1_.earmarks = _tmp0_;
#line 169 "../lib/sudoku-game.vala"
	_tmp1_.earmarks_length1 = _tmp0__length1;
#line 169 "../lib/sudoku-game.vala"
	_tmp1_._earmarks_size_ = _tmp1_.earmarks_length1;
#line 169 "../lib/sudoku-game.vala"
	step = _tmp1_;
#line 170 "../lib/sudoku-game.vala"
	_tmp2_ = step;
#line 170 "../lib/sudoku-game.vala"
	gee_collection_add ((GeeCollection*) stack, &_tmp2_);
#line 167 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_destroy (&step);
#line 751 "sudoku-game.c"
}

static void
sudoku_game_apply_stack (SudokuGame* self,
                         GeeList* from,
                         GeeList* to)
{
	gint _tmp0_;
	gint _tmp1_;
	SudokuGameUndoItem* top = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gpointer _tmp4_;
	gint old_val = 0;
	SudokuBoard* _tmp5_;
	SudokuGameUndoItem* _tmp6_;
	SudokuGameUndoItem* _tmp7_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp8_;
	SudokuGameUndoItem* _tmp9_;
	SudokuGameUndoItem* _tmp10_;
	gint _tmp11_ = 0;
	gboolean* _tmp12_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuGameUndoItem* _tmp13_;
	SudokuGameUndoItem* _tmp14_;
	gboolean* _tmp15_;
	gint _tmp15__length1;
	SudokuGameUndoItem* _tmp16_;
#line 173 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 173 "../lib/sudoku-game.vala"
	g_return_if_fail (from != NULL);
#line 173 "../lib/sudoku-game.vala"
	g_return_if_fail (to != NULL);
#line 175 "../lib/sudoku-game.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) from);
#line 175 "../lib/sudoku-game.vala"
	_tmp1_ = _tmp0_;
#line 175 "../lib/sudoku-game.vala"
	if (_tmp1_ == 0) {
#line 176 "../lib/sudoku-game.vala"
		return;
#line 796 "sudoku-game.c"
	}
#line 178 "../lib/sudoku-game.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) from);
#line 178 "../lib/sudoku-game.vala"
	_tmp3_ = _tmp2_;
#line 178 "../lib/sudoku-game.vala"
	_tmp4_ = gee_list_remove_at (from, _tmp3_ - 1);
#line 178 "../lib/sudoku-game.vala"
	top = (SudokuGameUndoItem*) _tmp4_;
#line 179 "../lib/sudoku-game.vala"
	_tmp5_ = self->priv->_board;
#line 179 "../lib/sudoku-game.vala"
	_tmp6_ = top;
#line 179 "../lib/sudoku-game.vala"
	_tmp7_ = top;
#line 179 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp5_, (*_tmp6_).row, (*_tmp7_).col);
#line 180 "../lib/sudoku-game.vala"
	_tmp8_ = self->priv->_board;
#line 180 "../lib/sudoku-game.vala"
	_tmp9_ = top;
#line 180 "../lib/sudoku-game.vala"
	_tmp10_ = top;
#line 180 "../lib/sudoku-game.vala"
	_tmp12_ = sudoku_board_get_earmarks (_tmp8_, (*_tmp9_).row, (*_tmp10_).col, &_tmp11_);
#line 180 "../lib/sudoku-game.vala"
	old_earmarks = _tmp12_;
#line 180 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp11_;
#line 180 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 181 "../lib/sudoku-game.vala"
	_tmp13_ = top;
#line 181 "../lib/sudoku-game.vala"
	_tmp14_ = top;
#line 181 "../lib/sudoku-game.vala"
	_tmp15_ = old_earmarks;
#line 181 "../lib/sudoku-game.vala"
	_tmp15__length1 = old_earmarks_length1;
#line 181 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, to, (*_tmp13_).row, (*_tmp14_).col, old_val, _tmp15_, (gint) _tmp15__length1);
#line 183 "../lib/sudoku-game.vala"
	_tmp16_ = top;
#line 183 "../lib/sudoku-game.vala"
	if ((*_tmp16_).val != old_val) {
#line 842 "sudoku-game.c"
		SudokuBoard* _tmp17_;
		SudokuGameUndoItem* _tmp18_;
		SudokuGameUndoItem* _tmp19_;
		SudokuGameUndoItem* _tmp20_;
#line 184 "../lib/sudoku-game.vala"
		_tmp17_ = self->priv->_board;
#line 184 "../lib/sudoku-game.vala"
		_tmp18_ = top;
#line 184 "../lib/sudoku-game.vala"
		_tmp19_ = top;
#line 184 "../lib/sudoku-game.vala"
		_tmp20_ = top;
#line 184 "../lib/sudoku-game.vala"
		sudoku_board_set (_tmp17_, (*_tmp18_).row, (*_tmp19_).col, (*_tmp20_).val);
#line 857 "sudoku-game.c"
	}
	{
		gint i = 0;
#line 186 "../lib/sudoku-game.vala"
		i = 1;
#line 863 "sudoku-game.c"
		{
			gboolean _tmp21_ = FALSE;
#line 186 "../lib/sudoku-game.vala"
			_tmp21_ = TRUE;
#line 186 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 870 "sudoku-game.c"
				SudokuGameUndoItem* _tmp23_;
				gboolean* _tmp24_;
				gint _tmp24__length1;
				SudokuGameUndoItem* _tmp25_;
				gboolean* _tmp26_;
				gint _tmp26__length1;
				gboolean _tmp27_;
				gboolean* _tmp28_;
				gint _tmp28__length1;
				gboolean _tmp29_;
#line 186 "../lib/sudoku-game.vala"
				if (!_tmp21_) {
#line 883 "sudoku-game.c"
					gint _tmp22_;
#line 186 "../lib/sudoku-game.vala"
					_tmp22_ = i;
#line 186 "../lib/sudoku-game.vala"
					i = _tmp22_ + 1;
#line 889 "sudoku-game.c"
				}
#line 186 "../lib/sudoku-game.vala"
				_tmp21_ = FALSE;
#line 186 "../lib/sudoku-game.vala"
				_tmp23_ = top;
#line 186 "../lib/sudoku-game.vala"
				_tmp24_ = (*_tmp23_).earmarks;
#line 186 "../lib/sudoku-game.vala"
				_tmp24__length1 = (*_tmp23_).earmarks_length1;
#line 186 "../lib/sudoku-game.vala"
				if (!(i <= _tmp24__length1)) {
#line 186 "../lib/sudoku-game.vala"
					break;
#line 903 "sudoku-game.c"
				}
#line 188 "../lib/sudoku-game.vala"
				_tmp25_ = top;
#line 188 "../lib/sudoku-game.vala"
				_tmp26_ = (*_tmp25_).earmarks;
#line 188 "../lib/sudoku-game.vala"
				_tmp26__length1 = (*_tmp25_).earmarks_length1;
#line 188 "../lib/sudoku-game.vala"
				_tmp27_ = _tmp26_[i - 1];
#line 188 "../lib/sudoku-game.vala"
				_tmp28_ = old_earmarks;
#line 188 "../lib/sudoku-game.vala"
				_tmp28__length1 = old_earmarks_length1;
#line 188 "../lib/sudoku-game.vala"
				_tmp29_ = _tmp28_[i - 1];
#line 188 "../lib/sudoku-game.vala"
				if (_tmp27_ != _tmp29_) {
#line 921 "sudoku-game.c"
					SudokuGameUndoItem* _tmp30_;
					gboolean* _tmp31_;
					gint _tmp31__length1;
					gboolean _tmp32_;
#line 190 "../lib/sudoku-game.vala"
					_tmp30_ = top;
#line 190 "../lib/sudoku-game.vala"
					_tmp31_ = (*_tmp30_).earmarks;
#line 190 "../lib/sudoku-game.vala"
					_tmp31__length1 = (*_tmp30_).earmarks_length1;
#line 190 "../lib/sudoku-game.vala"
					_tmp32_ = _tmp31_[i - 1];
#line 190 "../lib/sudoku-game.vala"
					if (_tmp32_) {
#line 936 "sudoku-game.c"
						SudokuBoard* _tmp33_;
						SudokuGameUndoItem* _tmp34_;
						SudokuGameUndoItem* _tmp35_;
#line 191 "../lib/sudoku-game.vala"
						_tmp33_ = self->priv->_board;
#line 191 "../lib/sudoku-game.vala"
						_tmp34_ = top;
#line 191 "../lib/sudoku-game.vala"
						_tmp35_ = top;
#line 191 "../lib/sudoku-game.vala"
						sudoku_board_enable_earmark (_tmp33_, (*_tmp34_).row, (*_tmp35_).col, i);
#line 948 "sudoku-game.c"
					} else {
						SudokuBoard* _tmp36_;
						SudokuGameUndoItem* _tmp37_;
						SudokuGameUndoItem* _tmp38_;
#line 193 "../lib/sudoku-game.vala"
						_tmp36_ = self->priv->_board;
#line 193 "../lib/sudoku-game.vala"
						_tmp37_ = top;
#line 193 "../lib/sudoku-game.vala"
						_tmp38_ = top;
#line 193 "../lib/sudoku-game.vala"
						sudoku_board_disable_earmark (_tmp36_, (*_tmp37_).row, (*_tmp38_).col, i);
#line 961 "sudoku-game.c"
					}
				}
			}
		}
	}
#line 173 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 173 "../lib/sudoku-game.vala"
	_sudoku_game_undo_item_free0 (top);
#line 971 "sudoku-game.c"
}

gdouble
sudoku_game_get_total_time_played (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GTimer* _tmp3_;
	gdouble result;
#line 199 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 201 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 201 "../lib/sudoku-game.vala"
	_tmp1_ = sudoku_board_get_previous_played_time (_tmp0_);
#line 201 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 201 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->timer;
#line 201 "../lib/sudoku-game.vala"
	result = _tmp2_ + g_timer_elapsed (_tmp3_, NULL);
#line 201 "../lib/sudoku-game.vala"
	return result;
#line 996 "sudoku-game.c"
}

static gboolean
_sudoku_game_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = sudoku_game_timeout_cb ((SudokuGame*) self);
#line 206 "../lib/sudoku-game.vala"
	return result;
#line 1006 "sudoku-game.c"
}

static gboolean
sudoku_game_timeout_cb (SudokuGame* self)
{
	gboolean result;
#line 204 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "../lib/sudoku-game.vala"
	self->priv->clock_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _sudoku_game_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 207 "../lib/sudoku-game.vala"
	g_source_set_name_by_id (self->priv->clock_timeout, "[gnome-sudoku] timeout_cb");
#line 208 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
#line 209 "../lib/sudoku-game.vala"
	result = FALSE;
#line 209 "../lib/sudoku-game.vala"
	return result;
#line 1025 "sudoku-game.c"
}

void
sudoku_game_start_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp2_;
#line 212 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 214 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->timer;
#line 214 "../lib/sudoku-game.vala"
	if (_tmp0_ == NULL) {
#line 1039 "sudoku-game.c"
		GTimer* _tmp1_;
#line 215 "../lib/sudoku-game.vala"
		_tmp1_ = g_timer_new ();
#line 215 "../lib/sudoku-game.vala"
		_g_timer_destroy0 (self->priv->timer);
#line 215 "../lib/sudoku-game.vala"
		self->priv->timer = _tmp1_;
#line 1047 "sudoku-game.c"
	}
#line 216 "../lib/sudoku-game.vala"
	_tmp2_ = self->priv->timer;
#line 216 "../lib/sudoku-game.vala"
	g_timer_start (_tmp2_);
#line 217 "../lib/sudoku-game.vala"
	sudoku_game_timeout_cb (self);
#line 1055 "sudoku-game.c"
}

void
sudoku_game_stop_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 220 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 220 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->timer;
#line 220 "../lib/sudoku-game.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "timer != null");
#line 223 "../lib/sudoku-game.vala"
	if (self->priv->clock_timeout != ((guint) 0)) {
#line 224 "../lib/sudoku-game.vala"
		g_source_remove (self->priv->clock_timeout);
#line 1073 "sudoku-game.c"
	}
#line 225 "../lib/sudoku-game.vala"
	self->priv->clock_timeout = (guint) 0;
#line 226 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->timer;
#line 226 "../lib/sudoku-game.vala"
	g_timer_stop (_tmp1_);
#line 227 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
#line 1083 "sudoku-game.c"
}

void
sudoku_game_resume_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 230 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 230 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->timer;
#line 230 "../lib/sudoku-game.vala"
	_vala_return_if_fail ((_tmp0_ != NULL) && (self->priv->clock_timeout == ((guint) 0)), "timer != null && clock_timeout == 0");
#line 233 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->timer;
#line 233 "../lib/sudoku-game.vala"
	g_timer_continue (_tmp1_);
#line 234 "../lib/sudoku-game.vala"
	sudoku_game_timeout_cb (self);
#line 1103 "sudoku-game.c"
}

SudokuBoard*
sudoku_game_get_board (SudokuGame* self)
{
	SudokuBoard* result;
	SudokuBoard* _tmp0_;
#line 26 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 26 "../lib/sudoku-game.vala"
	result = _tmp0_;
#line 26 "../lib/sudoku-game.vala"
	return result;
#line 1119 "sudoku-game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../lib/sudoku-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 1127 "sudoku-game.c"
}

static void
sudoku_game_set_board (SudokuGame* self,
                       SudokuBoard* value)
{
	SudokuBoard* old_value;
#line 26 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 26 "../lib/sudoku-game.vala"
	old_value = sudoku_game_get_board (self);
#line 26 "../lib/sudoku-game.vala"
	if (old_value != value) {
#line 1141 "sudoku-game.c"
		SudokuBoard* _tmp0_;
#line 26 "../lib/sudoku-game.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../lib/sudoku-game.vala"
		_g_object_unref0 (self->priv->_board);
#line 26 "../lib/sudoku-game.vala"
		self->priv->_board = _tmp0_;
#line 26 "../lib/sudoku-game.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_BOARD_PROPERTY]);
#line 1151 "sudoku-game.c"
	}
}

GameMode
sudoku_game_get_mode (SudokuGame* self)
{
	GameMode result;
#line 27 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../lib/sudoku-game.vala"
	result = self->priv->_mode;
#line 27 "../lib/sudoku-game.vala"
	return result;
#line 1165 "sudoku-game.c"
}

void
sudoku_game_set_mode (SudokuGame* self,
                      GameMode value)
{
	GameMode old_value;
#line 27 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 27 "../lib/sudoku-game.vala"
	old_value = sudoku_game_get_mode (self);
#line 27 "../lib/sudoku-game.vala"
	if (old_value != value) {
#line 27 "../lib/sudoku-game.vala"
		self->priv->_mode = value;
#line 27 "../lib/sudoku-game.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_MODE_PROPERTY]);
#line 1183 "sudoku-game.c"
	}
}

gboolean
sudoku_game_get_paused (SudokuGame* self)
{
	gboolean result;
#line 42 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../lib/sudoku-game.vala"
	result = self->priv->_paused;
#line 42 "../lib/sudoku-game.vala"
	return result;
#line 1197 "sudoku-game.c"
}

void
sudoku_game_set_paused (SudokuGame* self,
                        gboolean value)
{
#line 37 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 39 "../lib/sudoku-game.vala"
	self->priv->_paused = value;
#line 40 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL], 0);
#line 37 "../lib/sudoku-game.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY]);
#line 1212 "sudoku-game.c"
}

static gboolean*
_vala_array_dup11 (gboolean* self,
                   gssize length)
{
#line 45 "../lib/sudoku-game.vala"
	if (length > 0) {
#line 45 "../lib/sudoku-game.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1223 "sudoku-game.c"
	}
#line 45 "../lib/sudoku-game.vala"
	return NULL;
#line 1227 "sudoku-game.c"
}

static void
sudoku_game_undo_item_copy (const SudokuGameUndoItem* self,
                            SudokuGameUndoItem* dest)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gboolean* _tmp1_;
	gint _tmp1__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest).row = (*self).row;
#line 45 "../lib/sudoku-game.vala"
	(*dest).col = (*self).col;
#line 45 "../lib/sudoku-game.vala"
	(*dest).val = (*self).val;
#line 45 "../lib/sudoku-game.vala"
	_tmp0_ = (*self).earmarks;
#line 45 "../lib/sudoku-game.vala"
	_tmp0__length1 = (*self).earmarks_length1;
#line 45 "../lib/sudoku-game.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup11 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 45 "../lib/sudoku-game.vala"
	_tmp1__length1 = _tmp0__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks = (g_free ((*dest).earmarks), NULL);
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks = _tmp1_;
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks_length1 = _tmp1__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest)._earmarks_size_ = (*dest).earmarks_length1;
#line 1260 "sudoku-game.c"
}

static void
sudoku_game_undo_item_destroy (SudokuGameUndoItem* self)
{
#line 50 "../lib/sudoku-game.vala"
	(*self).earmarks = (g_free ((*self).earmarks), NULL);
#line 1268 "sudoku-game.c"
}

static SudokuGameUndoItem*
sudoku_game_undo_item_dup (const SudokuGameUndoItem* self)
{
	SudokuGameUndoItem* dup;
#line 45 "../lib/sudoku-game.vala"
	dup = g_new0 (SudokuGameUndoItem, 1);
#line 45 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_copy (self, dup);
#line 45 "../lib/sudoku-game.vala"
	return dup;
#line 1281 "sudoku-game.c"
}

static void
sudoku_game_undo_item_free (SudokuGameUndoItem* self)
{
#line 45 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_destroy (self);
#line 45 "../lib/sudoku-game.vala"
	g_free (self);
#line 1291 "sudoku-game.c"
}

static GType
sudoku_game_undo_item_get_type_once (void)
{
	GType sudoku_game_undo_item_type_id;
	sudoku_game_undo_item_type_id = g_boxed_type_register_static ("SudokuGameUndoItem", (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GBoxedFreeFunc) sudoku_game_undo_item_free);
	return sudoku_game_undo_item_type_id;
}

static GType
sudoku_game_undo_item_get_type (void)
{
	static volatile gsize sudoku_game_undo_item_type_id__once = 0;
	if (g_once_init_enter (&sudoku_game_undo_item_type_id__once)) {
		GType sudoku_game_undo_item_type_id;
		sudoku_game_undo_item_type_id = sudoku_game_undo_item_get_type_once ();
		g_once_init_leave (&sudoku_game_undo_item_type_id__once, sudoku_game_undo_item_type_id);
	}
	return sudoku_game_undo_item_type_id__once;
}

static void
sudoku_game_class_init (SudokuGameClass * klass,
                        gpointer klass_data)
{
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-game.vala"
	g_type_class_adjust_private_offset (klass, &SudokuGame_private_offset);
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_game_get_property;
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_game_set_property;
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_game_finalize;
#line 24 "../lib/sudoku-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_BOARD_PROPERTY, sudoku_game_properties[SUDOKU_GAME_BOARD_PROPERTY] = g_param_spec_object ("board", "board", "board", TYPE_SUDOKU_BOARD, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_MODE_PROPERTY, sudoku_game_properties[SUDOKU_GAME_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", TYPE_GAME_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_PAUSED_PROPERTY, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL] = g_signal_new ("tick", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1338 "sudoku-game.c"
}

static void
sudoku_game_instance_init (SudokuGame * self,
                           gpointer klass)
{
#line 24 "../lib/sudoku-game.vala"
	self->priv = sudoku_game_get_instance_private (self);
#line 34 "../lib/sudoku-game.vala"
	self->priv->_paused = FALSE;
#line 1349 "sudoku-game.c"
}

static void
sudoku_game_finalize (GObject * obj)
{
	SudokuGame * self;
#line 24 "../lib/sudoku-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_GAME, SudokuGame);
#line 26 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->_board);
#line 28 "../lib/sudoku-game.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 54 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->undostack);
#line 55 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->redostack);
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (sudoku_game_parent_class)->finalize (obj);
#line 1368 "sudoku-game.c"
}

static GType
sudoku_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuGame), 0, (GInstanceInitFunc) sudoku_game_instance_init, NULL };
	GType sudoku_game_type_id;
	sudoku_game_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuGame", &g_define_type_info, 0);
	SudokuGame_private_offset = g_type_add_instance_private (sudoku_game_type_id, sizeof (SudokuGamePrivate));
	return sudoku_game_type_id;
}

GType
sudoku_game_get_type (void)
{
	static volatile gsize sudoku_game_type_id__once = 0;
	if (g_once_init_enter (&sudoku_game_type_id__once)) {
		GType sudoku_game_type_id;
		sudoku_game_type_id = sudoku_game_get_type_once ();
		g_once_init_leave (&sudoku_game_type_id__once, sudoku_game_type_id);
	}
	return sudoku_game_type_id__once;
}

static void
_vala_sudoku_game_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
#line 24 "../lib/sudoku-game.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_BOARD_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		g_value_set_object (value, sudoku_game_get_board (self));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_MODE_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		g_value_set_enum (value, sudoku_game_get_mode (self));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_PAUSED_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		g_value_set_boolean (value, sudoku_game_get_paused (self));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1421 "sudoku-game.c"
		default:
#line 24 "../lib/sudoku-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1427 "sudoku-game.c"
	}
}

static void
_vala_sudoku_game_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
#line 24 "../lib/sudoku-game.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_BOARD_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		sudoku_game_set_board (self, g_value_get_object (value));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_MODE_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		sudoku_game_set_mode (self, g_value_get_enum (value));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_PAUSED_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		sudoku_game_set_paused (self, g_value_get_boolean (value));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1459 "sudoku-game.c"
		default:
#line 24 "../lib/sudoku-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1465 "sudoku-game.c"
	}
}

static GType
game_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_MODE_PLAY, "GAME_MODE_PLAY", "play"}, {GAME_MODE_CREATE, "GAME_MODE_CREATE", "create"}, {0, NULL, NULL}};
	GType game_mode_type_id;
	game_mode_type_id = g_enum_register_static ("GameMode", values);
	return game_mode_type_id;
}

GType
game_mode_get_type (void)
{
	static volatile gsize game_mode_type_id__once = 0;
	if (g_once_init_enter (&game_mode_type_id__once)) {
		GType game_mode_type_id;
		game_mode_type_id = game_mode_get_type_once ();
		g_once_init_leave (&game_mode_type_id__once, game_mode_type_id);
	}
	return game_mode_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

