/* number-picker.c generated by valac 0.56.17, the Vala compiler
 * generated from number-picker.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _NumberPickerPrivate NumberPickerPrivate;
enum  {
	NUMBER_PICKER_0_PROPERTY,
	NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY,
	NUMBER_PICKER_NUM_PROPERTIES
};
static GParamSpec* number_picker_properties[NUMBER_PICKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block7Data Block7Data;
enum  {
	NUMBER_PICKER_NUMBER_PICKED_SIGNAL,
	NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL,
	NUMBER_PICKER_NUM_SIGNALS
};
static guint number_picker_signals[NUMBER_PICKER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NumberPicker {
	GtkGrid parent_instance;
	NumberPickerPrivate * priv;
};

struct _NumberPickerClass {
	GtkGridClass parent_class;
};

struct _NumberPickerPrivate {
	SudokuBoard* board;
	GtkButton* clear_button;
	gint earmarks_active;
	gboolean _is_earmark_picker;
};

struct _Block5Data {
	int _ref_count_;
	NumberPicker* self;
	gboolean for_earmarks;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	gint n;
	GtkButton* button;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	GtkToggleButton* toggle_button;
};

static gint NumberPicker_private_offset;
static gpointer number_picker_parent_class = NULL;

VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN NumberPicker* number_picker_new (SudokuGame* game,
                                 gboolean for_earmarks);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuGame* game,
                                       gboolean for_earmarks);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void number_picker_set_is_earmark_picker (NumberPicker* self,
                                          gboolean value);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _________lambda4_ (Block6Data* _data6_);
static void __________lambda4__gtk_button_clicked (GtkButton* _sender,
                                            gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _________lambda5_ (Block7Data* _data7_);
static void __________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                   gpointer self);
static void _________lambda6_ (Block6Data* _data6_);
static void __________lambda6__gtk_widget_realize (GtkWidget* _sender,
                                            gpointer self);
static void __lambda7_ (Block5Data* _data5_);
static GtkToggleButton* number_picker_get_button_for (NumberPicker* self,
                                               gint number);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
VALA_EXTERN gboolean number_picker_get_is_earmark_picker (NumberPicker* self);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
static void g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void number_picker_finalize (GObject * obj);
static GType number_picker_get_type_once (void);
static void _vala_number_picker_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_number_picker_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
number_picker_get_instance_private (NumberPicker* self)
{
	return G_STRUCT_MEMBER_P (self, NumberPicker_private_offset);
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 37 "../src/number-picker.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 37 "../src/number-picker.vala"
	return _data5_;
#line 194 "number-picker.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 37 "../src/number-picker.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 204 "number-picker.c"
		NumberPicker* self;
#line 37 "../src/number-picker.vala"
		self = _data5_->self;
#line 37 "../src/number-picker.vala"
		_g_object_unref0 (self);
#line 37 "../src/number-picker.vala"
		g_slice_free (Block5Data, _data5_);
#line 212 "number-picker.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/number-picker.vala"
	return self ? g_object_ref (self) : NULL;
#line 221 "number-picker.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 46 "../src/number-picker.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 46 "../src/number-picker.vala"
	return _data6_;
#line 231 "number-picker.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 46 "../src/number-picker.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 241 "number-picker.c"
		NumberPicker* self;
#line 46 "../src/number-picker.vala"
		self = _data6_->_data5_->self;
#line 46 "../src/number-picker.vala"
		_g_object_unref0 (_data6_->button);
#line 46 "../src/number-picker.vala"
		block5_data_unref (_data6_->_data5_);
#line 46 "../src/number-picker.vala"
		_data6_->_data5_ = NULL;
#line 46 "../src/number-picker.vala"
		g_slice_free (Block6Data, _data6_);
#line 253 "number-picker.c"
	}
}

static void
_________lambda4_ (Block6Data* _data6_)
{
	Block5Data* _data5_;
	NumberPicker* self;
#line 64 "../src/number-picker.vala"
	_data5_ = _data6_->_data5_;
#line 64 "../src/number-picker.vala"
	self = _data5_->self;
#line 65 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL], 0, _data6_->n);
#line 268 "number-picker.c"
}

static void
__________lambda4__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self)
{
#line 64 "../src/number-picker.vala"
	_________lambda4_ (self);
#line 277 "number-picker.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 63 "../src/number-picker.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 63 "../src/number-picker.vala"
	return _data7_;
#line 287 "number-picker.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 63 "../src/number-picker.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 297 "number-picker.c"
		NumberPicker* self;
#line 63 "../src/number-picker.vala"
		self = _data7_->_data6_->_data5_->self;
#line 63 "../src/number-picker.vala"
		_g_object_unref0 (_data7_->toggle_button);
#line 63 "../src/number-picker.vala"
		block6_data_unref (_data7_->_data6_);
#line 63 "../src/number-picker.vala"
		_data7_->_data6_ = NULL;
#line 63 "../src/number-picker.vala"
		g_slice_free (Block7Data, _data7_);
#line 309 "number-picker.c"
	}
}

static void
_________lambda5_ (Block7Data* _data7_)
{
	Block6Data* _data6_;
	Block5Data* _data5_;
	NumberPicker* self;
	gboolean toggle_active = FALSE;
	GtkToggleButton* _tmp0_;
#line 70 "../src/number-picker.vala"
	_data6_ = _data7_->_data6_;
#line 70 "../src/number-picker.vala"
	_data5_ = _data6_->_data5_;
#line 70 "../src/number-picker.vala"
	self = _data5_->self;
#line 71 "../src/number-picker.vala"
	_tmp0_ = _data7_->toggle_button;
#line 71 "../src/number-picker.vala"
	toggle_active = gtk_toggle_button_get_active (_tmp0_);
#line 72 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL], 0, _data6_->n, toggle_active);
#line 333 "number-picker.c"
}

static void
__________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self)
{
#line 70 "../src/number-picker.vala"
	_________lambda5_ (self);
#line 342 "number-picker.c"
}

static void
_________lambda6_ (Block6Data* _data6_)
{
	Block5Data* _data5_;
	NumberPicker* self;
	GtkButton* _tmp0_;
#line 76 "../src/number-picker.vala"
	_data5_ = _data6_->_data5_;
#line 76 "../src/number-picker.vala"
	self = _data5_->self;
#line 77 "../src/number-picker.vala"
	_tmp0_ = _data6_->button;
#line 77 "../src/number-picker.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 359 "number-picker.c"
}

static void
__________lambda6__gtk_widget_realize (GtkWidget* _sender,
                                       gpointer self)
{
#line 76 "../src/number-picker.vala"
	_________lambda6_ (self);
#line 368 "number-picker.c"
}

static void
__lambda7_ (Block5Data* _data5_)
{
	NumberPicker* self;
#line 92 "../src/number-picker.vala"
	self = _data5_->self;
#line 93 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL], 0, 0);
#line 94 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL], 0, 0, FALSE);
#line 96 "../src/number-picker.vala"
	if (_data5_->for_earmarks) {
#line 383 "number-picker.c"
		{
			gint i = 0;
#line 98 "../src/number-picker.vala"
			i = 0;
#line 388 "number-picker.c"
			{
				gboolean _tmp0_ = FALSE;
#line 98 "../src/number-picker.vala"
				_tmp0_ = TRUE;
#line 98 "../src/number-picker.vala"
				while (TRUE) {
#line 395 "number-picker.c"
					GtkToggleButton* button = NULL;
					GtkToggleButton* _tmp2_;
					GtkToggleButton* _tmp3_;
#line 98 "../src/number-picker.vala"
					if (!_tmp0_) {
#line 401 "number-picker.c"
						gint _tmp1_;
#line 98 "../src/number-picker.vala"
						_tmp1_ = i;
#line 98 "../src/number-picker.vala"
						i = _tmp1_ + 1;
#line 407 "number-picker.c"
					}
#line 98 "../src/number-picker.vala"
					_tmp0_ = FALSE;
#line 98 "../src/number-picker.vala"
					if (!(i <= 8)) {
#line 98 "../src/number-picker.vala"
						break;
#line 415 "number-picker.c"
					}
#line 100 "../src/number-picker.vala"
					_tmp2_ = number_picker_get_button_for (self, i);
#line 100 "../src/number-picker.vala"
					button = _tmp2_;
#line 101 "../src/number-picker.vala"
					_tmp3_ = button;
#line 101 "../src/number-picker.vala"
					gtk_toggle_button_set_active (_tmp3_, FALSE);
#line 98 "../src/number-picker.vala"
					_g_object_unref0 (button);
#line 427 "number-picker.c"
				}
			}
		}
	}
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 92 "../src/number-picker.vala"
	__lambda7_ (self);
#line 440 "number-picker.c"
}

NumberPicker*
number_picker_construct (GType object_type,
                         SudokuGame* game,
                         gboolean for_earmarks)
{
	NumberPicker * self = NULL;
	Block5Data* _data5_;
	SudokuBoard* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	GtkButton* _tmp47_;
	GtkButton* _tmp48_;
	GtkButton* _tmp49_;
	GtkLabel* label = NULL;
	gchar* _tmp50_;
	gchar* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkButton* _tmp54_;
	GtkButton* _tmp55_;
#line 37 "../src/number-picker.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 37 "../src/number-picker.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 37 "../src/number-picker.vala"
	_data5_->_ref_count_ = 1;
#line 37 "../src/number-picker.vala"
	_data5_->for_earmarks = for_earmarks;
#line 37 "../src/number-picker.vala"
	self = (NumberPicker*) g_object_new (object_type, NULL);
#line 37 "../src/number-picker.vala"
	_data5_->self = g_object_ref (self);
#line 39 "../src/number-picker.vala"
	_tmp0_ = sudoku_game_get_board (game);
#line 39 "../src/number-picker.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/number-picker.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 39 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->board);
#line 39 "../src/number-picker.vala"
	self->priv->board = _tmp2_;
#line 40 "../src/number-picker.vala"
	self->priv->earmarks_active = 0;
#line 42 "../src/number-picker.vala"
	number_picker_set_is_earmark_picker (self, _data5_->for_earmarks);
#line 489 "number-picker.c"
	{
		gint col = 0;
#line 44 "../src/number-picker.vala"
		col = 0;
#line 494 "number-picker.c"
		{
			gboolean _tmp3_ = FALSE;
#line 44 "../src/number-picker.vala"
			_tmp3_ = TRUE;
#line 44 "../src/number-picker.vala"
			while (TRUE) {
#line 501 "number-picker.c"
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 44 "../src/number-picker.vala"
				if (!_tmp3_) {
#line 507 "number-picker.c"
					gint _tmp4_;
#line 44 "../src/number-picker.vala"
					_tmp4_ = col;
#line 44 "../src/number-picker.vala"
					col = _tmp4_ + 1;
#line 513 "number-picker.c"
				}
#line 44 "../src/number-picker.vala"
				_tmp3_ = FALSE;
#line 44 "../src/number-picker.vala"
				_tmp5_ = self->priv->board;
#line 44 "../src/number-picker.vala"
				_tmp6_ = sudoku_board_get_block_cols (_tmp5_);
#line 44 "../src/number-picker.vala"
				_tmp7_ = _tmp6_;
#line 44 "../src/number-picker.vala"
				if (!(col < _tmp7_)) {
#line 44 "../src/number-picker.vala"
					break;
#line 527 "number-picker.c"
				}
				{
					gint row = 0;
#line 46 "../src/number-picker.vala"
					row = 0;
#line 533 "number-picker.c"
					{
						gboolean _tmp8_ = FALSE;
#line 46 "../src/number-picker.vala"
						_tmp8_ = TRUE;
#line 46 "../src/number-picker.vala"
						while (TRUE) {
#line 540 "number-picker.c"
							Block6Data* _data6_;
							SudokuBoard* _tmp10_;
							gint _tmp11_;
							gint _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuBoard* _tmp16_;
							gint _tmp17_;
							gint _tmp18_;
							GtkButton* _tmp19_ = NULL;
							GtkButton* _tmp22_;
							GtkButton* _tmp23_;
							GtkButton* _tmp24_;
							GtkLabel* label = NULL;
							gchar* _tmp25_;
							gchar* _tmp26_;
							GtkLabel* _tmp27_;
							GtkLabel* _tmp28_;
							GtkLabel* _tmp29_;
							gint _tmp30_ = 0;
							GtkLabel* _tmp31_;
							gint _tmp32_ = 0;
							GtkLabel* _tmp33_;
							gint _tmp34_ = 0;
							GtkLabel* _tmp35_;
							gint _tmp36_ = 0;
							GtkLabel* _tmp37_;
							GtkButton* _tmp38_;
							GtkLabel* _tmp39_;
							GtkLabel* _tmp40_;
							GtkButton* _tmp46_;
#line 46 "../src/number-picker.vala"
							_data6_ = g_slice_new0 (Block6Data);
#line 46 "../src/number-picker.vala"
							_data6_->_ref_count_ = 1;
#line 46 "../src/number-picker.vala"
							_data6_->_data5_ = block5_data_ref (_data5_);
#line 46 "../src/number-picker.vala"
							if (!_tmp8_) {
#line 581 "number-picker.c"
								gint _tmp9_;
#line 46 "../src/number-picker.vala"
								_tmp9_ = row;
#line 46 "../src/number-picker.vala"
								row = _tmp9_ + 1;
#line 587 "number-picker.c"
							}
#line 46 "../src/number-picker.vala"
							_tmp8_ = FALSE;
#line 46 "../src/number-picker.vala"
							_tmp10_ = self->priv->board;
#line 46 "../src/number-picker.vala"
							_tmp11_ = sudoku_board_get_block_rows (_tmp10_);
#line 46 "../src/number-picker.vala"
							_tmp12_ = _tmp11_;
#line 46 "../src/number-picker.vala"
							if (!(row < _tmp12_)) {
#line 46 "../src/number-picker.vala"
								block6_data_unref (_data6_);
#line 46 "../src/number-picker.vala"
								_data6_ = NULL;
#line 46 "../src/number-picker.vala"
								break;
#line 605 "number-picker.c"
							}
#line 48 "../src/number-picker.vala"
							_tmp13_ = self->priv->board;
#line 48 "../src/number-picker.vala"
							_tmp14_ = sudoku_board_get_block_rows (_tmp13_);
#line 48 "../src/number-picker.vala"
							_tmp15_ = _tmp14_;
#line 48 "../src/number-picker.vala"
							_tmp16_ = self->priv->board;
#line 48 "../src/number-picker.vala"
							_tmp17_ = sudoku_board_get_block_cols (_tmp16_);
#line 48 "../src/number-picker.vala"
							_tmp18_ = _tmp17_;
#line 48 "../src/number-picker.vala"
							_data6_->n = (col + (((_tmp15_ - 1) - row) * _tmp18_)) + 1;
#line 50 "../src/number-picker.vala"
							if (_data5_->for_earmarks) {
#line 623 "number-picker.c"
								GtkToggleButton* _tmp20_;
#line 50 "../src/number-picker.vala"
								_tmp20_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 50 "../src/number-picker.vala"
								g_object_ref_sink (_tmp20_);
#line 50 "../src/number-picker.vala"
								_g_object_unref0 (_tmp19_);
#line 50 "../src/number-picker.vala"
								_tmp19_ = (GtkButton*) _tmp20_;
#line 633 "number-picker.c"
							} else {
								GtkButton* _tmp21_;
#line 50 "../src/number-picker.vala"
								_tmp21_ = (GtkButton*) gtk_button_new ();
#line 50 "../src/number-picker.vala"
								g_object_ref_sink (_tmp21_);
#line 50 "../src/number-picker.vala"
								_g_object_unref0 (_tmp19_);
#line 50 "../src/number-picker.vala"
								_tmp19_ = _tmp21_;
#line 644 "number-picker.c"
							}
#line 50 "../src/number-picker.vala"
							_tmp22_ = _g_object_ref0 (_tmp19_);
#line 50 "../src/number-picker.vala"
							_data6_->button = _tmp22_;
#line 51 "../src/number-picker.vala"
							_tmp23_ = _data6_->button;
#line 51 "../src/number-picker.vala"
							gtk_widget_set_focus_on_click ((GtkWidget*) _tmp23_, FALSE);
#line 52 "../src/number-picker.vala"
							_tmp24_ = _data6_->button;
#line 52 "../src/number-picker.vala"
							gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp24_, col, row, 1, 1);
#line 54 "../src/number-picker.vala"
							_tmp25_ = g_strdup_printf ("<big>%d</big>", _data6_->n);
#line 54 "../src/number-picker.vala"
							_tmp26_ = _tmp25_;
#line 54 "../src/number-picker.vala"
							_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
#line 54 "../src/number-picker.vala"
							g_object_ref_sink (_tmp27_);
#line 54 "../src/number-picker.vala"
							_tmp28_ = _tmp27_;
#line 54 "../src/number-picker.vala"
							_g_free0 (_tmp26_);
#line 54 "../src/number-picker.vala"
							label = _tmp28_;
#line 55 "../src/number-picker.vala"
							_tmp29_ = label;
#line 55 "../src/number-picker.vala"
							gtk_label_set_use_markup (_tmp29_, TRUE);
#line 56 "../src/number-picker.vala"
							if (_data5_->for_earmarks) {
#line 56 "../src/number-picker.vala"
								_tmp30_ = 0;
#line 680 "number-picker.c"
							} else {
#line 56 "../src/number-picker.vala"
								_tmp30_ = 8;
#line 684 "number-picker.c"
							}
#line 56 "../src/number-picker.vala"
							_tmp31_ = label;
#line 56 "../src/number-picker.vala"
							gtk_widget_set_margin_start ((GtkWidget*) _tmp31_, _tmp30_);
#line 57 "../src/number-picker.vala"
							if (_data5_->for_earmarks) {
#line 57 "../src/number-picker.vala"
								_tmp32_ = 16;
#line 694 "number-picker.c"
							} else {
#line 57 "../src/number-picker.vala"
								_tmp32_ = 8;
#line 698 "number-picker.c"
							}
#line 57 "../src/number-picker.vala"
							_tmp33_ = label;
#line 57 "../src/number-picker.vala"
							gtk_widget_set_margin_end ((GtkWidget*) _tmp33_, _tmp32_);
#line 58 "../src/number-picker.vala"
							if (_data5_->for_earmarks) {
#line 58 "../src/number-picker.vala"
								_tmp34_ = 0;
#line 708 "number-picker.c"
							} else {
#line 58 "../src/number-picker.vala"
								_tmp34_ = 4;
#line 712 "number-picker.c"
							}
#line 58 "../src/number-picker.vala"
							_tmp35_ = label;
#line 58 "../src/number-picker.vala"
							gtk_widget_set_margin_top ((GtkWidget*) _tmp35_, _tmp34_);
#line 59 "../src/number-picker.vala"
							if (_data5_->for_earmarks) {
#line 59 "../src/number-picker.vala"
								_tmp36_ = 8;
#line 722 "number-picker.c"
							} else {
#line 59 "../src/number-picker.vala"
								_tmp36_ = 4;
#line 726 "number-picker.c"
							}
#line 59 "../src/number-picker.vala"
							_tmp37_ = label;
#line 59 "../src/number-picker.vala"
							gtk_widget_set_margin_bottom ((GtkWidget*) _tmp37_, _tmp36_);
#line 60 "../src/number-picker.vala"
							_tmp38_ = _data6_->button;
#line 60 "../src/number-picker.vala"
							_tmp39_ = label;
#line 60 "../src/number-picker.vala"
							gtk_button_set_child (_tmp38_, (GtkWidget*) _tmp39_);
#line 61 "../src/number-picker.vala"
							_tmp40_ = label;
#line 61 "../src/number-picker.vala"
							gtk_widget_show ((GtkWidget*) _tmp40_);
#line 63 "../src/number-picker.vala"
							if (!_data5_->for_earmarks) {
#line 744 "number-picker.c"
								GtkButton* _tmp41_;
#line 64 "../src/number-picker.vala"
								_tmp41_ = _data6_->button;
#line 64 "../src/number-picker.vala"
								g_signal_connect_data (_tmp41_, "clicked", (GCallback) __________lambda4__gtk_button_clicked, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 750 "number-picker.c"
							} else {
								Block7Data* _data7_;
								GtkButton* _tmp42_;
								GtkToggleButton* _tmp43_;
								GtkToggleButton* _tmp44_;
#line 63 "../src/number-picker.vala"
								_data7_ = g_slice_new0 (Block7Data);
#line 63 "../src/number-picker.vala"
								_data7_->_ref_count_ = 1;
#line 63 "../src/number-picker.vala"
								_data7_->_data6_ = block6_data_ref (_data6_);
#line 69 "../src/number-picker.vala"
								_tmp42_ = _data6_->button;
#line 69 "../src/number-picker.vala"
								_tmp43_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 69 "../src/number-picker.vala"
								_data7_->toggle_button = _tmp43_;
#line 70 "../src/number-picker.vala"
								_tmp44_ = _data7_->toggle_button;
#line 70 "../src/number-picker.vala"
								g_signal_connect_data (_tmp44_, "toggled", (GCallback) __________lambda5__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 63 "../src/number-picker.vala"
								block7_data_unref (_data7_);
#line 63 "../src/number-picker.vala"
								_data7_ = NULL;
#line 776 "number-picker.c"
							}
#line 75 "../src/number-picker.vala"
							if (_data6_->n == 5) {
#line 780 "number-picker.c"
								GtkButton* _tmp45_;
#line 76 "../src/number-picker.vala"
								_tmp45_ = _data6_->button;
#line 76 "../src/number-picker.vala"
								g_signal_connect_data ((GtkWidget*) _tmp45_, "realize", (GCallback) __________lambda6__gtk_widget_realize, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 786 "number-picker.c"
							}
#line 79 "../src/number-picker.vala"
							_tmp46_ = _data6_->button;
#line 79 "../src/number-picker.vala"
							gtk_widget_show ((GtkWidget*) _tmp46_);
#line 46 "../src/number-picker.vala"
							_g_object_unref0 (label);
#line 46 "../src/number-picker.vala"
							_g_object_unref0 (_tmp19_);
#line 46 "../src/number-picker.vala"
							block6_data_unref (_data6_);
#line 46 "../src/number-picker.vala"
							_data6_ = NULL;
#line 800 "number-picker.c"
						}
					}
				}
			}
		}
	}
#line 83 "../src/number-picker.vala"
	_tmp47_ = (GtkButton*) gtk_button_new ();
#line 83 "../src/number-picker.vala"
	g_object_ref_sink (_tmp47_);
#line 83 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->clear_button);
#line 83 "../src/number-picker.vala"
	self->priv->clear_button = _tmp47_;
#line 84 "../src/number-picker.vala"
	_tmp48_ = self->priv->clear_button;
#line 84 "../src/number-picker.vala"
	gtk_widget_set_focus_on_click ((GtkWidget*) _tmp48_, FALSE);
#line 85 "../src/number-picker.vala"
	_tmp49_ = self->priv->clear_button;
#line 85 "../src/number-picker.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp49_, 0, 4, 3, 1);
#line 87 "../src/number-picker.vala"
	_tmp50_ = g_strdup_printf ("<big>%s</big>", _ ("Clear"));
#line 87 "../src/number-picker.vala"
	_tmp51_ = _tmp50_;
#line 87 "../src/number-picker.vala"
	_tmp52_ = (GtkLabel*) gtk_label_new (_tmp51_);
#line 87 "../src/number-picker.vala"
	g_object_ref_sink (_tmp52_);
#line 87 "../src/number-picker.vala"
	_tmp53_ = _tmp52_;
#line 87 "../src/number-picker.vala"
	_g_free0 (_tmp51_);
#line 87 "../src/number-picker.vala"
	label = _tmp53_;
#line 88 "../src/number-picker.vala"
	gtk_label_set_use_markup (label, TRUE);
#line 89 "../src/number-picker.vala"
	_tmp54_ = self->priv->clear_button;
#line 89 "../src/number-picker.vala"
	gtk_button_set_child (_tmp54_, (GtkWidget*) label);
#line 90 "../src/number-picker.vala"
	gtk_widget_show ((GtkWidget*) label);
#line 92 "../src/number-picker.vala"
	_tmp55_ = self->priv->clear_button;
#line 92 "../src/number-picker.vala"
	g_signal_connect_data (_tmp55_, "clicked", (GCallback) ___lambda7__gtk_button_clicked, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 106 "../src/number-picker.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 107 "../src/number-picker.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 108 "../src/number-picker.vala"
	gtk_widget_set_margin_top ((GtkWidget*) self, 2);
#line 109 "../src/number-picker.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 2);
#line 110 "../src/number-picker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 2);
#line 111 "../src/number-picker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 2);
#line 112 "../src/number-picker.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 3);
#line 113 "../src/number-picker.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 3);
#line 114 "../src/number-picker.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 37 "../src/number-picker.vala"
	_g_object_unref0 (label);
#line 37 "../src/number-picker.vala"
	block5_data_unref (_data5_);
#line 37 "../src/number-picker.vala"
	_data5_ = NULL;
#line 37 "../src/number-picker.vala"
	return self;
#line 875 "number-picker.c"
}

NumberPicker*
number_picker_new (SudokuGame* game,
                   gboolean for_earmarks)
{
#line 37 "../src/number-picker.vala"
	return number_picker_construct (TYPE_NUMBER_PICKER, game, for_earmarks);
#line 884 "number-picker.c"
}

void
number_picker_set_clear_button_visibility (NumberPicker* self,
                                           gboolean visible)
{
#line 117 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/number-picker.vala"
	if (visible) {
#line 895 "number-picker.c"
		GtkButton* _tmp0_;
#line 120 "../src/number-picker.vala"
		_tmp0_ = self->priv->clear_button;
#line 120 "../src/number-picker.vala"
		gtk_widget_show ((GtkWidget*) _tmp0_);
#line 901 "number-picker.c"
	} else {
		GtkButton* _tmp1_;
#line 122 "../src/number-picker.vala"
		_tmp1_ = self->priv->clear_button;
#line 122 "../src/number-picker.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 908 "number-picker.c"
	}
}

void
number_picker_set_clear_button_enabled (NumberPicker* self,
                                        gboolean enabled)
{
#line 125 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/number-picker.vala"
	if (enabled) {
#line 920 "number-picker.c"
		GtkButton* _tmp0_;
#line 128 "../src/number-picker.vala"
		_tmp0_ = self->priv->clear_button;
#line 128 "../src/number-picker.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 926 "number-picker.c"
	} else {
		GtkButton* _tmp1_;
#line 130 "../src/number-picker.vala"
		_tmp1_ = self->priv->clear_button;
#line 130 "../src/number-picker.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 933 "number-picker.c"
	}
}

void
number_picker_set_earmarks (NumberPicker* self,
                            gint row,
                            gint col)
{
	gboolean _tmp0_;
#line 133 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/number-picker.vala"
	_tmp0_ = self->priv->_is_earmark_picker;
#line 133 "../src/number-picker.vala"
	_vala_return_if_fail (_tmp0_, "is_earmark_picker");
#line 949 "number-picker.c"
	{
		gint i = 0;
#line 136 "../src/number-picker.vala"
		i = 0;
#line 954 "number-picker.c"
		{
			gboolean _tmp1_ = FALSE;
#line 136 "../src/number-picker.vala"
			_tmp1_ = TRUE;
#line 136 "../src/number-picker.vala"
			while (TRUE) {
#line 961 "number-picker.c"
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				SudokuBoard* _tmp6_;
#line 136 "../src/number-picker.vala"
				if (!_tmp1_) {
#line 968 "number-picker.c"
					gint _tmp2_;
#line 136 "../src/number-picker.vala"
					_tmp2_ = i;
#line 136 "../src/number-picker.vala"
					i = _tmp2_ + 1;
#line 974 "number-picker.c"
				}
#line 136 "../src/number-picker.vala"
				_tmp1_ = FALSE;
#line 136 "../src/number-picker.vala"
				_tmp3_ = self->priv->board;
#line 136 "../src/number-picker.vala"
				_tmp4_ = sudoku_board_get_max_val (_tmp3_);
#line 136 "../src/number-picker.vala"
				_tmp5_ = _tmp4_;
#line 136 "../src/number-picker.vala"
				if (!(i < _tmp5_)) {
#line 136 "../src/number-picker.vala"
					break;
#line 988 "number-picker.c"
				}
#line 137 "../src/number-picker.vala"
				_tmp6_ = self->priv->board;
#line 137 "../src/number-picker.vala"
				number_picker_set_earmark (self, row, col, i, sudoku_board_is_earmark_enabled (_tmp6_, row, col, i + 1));
#line 994 "number-picker.c"
			}
		}
	}
}

void
number_picker_set_earmark (NumberPicker* self,
                           gint row,
                           gint col,
                           gint index,
                           gboolean state)
{
	gboolean _tmp0_;
	GtkToggleButton* _tmp1_;
	GtkToggleButton* _tmp2_;
#line 140 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/number-picker.vala"
	_tmp0_ = self->priv->_is_earmark_picker;
#line 140 "../src/number-picker.vala"
	_vala_return_if_fail (_tmp0_, "is_earmark_picker");
#line 143 "../src/number-picker.vala"
	_tmp1_ = number_picker_get_button_for (self, index);
#line 143 "../src/number-picker.vala"
	_tmp2_ = _tmp1_;
#line 143 "../src/number-picker.vala"
	gtk_toggle_button_set_active (_tmp2_, state);
#line 143 "../src/number-picker.vala"
	_g_object_unref0 (_tmp2_);
#line 1024 "number-picker.c"
}

static GtkToggleButton*
number_picker_get_button_for (NumberPicker* self,
                              gint number)
{
	SudokuBoard* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	SudokuBoard* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	SudokuBoard* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkWidget* _tmp9_;
	GtkToggleButton* _tmp10_;
	GtkToggleButton* result;
#line 146 "../src/number-picker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "../src/number-picker.vala"
	_tmp0_ = self->priv->board;
#line 148 "../src/number-picker.vala"
	_tmp1_ = sudoku_board_get_block_cols (_tmp0_);
#line 148 "../src/number-picker.vala"
	_tmp2_ = _tmp1_;
#line 148 "../src/number-picker.vala"
	_tmp3_ = self->priv->board;
#line 148 "../src/number-picker.vala"
	_tmp4_ = sudoku_board_get_block_rows (_tmp3_);
#line 148 "../src/number-picker.vala"
	_tmp5_ = _tmp4_;
#line 148 "../src/number-picker.vala"
	_tmp6_ = self->priv->board;
#line 148 "../src/number-picker.vala"
	_tmp7_ = sudoku_board_get_block_rows (_tmp6_);
#line 148 "../src/number-picker.vala"
	_tmp8_ = _tmp7_;
#line 148 "../src/number-picker.vala"
	_tmp9_ = gtk_grid_get_child_at ((GtkGrid*) self, number % _tmp2_, (_tmp5_ - 1) - (number / _tmp8_));
#line 148 "../src/number-picker.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 148 "../src/number-picker.vala"
	result = _tmp10_;
#line 148 "../src/number-picker.vala"
	return result;
#line 1071 "number-picker.c"
}

gboolean
number_picker_get_is_earmark_picker (NumberPicker* self)
{
	gboolean result;
#line 35 "../src/number-picker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../src/number-picker.vala"
	result = self->priv->_is_earmark_picker;
#line 35 "../src/number-picker.vala"
	return result;
#line 1084 "number-picker.c"
}

static void
number_picker_set_is_earmark_picker (NumberPicker* self,
                                     gboolean value)
{
	gboolean old_value;
#line 35 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/number-picker.vala"
	old_value = number_picker_get_is_earmark_picker (self);
#line 35 "../src/number-picker.vala"
	if (old_value != value) {
#line 35 "../src/number-picker.vala"
		self->priv->_is_earmark_picker = value;
#line 35 "../src/number-picker.vala"
		g_object_notify_by_pspec ((GObject *) self, number_picker_properties[NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY]);
#line 1102 "number-picker.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_BOOLEAN) (gpointer data1, gint arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../src/number-picker.vala"
	g_return_if_fail (n_param_values == 3);
#line 24 "../src/number-picker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/number-picker.vala"
		data1 = closure->data;
#line 24 "../src/number-picker.vala"
		data2 = param_values->data[0].v_pointer;
#line 1128 "number-picker.c"
	} else {
#line 24 "../src/number-picker.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/number-picker.vala"
		data2 = closure->data;
#line 1134 "number-picker.c"
	}
#line 24 "../src/number-picker.vala"
	callback = (GMarshalFunc_VOID__INT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/number-picker.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 1140 "number-picker.c"
}

static void
number_picker_class_init (NumberPickerClass * klass,
                          gpointer klass_data)
{
#line 24 "../src/number-picker.vala"
	number_picker_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/number-picker.vala"
	g_type_class_adjust_private_offset (klass, &NumberPicker_private_offset);
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_number_picker_get_property;
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_number_picker_set_property;
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (klass)->finalize = number_picker_finalize;
#line 24 "../src/number-picker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY, number_picker_properties[NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY] = g_param_spec_boolean ("is-earmark-picker", "is-earmark-picker", "is-earmark-picker", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/number-picker.vala"
	number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL] = g_signal_new ("number-picked", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 24 "../src/number-picker.vala"
	number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL] = g_signal_new ("earmark-state-changed", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_BOOLEAN);
#line 1163 "number-picker.c"
}

static void
number_picker_instance_init (NumberPicker * self,
                             gpointer klass)
{
#line 24 "../src/number-picker.vala"
	self->priv = number_picker_get_instance_private (self);
#line 1172 "number-picker.c"
}

static void
number_picker_finalize (GObject * obj)
{
	NumberPicker * self;
#line 24 "../src/number-picker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER_PICKER, NumberPicker);
#line 26 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->board);
#line 31 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->clear_button);
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (number_picker_parent_class)->finalize (obj);
#line 1187 "number-picker.c"
}

static GType
number_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NumberPickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NumberPicker), 0, (GInstanceInitFunc) number_picker_instance_init, NULL };
	GType number_picker_type_id;
	number_picker_type_id = g_type_register_static (gtk_grid_get_type (), "NumberPicker", &g_define_type_info, 0);
	NumberPicker_private_offset = g_type_add_instance_private (number_picker_type_id, sizeof (NumberPickerPrivate));
	return number_picker_type_id;
}

GType
number_picker_get_type (void)
{
	static volatile gsize number_picker_type_id__once = 0;
	if (g_once_init_enter (&number_picker_type_id__once)) {
		GType number_picker_type_id;
		number_picker_type_id = number_picker_get_type_once ();
		g_once_init_leave (&number_picker_type_id__once, number_picker_type_id);
	}
	return number_picker_type_id__once;
}

static void
_vala_number_picker_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	NumberPicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER_PICKER, NumberPicker);
#line 24 "../src/number-picker.vala"
	switch (property_id) {
#line 24 "../src/number-picker.vala"
		case NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY:
#line 24 "../src/number-picker.vala"
		g_value_set_boolean (value, number_picker_get_is_earmark_picker (self));
#line 24 "../src/number-picker.vala"
		break;
#line 1228 "number-picker.c"
		default:
#line 24 "../src/number-picker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/number-picker.vala"
		break;
#line 1234 "number-picker.c"
	}
}

static void
_vala_number_picker_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	NumberPicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER_PICKER, NumberPicker);
#line 24 "../src/number-picker.vala"
	switch (property_id) {
#line 24 "../src/number-picker.vala"
		case NUMBER_PICKER_IS_EARMARK_PICKER_PROPERTY:
#line 24 "../src/number-picker.vala"
		number_picker_set_is_earmark_picker (self, g_value_get_boolean (value));
#line 24 "../src/number-picker.vala"
		break;
#line 1254 "number-picker.c"
		default:
#line 24 "../src/number-picker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/number-picker.vala"
		break;
#line 1260 "number-picker.c"
	}
}

