/* print-dialog.c generated by valac 0.56.17, the Vala compiler
 * generated from print-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <gdk/gdk.h>

#define PRINT_DIALOG_DIFFICULTY_KEY_NAME "print-multiple-sudoku-difficulty"
#define PRINT_DIALOG_MAX_PUZZLES_PER_PAGE 15
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PRINT_DIALOG (print_dialog_get_type ())
#define PRINT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PRINT_DIALOG, PrintDialog))
#define PRINT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PRINT_DIALOG, PrintDialogClass))
#define IS_PRINT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PRINT_DIALOG))
#define IS_PRINT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PRINT_DIALOG))
#define PRINT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PRINT_DIALOG, PrintDialogClass))

typedef struct _PrintDialog PrintDialog;
typedef struct _PrintDialogClass PrintDialogClass;
typedef struct _PrintDialogPrivate PrintDialogPrivate;
enum  {
	PRINT_DIALOG_0_PROPERTY,
	PRINT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* print_dialog_properties[PRINT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;

#define TYPE_SUDOKU_PRINTER (sudoku_printer_get_type ())
#define SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinter))
#define SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))
#define IS_SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PRINTER))
#define IS_SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PRINTER))
#define SUDOKU_PRINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))

typedef struct _SudokuPrinter SudokuPrinter;
typedef struct _SudokuPrinterClass SudokuPrinterClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PrintDialog {
	AdwWindow parent_instance;
	PrintDialogPrivate * priv;
};

struct _PrintDialogClass {
	AdwWindowClass parent_class;
};

struct _PrintDialogPrivate {
	SudokuSaver* saver;
	GSettings* settings;
	GtkButton* print_button;
	AdwPreferencesGroup* options_group;
	AdwSpinRow* n_puzzles;
	AdwSpinRow* n_puzzles_per_page;
	AdwComboRow* difficulty;
	GCancellable* cancellable;
};

struct _Block8Data {
	int _ref_count_;
	PrintDialog* self;
	GtkAdjustment* total;
	GtkAdjustment* per_page;
};

struct _Block9Data {
	int _ref_count_;
	PrintDialog* self;
	gint npuzzles_per_page;
};

static gint PrintDialog_private_offset;
static gpointer print_dialog_parent_class = NULL;

VALA_EXTERN GType print_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PrintDialog, g_object_unref)
VALA_EXTERN PrintDialog* print_dialog_new (SudokuSaver* saver,
                               GtkWindow* window);
VALA_EXTERN PrintDialog* print_dialog_construct (GType object_type,
                                     SudokuSaver* saver,
                                     GtkWindow* window);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda27_ (Block8Data* _data8_);
static void ___lambda27__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
static void __lambda28_ (Block8Data* _data8_);
static void ___lambda28__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
static void __lambda29_ (PrintDialog* self);
VALA_EXTERN void print_dialog_print (PrintDialog* self);
static void ___lambda29__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda30_ (Block9Data* _data9_,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN GType sudoku_printer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuPrinter, g_object_unref)
VALA_EXTERN SudokuPrinter* sudoku_printer_new (GeeList* boards,
                                   gint sudokus_per_page,
                                   GtkWindow* window);
VALA_EXTERN SudokuPrinter* sudoku_printer_construct (GType object_type,
                                         GeeList* boards,
                                         gint sudokus_per_page,
                                         GtkWindow* window);
VALA_EXTERN GtkPrintOperationResult sudoku_printer_print_sudoku (SudokuPrinter* self);
static void ___lambda30__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gboolean _print_dialog___lambda31_ (GtkWidget* _self_);
static gboolean __print_dialog___lambda31__gtk_shortcut_func (GtkWidget* widget,
                                                       GVariant* args,
                                                       gpointer self);
static void print_dialog_finalize (GObject * obj);
static GType print_dialog_get_type_once (void);

static inline gpointer
print_dialog_get_instance_private (PrintDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PrintDialog_private_offset);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 41 "../src/print-dialog.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 41 "../src/print-dialog.vala"
	return _data8_;
#line 182 "print-dialog.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 41 "../src/print-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 192 "print-dialog.c"
		PrintDialog* self;
#line 41 "../src/print-dialog.vala"
		self = _data8_->self;
#line 41 "../src/print-dialog.vala"
		_g_object_unref0 (_data8_->per_page);
#line 41 "../src/print-dialog.vala"
		_g_object_unref0 (_data8_->total);
#line 41 "../src/print-dialog.vala"
		_g_object_unref0 (self);
#line 41 "../src/print-dialog.vala"
		g_slice_free (Block8Data, _data8_);
#line 204 "print-dialog.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/print-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 213 "print-dialog.c"
}

static void
__lambda27_ (Block8Data* _data8_)
{
	PrintDialog* self;
	gint total_value = 0;
	GSettings* _tmp0_;
	gint max_per_page = 0;
	gint per_page_value = 0;
#line 64 "../src/print-dialog.vala"
	self = _data8_->self;
#line 65 "../src/print-dialog.vala"
	total_value = (gint) gtk_adjustment_get_value (_data8_->total);
#line 66 "../src/print-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 66 "../src/print-dialog.vala"
	g_settings_set_int (_tmp0_, "print-multiple-sudokus-to-print", total_value);
#line 68 "../src/print-dialog.vala"
	max_per_page = MIN (PRINT_DIALOG_MAX_PUZZLES_PER_PAGE, total_value);
#line 69 "../src/print-dialog.vala"
	per_page_value = (gint) gtk_adjustment_get_value (_data8_->per_page);
#line 70 "../src/print-dialog.vala"
	per_page_value = MIN (per_page_value, max_per_page);
#line 71 "../src/print-dialog.vala"
	gtk_adjustment_set_upper (_data8_->per_page, (gdouble) max_per_page);
#line 72 "../src/print-dialog.vala"
	gtk_adjustment_set_value (_data8_->per_page, (gdouble) per_page_value);
#line 242 "print-dialog.c"
}

static void
___lambda27__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
#line 64 "../src/print-dialog.vala"
	__lambda27_ (self);
#line 251 "print-dialog.c"
}

static void
__lambda28_ (Block8Data* _data8_)
{
	PrintDialog* self;
	gint per_page_value = 0;
	GSettings* _tmp0_;
#line 74 "../src/print-dialog.vala"
	self = _data8_->self;
#line 75 "../src/print-dialog.vala"
	per_page_value = (gint) gtk_adjustment_get_value (_data8_->per_page);
#line 76 "../src/print-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 76 "../src/print-dialog.vala"
	g_settings_set_int (_tmp0_, "print-multiple-sudokus-to-print-per-page", per_page_value);
#line 268 "print-dialog.c"
}

static void
___lambda28__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
#line 74 "../src/print-dialog.vala"
	__lambda28_ (self);
#line 277 "print-dialog.c"
}

static void
__lambda29_ (PrintDialog* self)
{
#line 80 "../src/print-dialog.vala"
	print_dialog_print (self);
#line 285 "print-dialog.c"
}

static void
___lambda29__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 79 "../src/print-dialog.vala"
	__lambda29_ ((PrintDialog*) self);
#line 294 "print-dialog.c"
}

PrintDialog*
print_dialog_construct (GType object_type,
                        SudokuSaver* saver,
                        GtkWindow* window)
{
	PrintDialog * self = NULL;
	Block8Data* _data8_;
	SudokuSaver* _tmp0_;
	GSettings* _tmp1_;
	DifficultyCategory saved_difficulty = 0;
	GSettings* _tmp2_;
	AdwComboRow* _tmp3_;
	gint initial_total_value = 0;
	GSettings* _tmp4_;
	gint initial_per_page_value = 0;
	GSettings* _tmp5_;
	AdwSpinRow* _tmp6_;
	GtkAdjustment* _tmp7_;
	GtkAdjustment* _tmp8_;
	AdwSpinRow* _tmp9_;
	GtkAdjustment* _tmp10_;
	GtkAdjustment* _tmp11_;
	gint initial_max_per_page = 0;
	GtkButton* _tmp12_;
#line 41 "../src/print-dialog.vala"
	g_return_val_if_fail (saver != NULL, NULL);
#line 41 "../src/print-dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 41 "../src/print-dialog.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 41 "../src/print-dialog.vala"
	_data8_->_ref_count_ = 1;
#line 43 "../src/print-dialog.vala"
	self = (PrintDialog*) g_object_new (object_type, NULL);
#line 43 "../src/print-dialog.vala"
	_data8_->self = g_object_ref (self);
#line 45 "../src/print-dialog.vala"
	_tmp0_ = _g_object_ref0 (saver);
#line 45 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->saver);
#line 45 "../src/print-dialog.vala"
	self->priv->saver = _tmp0_;
#line 46 "../src/print-dialog.vala"
	_tmp1_ = g_settings_new ("org.gnome.Sudoku");
#line 46 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 46 "../src/print-dialog.vala"
	self->priv->settings = _tmp1_;
#line 48 "../src/print-dialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, window);
#line 50 "../src/print-dialog.vala"
	_tmp2_ = self->priv->settings;
#line 50 "../src/print-dialog.vala"
	saved_difficulty = (DifficultyCategory) g_settings_get_enum (_tmp2_, PRINT_DIALOG_DIFFICULTY_KEY_NAME);
#line 51 "../src/print-dialog.vala"
	_tmp3_ = self->priv->difficulty;
#line 51 "../src/print-dialog.vala"
	adw_combo_row_set_selected (_tmp3_, (guint) (((gint) saved_difficulty) - 1));
#line 53 "../src/print-dialog.vala"
	_tmp4_ = self->priv->settings;
#line 53 "../src/print-dialog.vala"
	initial_total_value = g_settings_get_int (_tmp4_, "print-multiple-sudokus-to-print");
#line 54 "../src/print-dialog.vala"
	_tmp5_ = self->priv->settings;
#line 54 "../src/print-dialog.vala"
	initial_per_page_value = g_settings_get_int (_tmp5_, "print-multiple-sudokus-to-print-per-page");
#line 56 "../src/print-dialog.vala"
	_tmp6_ = self->priv->n_puzzles;
#line 56 "../src/print-dialog.vala"
	_tmp7_ = adw_spin_row_get_adjustment (_tmp6_);
#line 56 "../src/print-dialog.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 56 "../src/print-dialog.vala"
	_data8_->total = _tmp8_;
#line 57 "../src/print-dialog.vala"
	_tmp9_ = self->priv->n_puzzles_per_page;
#line 57 "../src/print-dialog.vala"
	_tmp10_ = adw_spin_row_get_adjustment (_tmp9_);
#line 57 "../src/print-dialog.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 57 "../src/print-dialog.vala"
	_data8_->per_page = _tmp11_;
#line 59 "../src/print-dialog.vala"
	gtk_adjustment_set_value (_data8_->total, (gdouble) initial_total_value);
#line 60 "../src/print-dialog.vala"
	initial_max_per_page = MIN (PRINT_DIALOG_MAX_PUZZLES_PER_PAGE, initial_total_value);
#line 61 "../src/print-dialog.vala"
	gtk_adjustment_set_value (_data8_->per_page, (gdouble) MIN (initial_max_per_page, initial_per_page_value));
#line 62 "../src/print-dialog.vala"
	gtk_adjustment_set_upper (_data8_->per_page, (gdouble) initial_max_per_page);
#line 64 "../src/print-dialog.vala"
	g_signal_connect_data (_data8_->total, "value-changed", (GCallback) ___lambda27__gtk_adjustment_value_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 74 "../src/print-dialog.vala"
	g_signal_connect_data (_data8_->per_page, "value-changed", (GCallback) ___lambda28__gtk_adjustment_value_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 79 "../src/print-dialog.vala"
	_tmp12_ = self->priv->print_button;
#line 79 "../src/print-dialog.vala"
	g_signal_connect_object (_tmp12_, "clicked", (GCallback) ___lambda29__gtk_button_clicked, self, 0);
#line 41 "../src/print-dialog.vala"
	block8_data_unref (_data8_);
#line 41 "../src/print-dialog.vala"
	_data8_ = NULL;
#line 41 "../src/print-dialog.vala"
	return self;
#line 401 "print-dialog.c"
}

PrintDialog*
print_dialog_new (SudokuSaver* saver,
                  GtkWindow* window)
{
#line 41 "../src/print-dialog.vala"
	return print_dialog_construct (TYPE_PRINT_DIALOG, saver, window);
#line 410 "print-dialog.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 91 "../src/print-dialog.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 91 "../src/print-dialog.vala"
	return _data9_;
#line 420 "print-dialog.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 91 "../src/print-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 430 "print-dialog.c"
		PrintDialog* self;
#line 91 "../src/print-dialog.vala"
		self = _data9_->self;
#line 91 "../src/print-dialog.vala"
		_g_object_unref0 (self);
#line 91 "../src/print-dialog.vala"
		g_slice_free (Block9Data, _data9_);
#line 438 "print-dialog.c"
	}
}

static void
__lambda30_ (Block9Data* _data9_,
             GObject* obj,
             GAsyncResult* res)
{
	PrintDialog* self;
	GError* _inner_error0_ = NULL;
#line 103 "../src/print-dialog.vala"
	self = _data9_->self;
#line 103 "../src/print-dialog.vala"
	g_return_if_fail (res != NULL);
#line 453 "print-dialog.c"
	{
		GeeList* boards = NULL;
		GeeList* _tmp0_;
		SudokuPrinter* printer = NULL;
		SudokuPrinter* _tmp1_;
		SudokuPrinter* _tmp2_;
#line 106 "../src/print-dialog.vala"
		_tmp0_ = sudoku_generator_generate_boards_finish (res, &_inner_error0_);
#line 106 "../src/print-dialog.vala"
		boards = _tmp0_;
#line 106 "../src/print-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/print-dialog.vala"
			if (_inner_error0_->domain == G_THREAD_ERROR) {
#line 468 "print-dialog.c"
				goto __catch0_g_thread_error;
			}
#line 106 "../src/print-dialog.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 473 "print-dialog.c"
				goto __catch0_g_io_error;
			}
#line 106 "../src/print-dialog.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../src/print-dialog.vala"
			g_clear_error (&_inner_error0_);
#line 106 "../src/print-dialog.vala"
			return;
#line 482 "print-dialog.c"
		}
#line 108 "../src/print-dialog.vala"
		_tmp1_ = sudoku_printer_new (boards, _data9_->npuzzles_per_page, (GtkWindow*) self);
#line 108 "../src/print-dialog.vala"
		printer = _tmp1_;
#line 109 "../src/print-dialog.vala"
		_tmp2_ = printer;
#line 109 "../src/print-dialog.vala"
		if (sudoku_printer_print_sudoku (_tmp2_) == GTK_PRINT_OPERATION_RESULT_APPLY) {
#line 492 "print-dialog.c"
			{
				GeeList* _board_list = NULL;
				gint _board_size = 0;
				GeeList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _board_index = 0;
#line 111 "../src/print-dialog.vala"
				_board_list = boards;
#line 111 "../src/print-dialog.vala"
				_tmp3_ = _board_list;
#line 111 "../src/print-dialog.vala"
				_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 111 "../src/print-dialog.vala"
				_tmp5_ = _tmp4_;
#line 111 "../src/print-dialog.vala"
				_board_size = _tmp5_;
#line 111 "../src/print-dialog.vala"
				_board_index = -1;
#line 111 "../src/print-dialog.vala"
				while (TRUE) {
#line 514 "print-dialog.c"
					gint _tmp6_;
					gint _tmp7_;
					SudokuBoard* board = NULL;
					GeeList* _tmp8_;
					gpointer _tmp9_;
					SudokuSaver* _tmp10_;
					SudokuBoard* _tmp11_;
					SudokuGame* _tmp12_;
					SudokuGame* _tmp13_;
#line 111 "../src/print-dialog.vala"
					_board_index = _board_index + 1;
#line 111 "../src/print-dialog.vala"
					_tmp6_ = _board_index;
#line 111 "../src/print-dialog.vala"
					_tmp7_ = _board_size;
#line 111 "../src/print-dialog.vala"
					if (!(_tmp6_ < _tmp7_)) {
#line 111 "../src/print-dialog.vala"
						break;
#line 534 "print-dialog.c"
					}
#line 111 "../src/print-dialog.vala"
					_tmp8_ = _board_list;
#line 111 "../src/print-dialog.vala"
					_tmp9_ = gee_list_get (_tmp8_, _board_index);
#line 111 "../src/print-dialog.vala"
					board = (SudokuBoard*) _tmp9_;
#line 112 "../src/print-dialog.vala"
					_tmp10_ = self->priv->saver;
#line 112 "../src/print-dialog.vala"
					_tmp11_ = board;
#line 112 "../src/print-dialog.vala"
					_tmp12_ = sudoku_game_new (_tmp11_);
#line 112 "../src/print-dialog.vala"
					_tmp13_ = _tmp12_;
#line 112 "../src/print-dialog.vala"
					sudoku_saver_add_game_to_finished (_tmp10_, _tmp13_, FALSE);
#line 112 "../src/print-dialog.vala"
					_g_object_unref0 (_tmp13_);
#line 111 "../src/print-dialog.vala"
					_g_object_unref0 (board);
#line 556 "print-dialog.c"
				}
			}
		}
#line 104 "../src/print-dialog.vala"
		_g_object_unref0 (printer);
#line 104 "../src/print-dialog.vala"
		_g_object_unref0 (boards);
#line 564 "print-dialog.c"
	}
	goto __finally0;
	__catch0_g_thread_error:
	{
		GError* e = NULL;
		const gchar* _tmp14_;
#line 104 "../src/print-dialog.vala"
		e = _inner_error0_;
#line 104 "../src/print-dialog.vala"
		_inner_error0_ = NULL;
#line 117 "../src/print-dialog.vala"
		_tmp14_ = e->message;
#line 117 "../src/print-dialog.vala"
		g_error ("print-dialog.vala:117: Thread error: %s\n", _tmp14_);
#line 104 "../src/print-dialog.vala"
		_g_error_free0 (e);
#line 581 "print-dialog.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
#line 104 "../src/print-dialog.vala"
		e = _inner_error0_;
#line 104 "../src/print-dialog.vala"
		_inner_error0_ = NULL;
#line 121 "../src/print-dialog.vala"
		_tmp15_ = e;
#line 121 "../src/print-dialog.vala"
		if (!g_error_matches (_tmp15_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 596 "print-dialog.c"
			GError* _tmp16_;
			const gchar* _tmp17_;
#line 122 "../src/print-dialog.vala"
			_tmp16_ = e;
#line 122 "../src/print-dialog.vala"
			_tmp17_ = _tmp16_->message;
#line 122 "../src/print-dialog.vala"
			g_warning ("print-dialog.vala:122: Error: %s\n", _tmp17_);
#line 605 "print-dialog.c"
		}
#line 104 "../src/print-dialog.vala"
		_g_error_free0 (e);
#line 609 "print-dialog.c"
	}
	__finally0:
#line 104 "../src/print-dialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../src/print-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../src/print-dialog.vala"
		g_clear_error (&_inner_error0_);
#line 104 "../src/print-dialog.vala"
		return;
#line 620 "print-dialog.c"
	}
#line 125 "../src/print-dialog.vala"
	gtk_window_destroy ((GtkWindow*) self);
#line 624 "print-dialog.c"
}

static void
___lambda30__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 103 "../src/print-dialog.vala"
	__lambda30_ (self, source_object, res);
#line 103 "../src/print-dialog.vala"
	block9_data_unref (self);
#line 636 "print-dialog.c"
}

void
print_dialog_print (PrintDialog* self)
{
	Block9Data* _data9_;
	gint npuzzles = 0;
	AdwSpinRow* _tmp0_;
	GtkAdjustment* _tmp1_;
	AdwSpinRow* _tmp2_;
	GtkAdjustment* _tmp3_;
	DifficultyCategory level = 0;
	AdwComboRow* _tmp4_;
	GSettings* _tmp5_;
	GtkButton* _tmp6_;
	AdwPreferencesGroup* _tmp7_;
	GCancellable* _tmp8_;
	GCancellable* _tmp9_;
#line 91 "../src/print-dialog.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/print-dialog.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 91 "../src/print-dialog.vala"
	_data9_->_ref_count_ = 1;
#line 91 "../src/print-dialog.vala"
	_data9_->self = g_object_ref (self);
#line 93 "../src/print-dialog.vala"
	_tmp0_ = self->priv->n_puzzles;
#line 93 "../src/print-dialog.vala"
	_tmp1_ = adw_spin_row_get_adjustment (_tmp0_);
#line 93 "../src/print-dialog.vala"
	npuzzles = (gint) gtk_adjustment_get_value (_tmp1_);
#line 94 "../src/print-dialog.vala"
	_tmp2_ = self->priv->n_puzzles_per_page;
#line 94 "../src/print-dialog.vala"
	_tmp3_ = adw_spin_row_get_adjustment (_tmp2_);
#line 94 "../src/print-dialog.vala"
	_data9_->npuzzles_per_page = (gint) gtk_adjustment_get_value (_tmp3_);
#line 95 "../src/print-dialog.vala"
	_tmp4_ = self->priv->difficulty;
#line 95 "../src/print-dialog.vala"
	level = ((DifficultyCategory) adw_combo_row_get_selected (_tmp4_)) + 1;
#line 97 "../src/print-dialog.vala"
	_tmp5_ = self->priv->settings;
#line 97 "../src/print-dialog.vala"
	g_settings_set_enum (_tmp5_, PRINT_DIALOG_DIFFICULTY_KEY_NAME, (gint) level);
#line 99 "../src/print-dialog.vala"
	_tmp6_ = self->priv->print_button;
#line 99 "../src/print-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 100 "../src/print-dialog.vala"
	_tmp7_ = self->priv->options_group;
#line 100 "../src/print-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 102 "../src/print-dialog.vala"
	_tmp8_ = g_cancellable_new ();
#line 102 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 102 "../src/print-dialog.vala"
	self->priv->cancellable = _tmp8_;
#line 103 "../src/print-dialog.vala"
	_tmp9_ = self->priv->cancellable;
#line 103 "../src/print-dialog.vala"
	sudoku_generator_generate_boards_async (npuzzles, level, _tmp9_, ___lambda30__gasync_ready_callback, block9_data_ref (_data9_));
#line 91 "../src/print-dialog.vala"
	block9_data_unref (_data9_);
#line 91 "../src/print-dialog.vala"
	_data9_ = NULL;
#line 705 "print-dialog.c"
}

static gboolean
_print_dialog___lambda31_ (GtkWidget* _self_)
{
	gboolean result;
#line 85 "../src/print-dialog.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 86 "../src/print-dialog.vala"
	gtk_window_destroy ((GtkWindow*) G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_PRINT_DIALOG, PrintDialog));
#line 87 "../src/print-dialog.vala"
	result = GDK_EVENT_STOP;
#line 87 "../src/print-dialog.vala"
	return result;
#line 720 "print-dialog.c"
}

static gboolean
__print_dialog___lambda31__gtk_shortcut_func (GtkWidget* widget,
                                              GVariant* args,
                                              gpointer self)
{
	gboolean result;
	result = _print_dialog___lambda31_ (widget);
#line 85 "../src/print-dialog.vala"
	return result;
#line 732 "print-dialog.c"
}

static void
print_dialog_class_init (PrintDialogClass * klass,
                         gpointer klass_data)
{
#line 25 "../src/print-dialog.vala"
	print_dialog_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/print-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PrintDialog_private_offset);
#line 25 "../src/print-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = print_dialog_finalize;
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/print-dialog.ui");
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "print_button", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, print_button));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "options_group", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, options_group));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "n_puzzles", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, n_puzzles));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "n_puzzles_per_page", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, n_puzzles_per_page));
#line 25 "../src/print-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "difficulty", FALSE, PrintDialog_private_offset + G_STRUCT_OFFSET (PrintDialogPrivate, difficulty));
#line 85 "../src/print-dialog.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Escape, 0, __print_dialog___lambda31__gtk_shortcut_func, NULL, NULL, NULL);
#line 759 "print-dialog.c"
}

static void
print_dialog_instance_init (PrintDialog * self,
                            gpointer klass)
{
#line 25 "../src/print-dialog.vala"
	self->priv = print_dialog_get_instance_private (self);
#line 25 "../src/print-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 770 "print-dialog.c"
}

static void
print_dialog_finalize (GObject * obj)
{
	PrintDialog * self;
#line 25 "../src/print-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PRINT_DIALOG, PrintDialog);
#line 27 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->saver);
#line 28 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 36 "../src/print-dialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 25 "../src/print-dialog.vala"
	G_OBJECT_CLASS (print_dialog_parent_class)->finalize (obj);
#line 787 "print-dialog.c"
}

static GType
print_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) print_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintDialog), 0, (GInstanceInitFunc) print_dialog_instance_init, NULL };
	GType print_dialog_type_id;
	print_dialog_type_id = g_type_register_static (adw_window_get_type (), "PrintDialog", &g_define_type_info, 0);
	PrintDialog_private_offset = g_type_add_instance_private (print_dialog_type_id, sizeof (PrintDialogPrivate));
	return print_dialog_type_id;
}

GType
print_dialog_get_type (void)
{
	static volatile gsize print_dialog_type_id__once = 0;
	if (g_once_init_enter (&print_dialog_type_id__once)) {
		GType print_dialog_type_id;
		print_dialog_type_id = print_dialog_get_type_once ();
		g_once_init_leave (&print_dialog_type_id__once, print_dialog_type_id);
	}
	return print_dialog_type_id__once;
}

