/* sudoku-cell.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#define SUDOKU_CELL_size_ratio 2
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_POPOVER_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_PAUSED_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL,
	SUDOKU_CELL_NUM_SIGNALS
};
static guint sudoku_cell_signals[SUDOKU_CELL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerKey* key_controller;
	GtkPopover* _popover;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	gboolean _paused;
	gboolean control_key_pressed;
};

struct _Block10Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* earmark_picker;
};

struct _Block11Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* number_picker;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
static void sudoku_cell_set_fixed_css (SudokuCell* self,
                                gboolean enabled);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* gesture,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* gesture,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
VALA_EXTERN GtkPopover* sudoku_cell_get_popover (SudokuCell* self);
static void __lambda10_ (SudokuCell* self);
static void ___lambda10__gtk_popover_closed (GtkPopover* _sender,
                                      gpointer self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
static void sudoku_cell_get_visible_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_earmark (SudokuCell* self,
                                 gint num);
static void sudoku_cell_get_visible_earmark (SudokuCell* self,
                                      gint num);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN gboolean number_picker_get_is_earmark_picker (NumberPicker* self);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
static void sudoku_cell_show_number_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
VALA_EXTERN void sudoku_cell_initialize_earmarks (SudokuCell* self,
                                      gboolean show_possibilities,
                                      gboolean force);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN NumberPicker* number_picker_new (SudokuGame* game,
                                 gboolean for_earmarks);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuGame* game,
                                       gboolean for_earmarks);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
static void __lambda9_ (Block10Data* _data10_,
                 gint number,
                 gboolean state);
static void ___lambda9__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda8_ (Block11Data* _data11_,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN void sudoku_cell_check_value_warnings (SudokuCell* self,
                                       gboolean show_extra_warnings);
VALA_EXTERN void sudoku_cell_check_earmarks_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
static void sudoku_cell_real_dispose (GObject* base);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel** label,
                                gint font_size);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_background (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_paused (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_paused (SudokuCell* self,
                             gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static void
sudoku_cell_set_fixed_css (SudokuCell* self,
                           gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 86 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_is_fixed (self);
#line 88 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 88 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 90 "../src/sudoku-cell.vala"
		if (enabled) {
#line 91 "../src/sudoku-cell.vala"
			gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
#line 325 "sudoku-cell.c"
		} else {
#line 93 "../src/sudoku-cell.vala"
			gtk_widget_remove_css_class ((GtkWidget*) self, "fixed");
#line 329 "sudoku-cell.c"
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 161 "../src/sudoku-cell.vala"
	return self ? g_object_ref (self) : NULL;
#line 339 "sudoku-cell.c"
}

void
sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                   gint val,
                                   gboolean enabled)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	GtkLabel* earmark = NULL;
	GtkLabel** _tmp3_;
	gint _tmp3__length1;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 156 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 158 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 158 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 158 "../src/sudoku-cell.vala"
	if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, val)) {
#line 159 "../src/sudoku-cell.vala"
		return;
#line 368 "sudoku-cell.c"
	}
#line 161 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->earmark_labels;
#line 161 "../src/sudoku-cell.vala"
	_tmp3__length1 = self->priv->earmark_labels_length1;
#line 161 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_[val - 1];
#line 161 "../src/sudoku-cell.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 161 "../src/sudoku-cell.vala"
	earmark = _tmp5_;
#line 162 "../src/sudoku-cell.vala"
	if (enabled) {
#line 382 "sudoku-cell.c"
		GtkLabel* _tmp7_;
#line 162 "../src/sudoku-cell.vala"
		_tmp7_ = earmark;
#line 162 "../src/sudoku-cell.vala"
		_tmp6_ = !gtk_widget_has_css_class ((GtkWidget*) _tmp7_, "error");
#line 388 "sudoku-cell.c"
	} else {
#line 162 "../src/sudoku-cell.vala"
		_tmp6_ = FALSE;
#line 392 "sudoku-cell.c"
	}
#line 162 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 396 "sudoku-cell.c"
		GtkLabel* _tmp8_;
#line 163 "../src/sudoku-cell.vala"
		_tmp8_ = earmark;
#line 163 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "highlight-label");
#line 402 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp9_;
#line 165 "../src/sudoku-cell.vala"
		_tmp9_ = earmark;
#line 165 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp9_, "highlight-label");
#line 409 "sudoku-cell.c"
	}
#line 156 "../src/sudoku-cell.vala"
	_g_object_unref0 (earmark);
#line 413 "sudoku-cell.c"
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 195 "../src/sudoku-cell.vala"
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
#line 424 "sudoku-cell.c"
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 196 "../src/sudoku-cell.vala"
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
#line 436 "sudoku-cell.c"
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
#line 197 "../src/sudoku-cell.vala"
	return result;
#line 450 "sudoku-cell.c"
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
#line 198 "../src/sudoku-cell.vala"
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
#line 462 "sudoku-cell.c"
}

static void
__lambda10_ (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 223 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 223 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 223 "../src/sudoku-cell.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 223 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 223 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 482 "sudoku-cell.c"
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
#line 225 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_popover (self);
#line 225 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 225 "../src/sudoku-cell.vala"
		gtk_popover_set_child (_tmp5_, NULL);
#line 226 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 493 "sudoku-cell.c"
	}
}

static void
___lambda10__gtk_popover_closed (GtkPopover* _sender,
                                 gpointer self)
{
#line 222 "../src/sudoku-cell.vala"
	__lambda10_ ((SudokuCell*) self);
#line 503 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame** game)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkGestureClick* _tmp9_;
	GtkGestureClick* _tmp10_;
	GtkEventController* _tmp11_;
	GtkGestureLongPress* _tmp12_;
	GtkEventController* _tmp13_;
	GtkEventControllerKey* _tmp14_;
	GtkEventController* _tmp15_;
	GtkGestureLongPress* _tmp16_;
	GtkGestureClick* _tmp17_;
	GtkEventControllerKey* _tmp18_;
	GtkEventControllerKey* _tmp19_;
	GtkLabel* _tmp20_;
	gint num = 0;
	GtkPopover* _tmp42_;
	GtkPopover* _tmp43_;
	GtkEventControllerKey* popover_controller = NULL;
	GtkEventControllerKey* _tmp44_;
	GtkEventControllerKey* _tmp45_;
	GtkEventControllerKey* _tmp46_;
	GtkWidget* _tmp47_ = NULL;
	GtkPopover* _tmp48_;
	GtkPopover* _tmp49_;
	GtkPopover* _tmp52_;
	GtkPopover* _tmp53_;
#line 170 "../src/sudoku-cell.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 170 "../src/sudoku-cell.vala"
	self = (SudokuCell*) g_object_new (object_type, NULL);
#line 172 "../src/sudoku-cell.vala"
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
#line 174 "../src/sudoku-cell.vala"
	self->priv->row = row;
#line 175 "../src/sudoku-cell.vala"
	self->priv->col = col;
#line 176 "../src/sudoku-cell.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 176 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 176 "../src/sudoku-cell.vala"
	self->priv->game = _tmp0_;
#line 178 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 178 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 178 "../src/sudoku-cell.vala"
	if (_tmp2_ != 0) {
#line 562 "sudoku-cell.c"
		GtkLabel* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
#line 180 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->value_label;
#line 180 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_value (self);
#line 180 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 180 "../src/sudoku-cell.vala"
		_tmp6_ = g_strdup_printf ("%i", _tmp5_);
#line 180 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 180 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp3_, _tmp7_);
#line 180 "../src/sudoku-cell.vala"
		_g_free0 (_tmp7_);
#line 181 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->value_label;
#line 181 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 587 "sudoku-cell.c"
	}
#line 184 "../src/sudoku-cell.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 185 "../src/sudoku-cell.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 187 "../src/sudoku-cell.vala"
	sudoku_cell_set_fixed_css (self, TRUE);
#line 189 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->button_controller;
#line 189 "../src/sudoku-cell.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp9_, (guint) 0);
#line 191 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->button_controller;
#line 191 "../src/sudoku-cell.vala"
	_tmp11_ = _g_object_ref0 ((GtkEventController*) _tmp10_);
#line 191 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp11_);
#line 192 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->long_press_controller;
#line 192 "../src/sudoku-cell.vala"
	_tmp13_ = _g_object_ref0 ((GtkEventController*) _tmp12_);
#line 192 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp13_);
#line 193 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->key_controller;
#line 193 "../src/sudoku-cell.vala"
	_tmp15_ = _g_object_ref0 ((GtkEventController*) _tmp14_);
#line 193 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp15_);
#line 195 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->long_press_controller;
#line 195 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp16_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 196 "../src/sudoku-cell.vala"
	_tmp17_ = self->priv->button_controller;
#line 196 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp17_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
#line 197 "../src/sudoku-cell.vala"
	_tmp18_ = self->priv->key_controller;
#line 197 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp18_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 198 "../src/sudoku-cell.vala"
	_tmp19_ = self->priv->key_controller;
#line 198 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp19_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 200 "../src/sudoku-cell.vala"
	_tmp20_ = self->priv->value_label;
#line 200 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp20_, (GtkWidget*) self);
#line 202 "../src/sudoku-cell.vala"
	num = 0;
#line 639 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 203 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 644 "sudoku-cell.c"
		{
			gboolean _tmp21_ = FALSE;
#line 203 "../src/sudoku-cell.vala"
			_tmp21_ = TRUE;
#line 203 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 651 "sudoku-cell.c"
				SudokuBoard* _tmp23_;
				SudokuBoard* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
#line 203 "../src/sudoku-cell.vala"
				if (!_tmp21_) {
#line 658 "sudoku-cell.c"
					gint _tmp22_;
#line 203 "../src/sudoku-cell.vala"
					_tmp22_ = row_tmp;
#line 203 "../src/sudoku-cell.vala"
					row_tmp = _tmp22_ + 1;
#line 664 "sudoku-cell.c"
				}
#line 203 "../src/sudoku-cell.vala"
				_tmp21_ = FALSE;
#line 203 "../src/sudoku-cell.vala"
				_tmp23_ = sudoku_game_get_board (*game);
#line 203 "../src/sudoku-cell.vala"
				_tmp24_ = _tmp23_;
#line 203 "../src/sudoku-cell.vala"
				_tmp25_ = sudoku_board_get_block_rows (_tmp24_);
#line 203 "../src/sudoku-cell.vala"
				_tmp26_ = _tmp25_;
#line 203 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp26_)) {
#line 203 "../src/sudoku-cell.vala"
					break;
#line 680 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 205 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 686 "sudoku-cell.c"
					{
						gboolean _tmp27_ = FALSE;
#line 205 "../src/sudoku-cell.vala"
						_tmp27_ = TRUE;
#line 205 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 693 "sudoku-cell.c"
							SudokuBoard* _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							gchar* _tmp35_;
							gchar* _tmp36_;
							GtkLabel* _tmp37_ = NULL;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							GtkLabel* _tmp39_;
							GtkLabel** _tmp40_;
							gint _tmp40__length1;
							GtkLabel* _tmp41_;
#line 205 "../src/sudoku-cell.vala"
							if (!_tmp27_) {
#line 712 "sudoku-cell.c"
								gint _tmp28_;
#line 205 "../src/sudoku-cell.vala"
								_tmp28_ = col_tmp;
#line 205 "../src/sudoku-cell.vala"
								col_tmp = _tmp28_ + 1;
#line 718 "sudoku-cell.c"
							}
#line 205 "../src/sudoku-cell.vala"
							_tmp27_ = FALSE;
#line 205 "../src/sudoku-cell.vala"
							_tmp29_ = sudoku_game_get_board (*game);
#line 205 "../src/sudoku-cell.vala"
							_tmp30_ = _tmp29_;
#line 205 "../src/sudoku-cell.vala"
							_tmp31_ = sudoku_board_get_block_cols (_tmp30_);
#line 205 "../src/sudoku-cell.vala"
							_tmp32_ = _tmp31_;
#line 205 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp32_)) {
#line 205 "../src/sudoku-cell.vala"
								break;
#line 734 "sudoku-cell.c"
							}
#line 207 "../src/sudoku-cell.vala"
							_tmp33_ = num;
#line 207 "../src/sudoku-cell.vala"
							num = _tmp33_ + 1;
#line 209 "../src/sudoku-cell.vala"
							_tmp34_ = self->priv->earmark_labels;
#line 209 "../src/sudoku-cell.vala"
							_tmp34__length1 = self->priv->earmark_labels_length1;
#line 209 "../src/sudoku-cell.vala"
							_tmp35_ = g_strdup_printf ("%i", num);
#line 209 "../src/sudoku-cell.vala"
							_tmp36_ = _tmp35_;
#line 209 "../src/sudoku-cell.vala"
							_tmp37_ = (GtkLabel*) gtk_label_new (_tmp36_);
#line 209 "../src/sudoku-cell.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp37_, FALSE);
#line 209 "../src/sudoku-cell.vala"
							g_object_ref_sink (_tmp37_);
#line 209 "../src/sudoku-cell.vala"
							_g_object_unref0 (_tmp34_[num - 1]);
#line 209 "../src/sudoku-cell.vala"
							_tmp34_[num - 1] = _tmp37_;
#line 209 "../src/sudoku-cell.vala"
							_g_free0 (_tmp36_);
#line 212 "../src/sudoku-cell.vala"
							_tmp38_ = self->priv->earmark_labels;
#line 212 "../src/sudoku-cell.vala"
							_tmp38__length1 = self->priv->earmark_labels_length1;
#line 212 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_[num - 1];
#line 212 "../src/sudoku-cell.vala"
							gtk_widget_set_parent ((GtkWidget*) _tmp39_, (GtkWidget*) self);
#line 213 "../src/sudoku-cell.vala"
							_tmp40_ = self->priv->earmark_labels;
#line 213 "../src/sudoku-cell.vala"
							_tmp40__length1 = self->priv->earmark_labels_length1;
#line 213 "../src/sudoku-cell.vala"
							_tmp41_ = _tmp40_[num - 1];
#line 213 "../src/sudoku-cell.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp41_, "earmark");
#line 776 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 217 "../src/sudoku-cell.vala"
	_tmp42_ = sudoku_cell_get_popover (self);
#line 217 "../src/sudoku-cell.vala"
	_tmp43_ = _tmp42_;
#line 217 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp43_, (GtkWidget*) self);
#line 218 "../src/sudoku-cell.vala"
	_tmp44_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 218 "../src/sudoku-cell.vala"
	popover_controller = _tmp44_;
#line 219 "../src/sudoku-cell.vala"
	_tmp45_ = popover_controller;
#line 219 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp45_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 220 "../src/sudoku-cell.vala"
	_tmp46_ = popover_controller;
#line 220 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp46_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 221 "../src/sudoku-cell.vala"
	_tmp48_ = sudoku_cell_get_popover (self);
#line 221 "../src/sudoku-cell.vala"
	_tmp49_ = _tmp48_;
#line 221 "../src/sudoku-cell.vala"
	_tmp47_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp49_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp49_) : NULL;
#line 221 "../src/sudoku-cell.vala"
	if (_tmp47_ != NULL) {
#line 809 "sudoku-cell.c"
		GtkEventControllerKey* _tmp50_;
		GtkEventController* _tmp51_;
#line 221 "../src/sudoku-cell.vala"
		_tmp50_ = popover_controller;
#line 221 "../src/sudoku-cell.vala"
		_tmp51_ = _g_object_ref0 ((GtkEventController*) _tmp50_);
#line 221 "../src/sudoku-cell.vala"
		gtk_widget_add_controller (_tmp47_, _tmp51_);
#line 818 "sudoku-cell.c"
	}
#line 222 "../src/sudoku-cell.vala"
	_tmp52_ = sudoku_cell_get_popover (self);
#line 222 "../src/sudoku-cell.vala"
	_tmp53_ = _tmp52_;
#line 222 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp53_, "closed", (GCallback) ___lambda10__gtk_popover_closed, self, 0);
#line 170 "../src/sudoku-cell.vala"
	_g_object_unref0 (popover_controller);
#line 170 "../src/sudoku-cell.vala"
	return self;
#line 830 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame** game)
{
#line 170 "../src/sudoku-cell.vala"
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game);
#line 840 "sudoku-cell.c"
}

void
sudoku_cell_update_value (SudokuCell* self)
{
	gint _tmp0_;
	gint _tmp1_;
#line 236 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 238 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 238 "../src/sudoku-cell.vala"
	if (_tmp1_ != 0) {
#line 856 "sudoku-cell.c"
		GtkLabel* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
#line 240 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->value_label;
#line 240 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_cell_get_value (self);
#line 240 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 240 "../src/sudoku-cell.vala"
		_tmp5_ = g_strdup_printf ("%i", _tmp4_);
#line 240 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 240 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp2_, _tmp6_);
#line 240 "../src/sudoku-cell.vala"
		_g_free0 (_tmp6_);
#line 241 "../src/sudoku-cell.vala"
		_tmp7_ = self->priv->value_label;
#line 241 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, TRUE);
#line 881 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp8_;
#line 244 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->value_label;
#line 244 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
#line 888 "sudoku-cell.c"
	}
#line 246 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 892 "sudoku-cell.c"
}

void
sudoku_cell_update_earmark (SudokuCell* self,
                            gint num)
{
#line 249 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmark (self, num);
#line 903 "sudoku-cell.c"
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 254 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 258 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 258 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 920 "sudoku-cell.c"
	} else {
#line 258 "../src/sudoku-cell.vala"
		_tmp0_ = keyval == GDK_KEY_Control_R;
#line 924 "sudoku-cell.c"
	}
#line 258 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 259 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = TRUE;
#line 930 "sudoku-cell.c"
	}
#line 263 "../src/sudoku-cell.vala"
	result = GDK_EVENT_PROPAGATE;
#line 263 "../src/sudoku-cell.vala"
	return result;
#line 936 "sudoku-cell.c"
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp6_ = FALSE;
	gint key = 0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_ = FALSE;
#line 266 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_is_fixed (self);
#line 270 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 270 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 270 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 965 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 270 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->game;
#line 270 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_game_get_paused (_tmp3_);
#line 270 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 270 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_;
#line 978 "sudoku-cell.c"
	}
#line 270 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 271 "../src/sudoku-cell.vala"
		return;
#line 984 "sudoku-cell.c"
	}
#line 273 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 273 "../src/sudoku-cell.vala"
		_tmp6_ = TRUE;
#line 990 "sudoku-cell.c"
	} else {
#line 273 "../src/sudoku-cell.vala"
		_tmp6_ = keyval == GDK_KEY_Control_R;
#line 994 "sudoku-cell.c"
	}
#line 273 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 274 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = FALSE;
#line 1000 "sudoku-cell.c"
	}
#line 276 "../src/sudoku-cell.vala"
	key = sudoku_cell_get_key_number (self, keyval);
#line 277 "../src/sudoku-cell.vala"
	if (key >= 1) {
#line 277 "../src/sudoku-cell.vala"
		_tmp7_ = key <= 9;
#line 1008 "sudoku-cell.c"
	} else {
#line 277 "../src/sudoku-cell.vala"
		_tmp7_ = FALSE;
#line 1012 "sudoku-cell.c"
	}
#line 277 "../src/sudoku-cell.vala"
	if (_tmp7_) {
#line 1016 "sudoku-cell.c"
		NumberPicker* number_picker = NULL;
		GtkPopover* _tmp8_;
		GtkPopover* _tmp9_;
		GtkWidget* _tmp10_;
		NumberPicker* _tmp11_;
		gboolean ctrl_pressed = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		GtkPopover* _tmp15_;
		GtkPopover* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		gboolean want_earmark = FALSE;
		gboolean _tmp26_ = FALSE;
#line 280 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_cell_get_popover (self);
#line 280 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 280 "../src/sudoku-cell.vala"
		_tmp10_ = gtk_popover_get_child (_tmp9_);
#line 280 "../src/sudoku-cell.vala"
		_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_NUMBER_PICKER, NumberPicker));
#line 280 "../src/sudoku-cell.vala"
		number_picker = _tmp11_;
#line 281 "../src/sudoku-cell.vala"
		ctrl_pressed = (state & GDK_CONTROL_MASK) > 0;
#line 282 "../src/sudoku-cell.vala"
		_tmp15_ = sudoku_cell_get_popover (self);
#line 282 "../src/sudoku-cell.vala"
		_tmp16_ = _tmp15_;
#line 282 "../src/sudoku-cell.vala"
		_tmp17_ = gtk_widget_get_visible ((GtkWidget*) _tmp16_);
#line 282 "../src/sudoku-cell.vala"
		_tmp18_ = _tmp17_;
#line 282 "../src/sudoku-cell.vala"
		if (_tmp18_) {
#line 1054 "sudoku-cell.c"
			NumberPicker* _tmp19_;
#line 282 "../src/sudoku-cell.vala"
			_tmp19_ = number_picker;
#line 282 "../src/sudoku-cell.vala"
			_tmp14_ = _tmp19_ != NULL;
#line 1060 "sudoku-cell.c"
		} else {
#line 282 "../src/sudoku-cell.vala"
			_tmp14_ = FALSE;
#line 1064 "sudoku-cell.c"
		}
#line 282 "../src/sudoku-cell.vala"
		if (_tmp14_) {
#line 1068 "sudoku-cell.c"
			NumberPicker* _tmp20_;
			gboolean _tmp21_;
			gboolean _tmp22_;
#line 282 "../src/sudoku-cell.vala"
			_tmp20_ = number_picker;
#line 282 "../src/sudoku-cell.vala"
			_tmp21_ = number_picker_get_is_earmark_picker (_tmp20_);
#line 282 "../src/sudoku-cell.vala"
			_tmp22_ = _tmp21_;
#line 282 "../src/sudoku-cell.vala"
			_tmp13_ = _tmp22_;
#line 1080 "sudoku-cell.c"
		} else {
#line 282 "../src/sudoku-cell.vala"
			_tmp13_ = FALSE;
#line 1084 "sudoku-cell.c"
		}
#line 282 "../src/sudoku-cell.vala"
		if (_tmp13_) {
#line 282 "../src/sudoku-cell.vala"
			_tmp12_ = TRUE;
#line 1090 "sudoku-cell.c"
		} else {
			gboolean _tmp23_ = FALSE;
#line 283 "../src/sudoku-cell.vala"
			if (ctrl_pressed) {
#line 1095 "sudoku-cell.c"
				gint _tmp24_;
				gint _tmp25_;
#line 283 "../src/sudoku-cell.vala"
				_tmp24_ = sudoku_cell_get_value (self);
#line 283 "../src/sudoku-cell.vala"
				_tmp25_ = _tmp24_;
#line 283 "../src/sudoku-cell.vala"
				_tmp23_ = _tmp25_ == 0;
#line 1104 "sudoku-cell.c"
			} else {
#line 283 "../src/sudoku-cell.vala"
				_tmp23_ = FALSE;
#line 1108 "sudoku-cell.c"
			}
#line 283 "../src/sudoku-cell.vala"
			_tmp12_ = _tmp23_;
#line 1112 "sudoku-cell.c"
		}
#line 282 "../src/sudoku-cell.vala"
		want_earmark = _tmp12_;
#line 284 "../src/sudoku-cell.vala"
		if (want_earmark) {
#line 1118 "sudoku-cell.c"
			SudokuGame* _tmp27_;
			GameMode _tmp28_;
			GameMode _tmp29_;
#line 284 "../src/sudoku-cell.vala"
			_tmp27_ = self->priv->game;
#line 284 "../src/sudoku-cell.vala"
			_tmp28_ = sudoku_game_get_mode (_tmp27_);
#line 284 "../src/sudoku-cell.vala"
			_tmp29_ = _tmp28_;
#line 284 "../src/sudoku-cell.vala"
			_tmp26_ = _tmp29_ == GAME_MODE_PLAY;
#line 1130 "sudoku-cell.c"
		} else {
#line 284 "../src/sudoku-cell.vala"
			_tmp26_ = FALSE;
#line 1134 "sudoku-cell.c"
		}
#line 284 "../src/sudoku-cell.vala"
		if (_tmp26_) {
#line 1138 "sudoku-cell.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp30_;
			SudokuBoard* _tmp31_;
			SudokuBoard* _tmp32_;
			gboolean _tmp33_ = FALSE;
			NumberPicker* _tmp34_;
#line 286 "../src/sudoku-cell.vala"
			_tmp30_ = self->priv->game;
#line 286 "../src/sudoku-cell.vala"
			_tmp31_ = sudoku_game_get_board (_tmp30_);
#line 286 "../src/sudoku-cell.vala"
			_tmp32_ = _tmp31_;
#line 286 "../src/sudoku-cell.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp32_, self->priv->row, self->priv->col, key);
#line 288 "../src/sudoku-cell.vala"
			_tmp34_ = number_picker;
#line 288 "../src/sudoku-cell.vala"
			if (_tmp34_ != NULL) {
#line 1157 "sudoku-cell.c"
				NumberPicker* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
#line 288 "../src/sudoku-cell.vala"
				_tmp35_ = number_picker;
#line 288 "../src/sudoku-cell.vala"
				_tmp36_ = number_picker_get_is_earmark_picker (_tmp35_);
#line 288 "../src/sudoku-cell.vala"
				_tmp37_ = _tmp36_;
#line 288 "../src/sudoku-cell.vala"
				_tmp33_ = _tmp37_;
#line 1169 "sudoku-cell.c"
			} else {
#line 288 "../src/sudoku-cell.vala"
				_tmp33_ = FALSE;
#line 1173 "sudoku-cell.c"
			}
#line 288 "../src/sudoku-cell.vala"
			if (_tmp33_) {
#line 1177 "sudoku-cell.c"
				NumberPicker* _tmp38_;
#line 290 "../src/sudoku-cell.vala"
				_tmp38_ = number_picker;
#line 290 "../src/sudoku-cell.vala"
				number_picker_set_earmark (_tmp38_, self->priv->row, self->priv->col, key - 1, new_state);
#line 1183 "sudoku-cell.c"
			} else {
#line 294 "../src/sudoku-cell.vala"
				if (new_state) {
#line 1187 "sudoku-cell.c"
					SudokuGame* _tmp39_;
#line 295 "../src/sudoku-cell.vala"
					_tmp39_ = self->priv->game;
#line 295 "../src/sudoku-cell.vala"
					sudoku_game_enable_earmark (_tmp39_, self->priv->row, self->priv->col, key);
#line 1193 "sudoku-cell.c"
				} else {
					SudokuGame* _tmp40_;
#line 297 "../src/sudoku-cell.vala"
					_tmp40_ = self->priv->game;
#line 297 "../src/sudoku-cell.vala"
					sudoku_game_disable_earmark (_tmp40_, self->priv->row, self->priv->col, key);
#line 1200 "sudoku-cell.c"
				}
			}
		} else {
#line 300 "../src/sudoku-cell.vala"
			if (!ctrl_pressed) {
#line 1206 "sudoku-cell.c"
				SudokuGame* _tmp41_;
				SudokuBoard* _tmp42_;
				SudokuBoard* _tmp43_;
#line 302 "../src/sudoku-cell.vala"
				sudoku_cell_set_value (self, key);
#line 303 "../src/sudoku-cell.vala"
				_tmp41_ = self->priv->game;
#line 303 "../src/sudoku-cell.vala"
				_tmp42_ = sudoku_game_get_board (_tmp41_);
#line 303 "../src/sudoku-cell.vala"
				_tmp43_ = _tmp42_;
#line 303 "../src/sudoku-cell.vala"
				sudoku_board_disable_all_earmarks (_tmp43_, self->priv->row, self->priv->col);
#line 1220 "sudoku-cell.c"
			}
		}
#line 305 "../src/sudoku-cell.vala"
		_g_object_unref0 (number_picker);
#line 305 "../src/sudoku-cell.vala"
		return;
#line 1227 "sudoku-cell.c"
	}
#line 308 "../src/sudoku-cell.vala"
	if (key == 0) {
#line 308 "../src/sudoku-cell.vala"
		_tmp45_ = TRUE;
#line 1233 "sudoku-cell.c"
	} else {
#line 309 "../src/sudoku-cell.vala"
		_tmp45_ = keyval == GDK_KEY_BackSpace;
#line 1237 "sudoku-cell.c"
	}
#line 308 "../src/sudoku-cell.vala"
	if (_tmp45_) {
#line 308 "../src/sudoku-cell.vala"
		_tmp44_ = TRUE;
#line 1243 "sudoku-cell.c"
	} else {
#line 310 "../src/sudoku-cell.vala"
		_tmp44_ = keyval == GDK_KEY_Delete;
#line 1247 "sudoku-cell.c"
	}
#line 308 "../src/sudoku-cell.vala"
	if (_tmp44_) {
#line 1251 "sudoku-cell.c"
		SudokuGame* _tmp46_;
		SudokuBoard* _tmp47_;
		SudokuBoard* _tmp48_;
#line 312 "../src/sudoku-cell.vala"
		_tmp46_ = self->priv->game;
#line 312 "../src/sudoku-cell.vala"
		_tmp47_ = sudoku_game_get_board (_tmp46_);
#line 312 "../src/sudoku-cell.vala"
		_tmp48_ = _tmp47_;
#line 312 "../src/sudoku-cell.vala"
		if (sudoku_board_has_earmarks (_tmp48_, self->priv->row, self->priv->col)) {
#line 1263 "sudoku-cell.c"
			SudokuGame* _tmp49_;
#line 313 "../src/sudoku-cell.vala"
			_tmp49_ = self->priv->game;
#line 313 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp49_, self->priv->row, self->priv->col);
#line 1269 "sudoku-cell.c"
		}
#line 314 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, 0);
#line 315 "../src/sudoku-cell.vala"
		return;
#line 1275 "sudoku-cell.c"
	}
#line 318 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_space) {
#line 318 "../src/sudoku-cell.vala"
		_tmp51_ = TRUE;
#line 1281 "sudoku-cell.c"
	} else {
#line 319 "../src/sudoku-cell.vala"
		_tmp51_ = keyval == GDK_KEY_Return;
#line 1285 "sudoku-cell.c"
	}
#line 318 "../src/sudoku-cell.vala"
	if (_tmp51_) {
#line 318 "../src/sudoku-cell.vala"
		_tmp50_ = TRUE;
#line 1291 "sudoku-cell.c"
	} else {
#line 320 "../src/sudoku-cell.vala"
		_tmp50_ = keyval == GDK_KEY_KP_Enter;
#line 1295 "sudoku-cell.c"
	}
#line 318 "../src/sudoku-cell.vala"
	if (_tmp50_) {
#line 322 "../src/sudoku-cell.vala"
		sudoku_cell_show_number_picker (self);
#line 323 "../src/sudoku-cell.vala"
		return;
#line 1303 "sudoku-cell.c"
	}
#line 326 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Escape) {
#line 1307 "sudoku-cell.c"
		GtkPopover* _tmp52_;
		GtkPopover* _tmp53_;
		gboolean _tmp54_;
		gboolean _tmp55_;
#line 328 "../src/sudoku-cell.vala"
		_tmp52_ = sudoku_cell_get_popover (self);
#line 328 "../src/sudoku-cell.vala"
		_tmp53_ = _tmp52_;
#line 328 "../src/sudoku-cell.vala"
		_tmp54_ = gtk_widget_get_visible ((GtkWidget*) _tmp53_);
#line 328 "../src/sudoku-cell.vala"
		_tmp55_ = _tmp54_;
#line 328 "../src/sudoku-cell.vala"
		if (_tmp55_) {
#line 1322 "sudoku-cell.c"
			GtkPopover* _tmp56_;
			GtkPopover* _tmp57_;
#line 329 "../src/sudoku-cell.vala"
			_tmp56_ = sudoku_cell_get_popover (self);
#line 329 "../src/sudoku-cell.vala"
			_tmp57_ = _tmp56_;
#line 329 "../src/sudoku-cell.vala"
			gtk_popover_popdown (_tmp57_);
#line 1331 "sudoku-cell.c"
		}
#line 330 "../src/sudoku-cell.vala"
		return;
#line 1335 "sudoku-cell.c"
	}
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* gesture,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 334 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 339 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 340 "../src/sudoku-cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 1360 "sudoku-cell.c"
	} else {
#line 339 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1364 "sudoku-cell.c"
	}
#line 339 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 341 "../src/sudoku-cell.vala"
		return;
#line 1370 "sudoku-cell.c"
	}
#line 343 "../src/sudoku-cell.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 345 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
#line 345 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 345 "../src/sudoku-cell.vala"
	if (!_tmp2_) {
#line 346 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1382 "sudoku-cell.c"
	}
#line 348 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_cell_get_is_fixed (self);
#line 348 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 348 "../src/sudoku-cell.vala"
	if (_tmp5_) {
#line 348 "../src/sudoku-cell.vala"
		_tmp3_ = TRUE;
#line 1392 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 348 "../src/sudoku-cell.vala"
		_tmp6_ = self->priv->game;
#line 348 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_game_get_paused (_tmp6_);
#line 348 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 348 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp8_;
#line 1405 "sudoku-cell.c"
	}
#line 348 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 349 "../src/sudoku-cell.vala"
		return;
#line 1411 "sudoku-cell.c"
	}
#line 351 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1415 "sudoku-cell.c"
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		SudokuGame* _tmp11_;
		GameMode _tmp12_;
		GameMode _tmp13_;
#line 353 "../src/sudoku-cell.vala"
		_tmp11_ = self->priv->game;
#line 353 "../src/sudoku-cell.vala"
		_tmp12_ = sudoku_game_get_mode (_tmp11_);
#line 353 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 353 "../src/sudoku-cell.vala"
		if (_tmp13_ == GAME_MODE_PLAY) {
#line 1429 "sudoku-cell.c"
			GdkEventSequence* _tmp14_;
			GdkEvent* _tmp15_;
#line 354 "../src/sudoku-cell.vala"
			_tmp14_ = gtk_gesture_get_last_updated_sequence ((GtkGesture*) gesture);
#line 354 "../src/sudoku-cell.vala"
			_tmp15_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp14_);
#line 354 "../src/sudoku-cell.vala"
			_tmp10_ = (gdk_event_get_modifier_state (_tmp15_) & GDK_CONTROL_MASK) > 0;
#line 1438 "sudoku-cell.c"
		} else {
#line 353 "../src/sudoku-cell.vala"
			_tmp10_ = FALSE;
#line 1442 "sudoku-cell.c"
		}
#line 353 "../src/sudoku-cell.vala"
		if (_tmp10_) {
#line 1446 "sudoku-cell.c"
			gint _tmp16_;
			gint _tmp17_;
#line 355 "../src/sudoku-cell.vala"
			_tmp16_ = sudoku_cell_get_value (self);
#line 355 "../src/sudoku-cell.vala"
			_tmp17_ = _tmp16_;
#line 355 "../src/sudoku-cell.vala"
			_tmp9_ = _tmp17_ == 0;
#line 1455 "sudoku-cell.c"
		} else {
#line 353 "../src/sudoku-cell.vala"
			_tmp9_ = FALSE;
#line 1459 "sudoku-cell.c"
		}
#line 353 "../src/sudoku-cell.vala"
		if (_tmp9_) {
#line 357 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1465 "sudoku-cell.c"
		} else {
#line 360 "../src/sudoku-cell.vala"
			sudoku_cell_show_number_picker (self);
#line 1469 "sudoku-cell.c"
		}
	} else {
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
#line 362 "../src/sudoku-cell.vala"
		if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY)) {
#line 1476 "sudoku-cell.c"
			SudokuGame* _tmp20_;
			GameMode _tmp21_;
			GameMode _tmp22_;
#line 363 "../src/sudoku-cell.vala"
			_tmp20_ = self->priv->game;
#line 363 "../src/sudoku-cell.vala"
			_tmp21_ = sudoku_game_get_mode (_tmp20_);
#line 363 "../src/sudoku-cell.vala"
			_tmp22_ = _tmp21_;
#line 363 "../src/sudoku-cell.vala"
			_tmp19_ = _tmp22_ == GAME_MODE_PLAY;
#line 1488 "sudoku-cell.c"
		} else {
#line 362 "../src/sudoku-cell.vala"
			_tmp19_ = FALSE;
#line 1492 "sudoku-cell.c"
		}
#line 362 "../src/sudoku-cell.vala"
		if (_tmp19_) {
#line 1496 "sudoku-cell.c"
			gint _tmp23_;
			gint _tmp24_;
#line 364 "../src/sudoku-cell.vala"
			_tmp23_ = sudoku_cell_get_value (self);
#line 364 "../src/sudoku-cell.vala"
			_tmp24_ = _tmp23_;
#line 364 "../src/sudoku-cell.vala"
			_tmp18_ = _tmp24_ == 0;
#line 1505 "sudoku-cell.c"
		} else {
#line 362 "../src/sudoku-cell.vala"
			_tmp18_ = FALSE;
#line 1509 "sudoku-cell.c"
		}
#line 362 "../src/sudoku-cell.vala"
		if (_tmp18_) {
#line 366 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1515 "sudoku-cell.c"
		}
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* gesture,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SudokuGame* _tmp8_;
	GameMode _tmp9_;
	GameMode _tmp10_;
#line 370 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 370 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 374 "../src/sudoku-cell.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 375 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 375 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 375 "../src/sudoku-cell.vala"
	if (!_tmp1_) {
#line 376 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1548 "sudoku-cell.c"
	}
#line 378 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 378 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 378 "../src/sudoku-cell.vala"
	if (_tmp4_) {
#line 378 "../src/sudoku-cell.vala"
		_tmp2_ = TRUE;
#line 1558 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 378 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->game;
#line 378 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 378 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 378 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp7_;
#line 1571 "sudoku-cell.c"
	}
#line 378 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 379 "../src/sudoku-cell.vala"
		return;
#line 1577 "sudoku-cell.c"
	}
#line 381 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->game;
#line 381 "../src/sudoku-cell.vala"
	_tmp9_ = sudoku_game_get_mode (_tmp8_);
#line 381 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_;
#line 381 "../src/sudoku-cell.vala"
	if (_tmp10_ == GAME_MODE_CREATE) {
#line 382 "../src/sudoku-cell.vala"
		sudoku_cell_show_number_picker (self);
#line 1589 "sudoku-cell.c"
	} else {
		gint _tmp11_;
		gint _tmp12_;
#line 383 "../src/sudoku-cell.vala"
		_tmp11_ = sudoku_cell_get_value (self);
#line 383 "../src/sudoku-cell.vala"
		_tmp12_ = _tmp11_;
#line 383 "../src/sudoku-cell.vala"
		if (_tmp12_ == 0) {
#line 384 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1601 "sudoku-cell.c"
		}
	}
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
#line 387 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 389 "../src/sudoku-cell.vala"
	switch (keyval) {
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_0:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_0:
#line 1619 "sudoku-cell.c"
		{
#line 393 "../src/sudoku-cell.vala"
			result = 0;
#line 393 "../src/sudoku-cell.vala"
			return result;
#line 1625 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_1:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_1:
#line 1631 "sudoku-cell.c"
		{
#line 396 "../src/sudoku-cell.vala"
			result = 1;
#line 396 "../src/sudoku-cell.vala"
			return result;
#line 1637 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_2:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_2:
#line 1643 "sudoku-cell.c"
		{
#line 399 "../src/sudoku-cell.vala"
			result = 2;
#line 399 "../src/sudoku-cell.vala"
			return result;
#line 1649 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_3:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_3:
#line 1655 "sudoku-cell.c"
		{
#line 402 "../src/sudoku-cell.vala"
			result = 3;
#line 402 "../src/sudoku-cell.vala"
			return result;
#line 1661 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_4:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_4:
#line 1667 "sudoku-cell.c"
		{
#line 405 "../src/sudoku-cell.vala"
			result = 4;
#line 405 "../src/sudoku-cell.vala"
			return result;
#line 1673 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_5:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_5:
#line 1679 "sudoku-cell.c"
		{
#line 408 "../src/sudoku-cell.vala"
			result = 5;
#line 408 "../src/sudoku-cell.vala"
			return result;
#line 1685 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_6:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_6:
#line 1691 "sudoku-cell.c"
		{
#line 411 "../src/sudoku-cell.vala"
			result = 6;
#line 411 "../src/sudoku-cell.vala"
			return result;
#line 1697 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_7:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_7:
#line 1703 "sudoku-cell.c"
		{
#line 414 "../src/sudoku-cell.vala"
			result = 7;
#line 414 "../src/sudoku-cell.vala"
			return result;
#line 1709 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_8:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_8:
#line 1715 "sudoku-cell.c"
		{
#line 417 "../src/sudoku-cell.vala"
			result = 8;
#line 417 "../src/sudoku-cell.vala"
			return result;
#line 1721 "sudoku-cell.c"
		}
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_9:
#line 389 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_9:
#line 1727 "sudoku-cell.c"
		{
#line 420 "../src/sudoku-cell.vala"
			result = 9;
#line 420 "../src/sudoku-cell.vala"
			return result;
#line 1733 "sudoku-cell.c"
		}
		default:
		{
#line 422 "../src/sudoku-cell.vala"
			result = -1;
#line 422 "../src/sudoku-cell.vala"
			return result;
#line 1741 "sudoku-cell.c"
		}
	}
}

void
sudoku_cell_initialize_earmarks (SudokuCell* self,
                                 gboolean show_possibilities,
                                 gboolean force)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp6_ = FALSE;
#line 426 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 428 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 428 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 428 "../src/sudoku-cell.vala"
	if (_tmp2_ != 0) {
#line 428 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 1765 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 428 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->game;
#line 428 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 428 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 428 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_ == GAME_MODE_CREATE;
#line 1778 "sudoku-cell.c"
	}
#line 428 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 429 "../src/sudoku-cell.vala"
		return;
#line 1784 "sudoku-cell.c"
	}
#line 431 "../src/sudoku-cell.vala"
	if (show_possibilities) {
#line 1788 "sudoku-cell.c"
		gboolean _tmp7_ = FALSE;
		SudokuGame* _tmp8_;
		SudokuBoard* _tmp9_;
		SudokuBoard* _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
#line 431 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->game;
#line 431 "../src/sudoku-cell.vala"
		_tmp9_ = sudoku_game_get_board (_tmp8_);
#line 431 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_;
#line 431 "../src/sudoku-cell.vala"
		_tmp11_ = sudoku_board_get_previous_played_time (_tmp10_);
#line 431 "../src/sudoku-cell.vala"
		_tmp12_ = _tmp11_;
#line 431 "../src/sudoku-cell.vala"
		if (_tmp12_ == 0.0) {
#line 431 "../src/sudoku-cell.vala"
			_tmp7_ = TRUE;
#line 1809 "sudoku-cell.c"
		} else {
#line 431 "../src/sudoku-cell.vala"
			_tmp7_ = force;
#line 1813 "sudoku-cell.c"
		}
#line 431 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp7_;
#line 1817 "sudoku-cell.c"
	} else {
#line 431 "../src/sudoku-cell.vala"
		_tmp6_ = FALSE;
#line 1821 "sudoku-cell.c"
	}
#line 431 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 1825 "sudoku-cell.c"
		gboolean* marks = NULL;
		SudokuGame* _tmp13_;
		SudokuBoard* _tmp14_;
		SudokuBoard* _tmp15_;
		gint _tmp16_ = 0;
		gboolean* _tmp17_;
		gint marks_length1;
		gint _marks_size_;
#line 433 "../src/sudoku-cell.vala"
		_tmp13_ = self->priv->game;
#line 433 "../src/sudoku-cell.vala"
		_tmp14_ = sudoku_game_get_board (_tmp13_);
#line 433 "../src/sudoku-cell.vala"
		_tmp15_ = _tmp14_;
#line 433 "../src/sudoku-cell.vala"
		_tmp17_ = sudoku_board_get_possibilities_as_bool_array (_tmp15_, self->priv->row, self->priv->col, &_tmp16_);
#line 433 "../src/sudoku-cell.vala"
		marks = _tmp17_;
#line 433 "../src/sudoku-cell.vala"
		marks_length1 = _tmp16_;
#line 433 "../src/sudoku-cell.vala"
		_marks_size_ = marks_length1;
#line 1848 "sudoku-cell.c"
		{
			gint num = 0;
#line 434 "../src/sudoku-cell.vala"
			num = 1;
#line 1853 "sudoku-cell.c"
			{
				gboolean _tmp18_ = FALSE;
#line 434 "../src/sudoku-cell.vala"
				_tmp18_ = TRUE;
#line 434 "../src/sudoku-cell.vala"
				while (TRUE) {
#line 1860 "sudoku-cell.c"
					gboolean _tmp20_ = FALSE;
					gboolean* _tmp21_;
					gint _tmp21__length1;
					gboolean _tmp22_;
#line 434 "../src/sudoku-cell.vala"
					if (!_tmp18_) {
#line 1867 "sudoku-cell.c"
						gint _tmp19_;
#line 434 "../src/sudoku-cell.vala"
						_tmp19_ = num;
#line 434 "../src/sudoku-cell.vala"
						num = _tmp19_ + 1;
#line 1873 "sudoku-cell.c"
					}
#line 434 "../src/sudoku-cell.vala"
					_tmp18_ = FALSE;
#line 434 "../src/sudoku-cell.vala"
					if (!(num <= 9)) {
#line 434 "../src/sudoku-cell.vala"
						break;
#line 1881 "sudoku-cell.c"
					}
#line 436 "../src/sudoku-cell.vala"
					_tmp21_ = marks;
#line 436 "../src/sudoku-cell.vala"
					_tmp21__length1 = marks_length1;
#line 436 "../src/sudoku-cell.vala"
					_tmp22_ = _tmp21_[num - 1];
#line 436 "../src/sudoku-cell.vala"
					if (_tmp22_) {
#line 1891 "sudoku-cell.c"
						SudokuGame* _tmp23_;
						SudokuBoard* _tmp24_;
						SudokuBoard* _tmp25_;
#line 436 "../src/sudoku-cell.vala"
						_tmp23_ = self->priv->game;
#line 436 "../src/sudoku-cell.vala"
						_tmp24_ = sudoku_game_get_board (_tmp23_);
#line 436 "../src/sudoku-cell.vala"
						_tmp25_ = _tmp24_;
#line 436 "../src/sudoku-cell.vala"
						_tmp20_ = !sudoku_board_is_earmark_enabled (_tmp25_, self->priv->row, self->priv->col, num);
#line 1903 "sudoku-cell.c"
					} else {
#line 436 "../src/sudoku-cell.vala"
						_tmp20_ = FALSE;
#line 1907 "sudoku-cell.c"
					}
#line 436 "../src/sudoku-cell.vala"
					if (_tmp20_) {
#line 1911 "sudoku-cell.c"
						SudokuGame* _tmp26_;
						SudokuBoard* _tmp27_;
						SudokuBoard* _tmp28_;
#line 437 "../src/sudoku-cell.vala"
						_tmp26_ = self->priv->game;
#line 437 "../src/sudoku-cell.vala"
						_tmp27_ = sudoku_game_get_board (_tmp26_);
#line 437 "../src/sudoku-cell.vala"
						_tmp28_ = _tmp27_;
#line 437 "../src/sudoku-cell.vala"
						sudoku_board_enable_earmark (_tmp28_, self->priv->row, self->priv->col, num);
#line 1923 "sudoku-cell.c"
					}
				}
			}
		}
#line 431 "../src/sudoku-cell.vala"
		marks = (g_free (marks), NULL);
#line 1930 "sudoku-cell.c"
	}
#line 441 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 1934 "sudoku-cell.c"
}

static void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
#line 444 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 1942 "sudoku-cell.c"
	{
		gint num = 0;
#line 446 "../src/sudoku-cell.vala"
		num = 1;
#line 1947 "sudoku-cell.c"
		{
			gboolean _tmp0_ = FALSE;
#line 446 "../src/sudoku-cell.vala"
			_tmp0_ = TRUE;
#line 446 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 446 "../src/sudoku-cell.vala"
				if (!_tmp0_) {
#line 1956 "sudoku-cell.c"
					gint _tmp1_;
#line 446 "../src/sudoku-cell.vala"
					_tmp1_ = num;
#line 446 "../src/sudoku-cell.vala"
					num = _tmp1_ + 1;
#line 1962 "sudoku-cell.c"
				}
#line 446 "../src/sudoku-cell.vala"
				_tmp0_ = FALSE;
#line 446 "../src/sudoku-cell.vala"
				if (!(num <= 9)) {
#line 446 "../src/sudoku-cell.vala"
					break;
#line 1970 "sudoku-cell.c"
				}
#line 447 "../src/sudoku-cell.vala"
				sudoku_cell_get_visible_earmark (self, num);
#line 1974 "sudoku-cell.c"
			}
		}
	}
}

static void
sudoku_cell_get_visible_earmark (SudokuCell* self,
                                 gint num)
{
	gint _tmp0_;
	gint _tmp1_;
#line 450 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 452 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 452 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 452 "../src/sudoku-cell.vala"
	if (_tmp1_ != 0) {
#line 1994 "sudoku-cell.c"
		GtkLabel** _tmp2_;
		gint _tmp2__length1;
		GtkLabel* _tmp3_;
#line 453 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->earmark_labels;
#line 453 "../src/sudoku-cell.vala"
		_tmp2__length1 = self->priv->earmark_labels_length1;
#line 453 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp2_[num - 1];
#line 453 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 2006 "sudoku-cell.c"
	} else {
		GtkLabel** _tmp4_;
		gint _tmp4__length1;
		GtkLabel* _tmp5_;
		SudokuGame* _tmp6_;
		SudokuBoard* _tmp7_;
		SudokuBoard* _tmp8_;
#line 455 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->earmark_labels;
#line 455 "../src/sudoku-cell.vala"
		_tmp4__length1 = self->priv->earmark_labels_length1;
#line 455 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_[num - 1];
#line 455 "../src/sudoku-cell.vala"
		_tmp6_ = self->priv->game;
#line 455 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_game_get_board (_tmp6_);
#line 455 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 455 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, sudoku_board_is_earmark_enabled (_tmp8_, self->priv->row, self->priv->col, num));
#line 2028 "sudoku-cell.c"
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 458 "../src/sudoku-cell.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 458 "../src/sudoku-cell.vala"
	return _data10_;
#line 2039 "sudoku-cell.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 458 "../src/sudoku-cell.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2049 "sudoku-cell.c"
		SudokuCell* self;
#line 458 "../src/sudoku-cell.vala"
		self = _data10_->self;
#line 458 "../src/sudoku-cell.vala"
		_g_object_unref0 (_data10_->earmark_picker);
#line 458 "../src/sudoku-cell.vala"
		_g_object_unref0 (self);
#line 458 "../src/sudoku-cell.vala"
		g_slice_free (Block10Data, _data10_);
#line 2059 "sudoku-cell.c"
	}
}

static void
__lambda9_ (Block10Data* _data10_,
            gint number,
            gboolean state)
{
	SudokuCell* self;
	NumberPicker* _tmp9_;
	SudokuGame* _tmp10_;
	SudokuBoard* _tmp11_;
	SudokuBoard* _tmp12_;
#line 475 "../src/sudoku-cell.vala"
	self = _data10_->self;
#line 476 "../src/sudoku-cell.vala"
	if (state) {
#line 2077 "sudoku-cell.c"
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		SudokuBoard* _tmp2_;
#line 478 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->game;
#line 478 "../src/sudoku-cell.vala"
		_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 478 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp1_;
#line 478 "../src/sudoku-cell.vala"
		if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, number)) {
#line 2089 "sudoku-cell.c"
			SudokuGame* _tmp3_;
#line 479 "../src/sudoku-cell.vala"
			_tmp3_ = self->priv->game;
#line 479 "../src/sudoku-cell.vala"
			sudoku_game_enable_earmark (_tmp3_, self->priv->row, self->priv->col, number);
#line 2095 "sudoku-cell.c"
		}
	} else {
#line 483 "../src/sudoku-cell.vala"
		if (number == 0) {
#line 2100 "sudoku-cell.c"
			SudokuGame* _tmp4_;
#line 484 "../src/sudoku-cell.vala"
			_tmp4_ = self->priv->game;
#line 484 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
#line 2106 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp5_;
			SudokuBoard* _tmp6_;
			SudokuBoard* _tmp7_;
#line 486 "../src/sudoku-cell.vala"
			_tmp5_ = self->priv->game;
#line 486 "../src/sudoku-cell.vala"
			_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 486 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 486 "../src/sudoku-cell.vala"
			if (sudoku_board_is_earmark_enabled (_tmp7_, self->priv->row, self->priv->col, number)) {
#line 2119 "sudoku-cell.c"
				SudokuGame* _tmp8_;
#line 487 "../src/sudoku-cell.vala"
				_tmp8_ = self->priv->game;
#line 487 "../src/sudoku-cell.vala"
				sudoku_game_disable_earmark (_tmp8_, self->priv->row, self->priv->col, number);
#line 2125 "sudoku-cell.c"
			}
		}
	}
#line 490 "../src/sudoku-cell.vala"
	_tmp9_ = _data10_->earmark_picker;
#line 490 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->game;
#line 490 "../src/sudoku-cell.vala"
	_tmp11_ = sudoku_game_get_board (_tmp10_);
#line 490 "../src/sudoku-cell.vala"
	_tmp12_ = _tmp11_;
#line 490 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_enabled (_tmp9_, sudoku_board_has_earmarks (_tmp12_, self->priv->row, self->priv->col));
#line 2139 "sudoku-cell.c"
}

static void
___lambda9__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
#line 475 "../src/sudoku-cell.vala"
	__lambda9_ (self, number, active);
#line 2150 "sudoku-cell.c"
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	gint _tmp0_;
	gint _tmp1_;
	Block10Data* _data10_;
	GtkPopover* _tmp2_;
	GtkPopover* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	SudokuGame* _tmp12_;
	NumberPicker* _tmp13_;
	NumberPicker* _tmp14_;
	SudokuGame* _tmp15_;
	SudokuBoard* _tmp16_;
	SudokuBoard* _tmp17_;
	NumberPicker* _tmp19_;
	NumberPicker* _tmp20_;
	GtkPopover* _tmp21_;
	GtkPopover* _tmp22_;
	NumberPicker* _tmp23_;
	GtkPopover* _tmp24_;
	GtkPopover* _tmp25_;
#line 458 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 458 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 458 "../src/sudoku-cell.vala"
	_vala_return_if_fail (_tmp1_ == 0, "this.value == 0");
#line 458 "../src/sudoku-cell.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 458 "../src/sudoku-cell.vala"
	_data10_->_ref_count_ = 1;
#line 458 "../src/sudoku-cell.vala"
	_data10_->self = g_object_ref (self);
#line 461 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_popover (self);
#line 461 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 461 "../src/sudoku-cell.vala"
	_tmp4_ = gtk_widget_get_visible ((GtkWidget*) _tmp3_);
#line 461 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 461 "../src/sudoku-cell.vala"
	if (_tmp5_) {
#line 2200 "sudoku-cell.c"
		GtkPopover* _tmp6_;
		GtkPopover* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 463 "../src/sudoku-cell.vala"
		sudoku_cell_dismiss_popover (self);
#line 464 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_cell_get_popover (self);
#line 464 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 464 "../src/sudoku-cell.vala"
		_tmp8_ = gtk_popover_get_child (_tmp7_);
#line 464 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 464 "../src/sudoku-cell.vala"
		_tmp10_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_NUMBER_PICKER, NumberPicker));
#line 464 "../src/sudoku-cell.vala"
		_tmp11_ = _tmp10_;
#line 464 "../src/sudoku-cell.vala"
		if (_tmp11_) {
#line 465 "../src/sudoku-cell.vala"
			block10_data_unref (_data10_);
#line 465 "../src/sudoku-cell.vala"
			_data10_ = NULL;
#line 465 "../src/sudoku-cell.vala"
			return;
#line 2229 "sudoku-cell.c"
		}
	}
#line 468 "../src/sudoku-cell.vala"
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
#line 470 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->game;
#line 470 "../src/sudoku-cell.vala"
	_tmp13_ = number_picker_new (_tmp12_, TRUE);
#line 470 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp13_);
#line 470 "../src/sudoku-cell.vala"
	_data10_->earmark_picker = _tmp13_;
#line 471 "../src/sudoku-cell.vala"
	_tmp14_ = _data10_->earmark_picker;
#line 471 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp14_, TRUE);
#line 472 "../src/sudoku-cell.vala"
	_tmp15_ = self->priv->game;
#line 472 "../src/sudoku-cell.vala"
	_tmp16_ = sudoku_game_get_board (_tmp15_);
#line 472 "../src/sudoku-cell.vala"
	_tmp17_ = _tmp16_;
#line 472 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp17_, self->priv->row, self->priv->col)) {
#line 2254 "sudoku-cell.c"
		NumberPicker* _tmp18_;
#line 473 "../src/sudoku-cell.vala"
		_tmp18_ = _data10_->earmark_picker;
#line 473 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp18_, FALSE);
#line 2260 "sudoku-cell.c"
	}
#line 475 "../src/sudoku-cell.vala"
	_tmp19_ = _data10_->earmark_picker;
#line 475 "../src/sudoku-cell.vala"
	g_signal_connect_data (_tmp19_, "earmark-state-changed", (GCallback) ___lambda9__number_picker_earmark_state_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 492 "../src/sudoku-cell.vala"
	_tmp20_ = _data10_->earmark_picker;
#line 492 "../src/sudoku-cell.vala"
	number_picker_set_earmarks (_tmp20_, self->priv->row, self->priv->col);
#line 493 "../src/sudoku-cell.vala"
	_tmp21_ = sudoku_cell_get_popover (self);
#line 493 "../src/sudoku-cell.vala"
	_tmp22_ = _tmp21_;
#line 493 "../src/sudoku-cell.vala"
	_tmp23_ = _data10_->earmark_picker;
#line 493 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp22_, (GtkWidget*) _tmp23_);
#line 495 "../src/sudoku-cell.vala"
	_tmp24_ = sudoku_cell_get_popover (self);
#line 495 "../src/sudoku-cell.vala"
	_tmp25_ = _tmp24_;
#line 495 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp25_);
#line 458 "../src/sudoku-cell.vala"
	block10_data_unref (_data10_);
#line 458 "../src/sudoku-cell.vala"
	_data10_ = NULL;
#line 2288 "sudoku-cell.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 498 "../src/sudoku-cell.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 498 "../src/sudoku-cell.vala"
	return _data11_;
#line 2298 "sudoku-cell.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 498 "../src/sudoku-cell.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 2308 "sudoku-cell.c"
		SudokuCell* self;
#line 498 "../src/sudoku-cell.vala"
		self = _data11_->self;
#line 498 "../src/sudoku-cell.vala"
		_g_object_unref0 (_data11_->number_picker);
#line 498 "../src/sudoku-cell.vala"
		_g_object_unref0 (self);
#line 498 "../src/sudoku-cell.vala"
		g_slice_free (Block11Data, _data11_);
#line 2318 "sudoku-cell.c"
	}
}

static void
__lambda8_ (Block11Data* _data11_,
            NumberPicker* o,
            gint number)
{
	SudokuCell* self;
#line 510 "../src/sudoku-cell.vala"
	self = _data11_->self;
#line 510 "../src/sudoku-cell.vala"
	g_return_if_fail (o != NULL);
#line 511 "../src/sudoku-cell.vala"
	if (number > 0) {
#line 2334 "sudoku-cell.c"
		GtkPopover* _tmp0_;
		GtkPopover* _tmp1_;
#line 512 "../src/sudoku-cell.vala"
		_tmp0_ = sudoku_cell_get_popover (self);
#line 512 "../src/sudoku-cell.vala"
		_tmp1_ = _tmp0_;
#line 512 "../src/sudoku-cell.vala"
		gtk_popover_popdown (_tmp1_);
#line 2343 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		NumberPicker* _tmp5_;
#line 515 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->game;
#line 515 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 515 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 515 "../src/sudoku-cell.vala"
		sudoku_board_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
#line 516 "../src/sudoku-cell.vala"
		_tmp5_ = _data11_->number_picker;
#line 516 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_visibility (_tmp5_, FALSE);
#line 2361 "sudoku-cell.c"
	}
#line 518 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, number);
#line 2365 "sudoku-cell.c"
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
#line 510 "../src/sudoku-cell.vala"
	__lambda8_ (self, _sender, number);
#line 2375 "sudoku-cell.c"
}

static void
sudoku_cell_show_number_picker (SudokuCell* self)
{
	Block11Data* _data11_;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuGame* _tmp10_;
	NumberPicker* _tmp11_;
	NumberPicker* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gint _tmp14_;
	gint _tmp15_;
	NumberPicker* _tmp19_;
	GtkPopover* _tmp20_;
	GtkPopover* _tmp21_;
	NumberPicker* _tmp22_;
	GtkPopover* _tmp23_;
	GtkPopover* _tmp24_;
#line 498 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 498 "../src/sudoku-cell.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 498 "../src/sudoku-cell.vala"
	_data11_->_ref_count_ = 1;
#line 498 "../src/sudoku-cell.vala"
	_data11_->self = g_object_ref (self);
#line 500 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 500 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 500 "../src/sudoku-cell.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 500 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 500 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 2416 "sudoku-cell.c"
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 502 "../src/sudoku-cell.vala"
		sudoku_cell_dismiss_popover (self);
#line 503 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_popover (self);
#line 503 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 503 "../src/sudoku-cell.vala"
		_tmp6_ = gtk_popover_get_child (_tmp5_);
#line 503 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 503 "../src/sudoku-cell.vala"
		_tmp8_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_NUMBER_PICKER, NumberPicker));
#line 503 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 503 "../src/sudoku-cell.vala"
		if (!_tmp9_) {
#line 504 "../src/sudoku-cell.vala"
			block11_data_unref (_data11_);
#line 504 "../src/sudoku-cell.vala"
			_data11_ = NULL;
#line 504 "../src/sudoku-cell.vala"
			return;
#line 2445 "sudoku-cell.c"
		}
	}
#line 507 "../src/sudoku-cell.vala"
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
#line 509 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->game;
#line 509 "../src/sudoku-cell.vala"
	_tmp11_ = number_picker_new (_tmp10_, FALSE);
#line 509 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp11_);
#line 509 "../src/sudoku-cell.vala"
	_data11_->number_picker = _tmp11_;
#line 510 "../src/sudoku-cell.vala"
	_tmp12_ = _data11_->number_picker;
#line 510 "../src/sudoku-cell.vala"
	g_signal_connect_data (_tmp12_, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 520 "../src/sudoku-cell.vala"
	_tmp14_ = sudoku_cell_get_value (self);
#line 520 "../src/sudoku-cell.vala"
	_tmp15_ = _tmp14_;
#line 520 "../src/sudoku-cell.vala"
	if (_tmp15_ > 0) {
#line 520 "../src/sudoku-cell.vala"
		_tmp13_ = TRUE;
#line 2470 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp16_;
		SudokuBoard* _tmp17_;
		SudokuBoard* _tmp18_;
#line 520 "../src/sudoku-cell.vala"
		_tmp16_ = self->priv->game;
#line 520 "../src/sudoku-cell.vala"
		_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 520 "../src/sudoku-cell.vala"
		_tmp18_ = _tmp17_;
#line 520 "../src/sudoku-cell.vala"
		_tmp13_ = sudoku_board_has_earmarks (_tmp18_, self->priv->row, self->priv->col);
#line 2483 "sudoku-cell.c"
	}
#line 520 "../src/sudoku-cell.vala"
	_tmp19_ = _data11_->number_picker;
#line 520 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp19_, _tmp13_);
#line 521 "../src/sudoku-cell.vala"
	_tmp20_ = sudoku_cell_get_popover (self);
#line 521 "../src/sudoku-cell.vala"
	_tmp21_ = _tmp20_;
#line 521 "../src/sudoku-cell.vala"
	_tmp22_ = _data11_->number_picker;
#line 521 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp21_, (GtkWidget*) _tmp22_);
#line 523 "../src/sudoku-cell.vala"
	_tmp23_ = sudoku_cell_get_popover (self);
#line 523 "../src/sudoku-cell.vala"
	_tmp24_ = _tmp23_;
#line 523 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp24_);
#line 498 "../src/sudoku-cell.vala"
	block11_data_unref (_data11_);
#line 498 "../src/sudoku-cell.vala"
	_data11_ = NULL;
#line 2507 "sudoku-cell.c"
}

void
sudoku_cell_check_value_warnings (SudokuCell* self,
                                  gboolean show_extra_warnings)
{
	gboolean _error_ = FALSE;
	gint _tmp0_;
	gint _tmp1_;
#line 526 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 528 "../src/sudoku-cell.vala"
	_error_ = FALSE;
#line 530 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 530 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 530 "../src/sudoku-cell.vala"
	if (_tmp1_ != 0) {
#line 2527 "sudoku-cell.c"
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		Coord _tmp7_ = {0};
		GtkLabel* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 532 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->game;
#line 532 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 532 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 532 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_board_get_broken_coords (_tmp4_);
#line 532 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 532 "../src/sudoku-cell.vala"
		coord_init (&_tmp7_, self->priv->row, self->priv->col);
#line 532 "../src/sudoku-cell.vala"
		if (gee_collection_contains ((GeeCollection*) _tmp6_, &_tmp7_)) {
#line 533 "../src/sudoku-cell.vala"
			_error_ = TRUE;
#line 2555 "sudoku-cell.c"
		} else {
			gboolean _tmp8_ = FALSE;
#line 535 "../src/sudoku-cell.vala"
			if (show_extra_warnings) {
#line 2560 "sudoku-cell.c"
				SudokuGame* _tmp9_;
				GameMode _tmp10_;
				GameMode _tmp11_;
#line 535 "../src/sudoku-cell.vala"
				_tmp9_ = self->priv->game;
#line 535 "../src/sudoku-cell.vala"
				_tmp10_ = sudoku_game_get_mode (_tmp9_);
#line 535 "../src/sudoku-cell.vala"
				_tmp11_ = _tmp10_;
#line 535 "../src/sudoku-cell.vala"
				_tmp8_ = _tmp11_ == GAME_MODE_PLAY;
#line 2572 "sudoku-cell.c"
			} else {
#line 535 "../src/sudoku-cell.vala"
				_tmp8_ = FALSE;
#line 2576 "sudoku-cell.c"
			}
#line 535 "../src/sudoku-cell.vala"
			if (_tmp8_) {
#line 2580 "sudoku-cell.c"
				gint solution = 0;
				SudokuGame* _tmp12_;
				SudokuBoard* _tmp13_;
				SudokuBoard* _tmp14_;
#line 537 "../src/sudoku-cell.vala"
				_tmp12_ = self->priv->game;
#line 537 "../src/sudoku-cell.vala"
				_tmp13_ = sudoku_game_get_board (_tmp12_);
#line 537 "../src/sudoku-cell.vala"
				_tmp14_ = _tmp13_;
#line 537 "../src/sudoku-cell.vala"
				solution = sudoku_board_get_solution (_tmp14_, self->priv->row, self->priv->col);
#line 538 "../src/sudoku-cell.vala"
				if (solution != 0) {
#line 2595 "sudoku-cell.c"
					gint _tmp15_;
					gint _tmp16_;
#line 539 "../src/sudoku-cell.vala"
					_tmp15_ = sudoku_cell_get_value (self);
#line 539 "../src/sudoku-cell.vala"
					_tmp16_ = _tmp15_;
#line 539 "../src/sudoku-cell.vala"
					_error_ = _tmp16_ != solution;
#line 2604 "sudoku-cell.c"
				}
			}
		}
#line 542 "../src/sudoku-cell.vala"
		_tmp17_ = self->priv->value_label;
#line 542 "../src/sudoku-cell.vala"
		_tmp18_ = sudoku_cell_get_value (self);
#line 542 "../src/sudoku-cell.vala"
		_tmp19_ = _tmp18_;
#line 542 "../src/sudoku-cell.vala"
		_tmp20_ = g_strdup_printf ("%i", _tmp19_);
#line 542 "../src/sudoku-cell.vala"
		_tmp21_ = _tmp20_;
#line 542 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp17_, _tmp21_);
#line 542 "../src/sudoku-cell.vala"
		_g_free0 (_tmp21_);
#line 2622 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp22_;
		SudokuBoard* _tmp23_;
		SudokuBoard* _tmp24_;
#line 545 "../src/sudoku-cell.vala"
		_tmp22_ = self->priv->game;
#line 545 "../src/sudoku-cell.vala"
		_tmp23_ = sudoku_game_get_board (_tmp22_);
#line 545 "../src/sudoku-cell.vala"
		_tmp24_ = _tmp23_;
#line 545 "../src/sudoku-cell.vala"
		if (sudoku_board_count_possibilities (_tmp24_, self->priv->row, self->priv->col) == 0) {
#line 2635 "sudoku-cell.c"
			GtkLabel* _tmp25_;
#line 546 "../src/sudoku-cell.vala"
			_tmp25_ = self->priv->value_label;
#line 546 "../src/sudoku-cell.vala"
			gtk_label_set_label (_tmp25_, "X");
#line 2641 "sudoku-cell.c"
		}
	}
#line 548 "../src/sudoku-cell.vala"
	if (_error_) {
#line 549 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "error");
#line 2648 "sudoku-cell.c"
	} else {
#line 551 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 2652 "sudoku-cell.c"
	}
}

void
sudoku_cell_check_earmarks_warnings (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean* marks = NULL;
	SudokuGame* _tmp6_;
	SudokuBoard* _tmp7_;
	SudokuBoard* _tmp8_;
	gint _tmp9_ = 0;
	gboolean* _tmp10_;
	gint marks_length1;
	gint _marks_size_;
#line 554 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 556 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 556 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 556 "../src/sudoku-cell.vala"
	if (_tmp2_ != 0) {
#line 556 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 2680 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 556 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->game;
#line 556 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 556 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 556 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_ == GAME_MODE_CREATE;
#line 2693 "sudoku-cell.c"
	}
#line 556 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 557 "../src/sudoku-cell.vala"
		return;
#line 2699 "sudoku-cell.c"
	}
#line 559 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->game;
#line 559 "../src/sudoku-cell.vala"
	_tmp7_ = sudoku_game_get_board (_tmp6_);
#line 559 "../src/sudoku-cell.vala"
	_tmp8_ = _tmp7_;
#line 559 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_board_get_earmarks (_tmp8_, self->priv->row, self->priv->col, &_tmp9_);
#line 559 "../src/sudoku-cell.vala"
	marks = _tmp10_;
#line 559 "../src/sudoku-cell.vala"
	marks_length1 = _tmp9_;
#line 559 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 2715 "sudoku-cell.c"
	{
		gint num = 0;
#line 560 "../src/sudoku-cell.vala"
		num = 1;
#line 2720 "sudoku-cell.c"
		{
			gboolean _tmp11_ = FALSE;
#line 560 "../src/sudoku-cell.vala"
			_tmp11_ = TRUE;
#line 560 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2727 "sudoku-cell.c"
				gboolean* _tmp13_;
				gint _tmp13__length1;
				gboolean* _tmp14_;
				gint _tmp14__length1;
				gboolean _tmp15_;
#line 560 "../src/sudoku-cell.vala"
				if (!_tmp11_) {
#line 2735 "sudoku-cell.c"
					gint _tmp12_;
#line 560 "../src/sudoku-cell.vala"
					_tmp12_ = num;
#line 560 "../src/sudoku-cell.vala"
					num = _tmp12_ + 1;
#line 2741 "sudoku-cell.c"
				}
#line 560 "../src/sudoku-cell.vala"
				_tmp11_ = FALSE;
#line 560 "../src/sudoku-cell.vala"
				_tmp13_ = marks;
#line 560 "../src/sudoku-cell.vala"
				_tmp13__length1 = marks_length1;
#line 560 "../src/sudoku-cell.vala"
				if (!(num <= _tmp13__length1)) {
#line 560 "../src/sudoku-cell.vala"
					break;
#line 2753 "sudoku-cell.c"
				}
#line 562 "../src/sudoku-cell.vala"
				_tmp14_ = marks;
#line 562 "../src/sudoku-cell.vala"
				_tmp14__length1 = marks_length1;
#line 562 "../src/sudoku-cell.vala"
				_tmp15_ = _tmp14_[num - 1];
#line 562 "../src/sudoku-cell.vala"
				if (_tmp15_) {
#line 563 "../src/sudoku-cell.vala"
					sudoku_cell_check_earmark_warnings (self, num);
#line 2765 "sudoku-cell.c"
				}
			}
		}
	}
#line 554 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2772 "sudoku-cell.c"
}

void
sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                    gint num)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 567 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 569 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 569 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 569 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 569 "../src/sudoku-cell.vala"
	if (!sudoku_board_is_possible (_tmp2_, self->priv->row, self->priv->col, num)) {
#line 2792 "sudoku-cell.c"
		GtkLabel** _tmp3_;
		gint _tmp3__length1;
		GtkLabel* _tmp4_;
#line 570 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->earmark_labels;
#line 570 "../src/sudoku-cell.vala"
		_tmp3__length1 = self->priv->earmark_labels_length1;
#line 570 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_[num - 1];
#line 570 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp4_, "error");
#line 2804 "sudoku-cell.c"
	} else {
		GtkLabel** _tmp5_;
		gint _tmp5__length1;
		GtkLabel* _tmp6_;
#line 572 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->earmark_labels;
#line 572 "../src/sudoku-cell.vala"
		_tmp5__length1 = self->priv->earmark_labels_length1;
#line 572 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_[num - 1];
#line 572 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp6_, "error");
#line 2817 "sudoku-cell.c"
	}
}

void
sudoku_cell_clear_warnings (SudokuCell* self)
{
	gboolean* marks = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_ = 0;
	gboolean* _tmp4_;
	gint marks_length1;
	gint _marks_size_;
	GtkLabel* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 575 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 577 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 577 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 577 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 577 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_board_get_earmarks (_tmp2_, self->priv->row, self->priv->col, &_tmp3_);
#line 577 "../src/sudoku-cell.vala"
	marks = _tmp4_;
#line 577 "../src/sudoku-cell.vala"
	marks_length1 = _tmp3_;
#line 577 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 578 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->value_label;
#line 578 "../src/sudoku-cell.vala"
	_tmp6_ = sudoku_cell_get_value (self);
#line 578 "../src/sudoku-cell.vala"
	_tmp7_ = _tmp6_;
#line 578 "../src/sudoku-cell.vala"
	_tmp8_ = g_strdup_printf ("%i", _tmp7_);
#line 578 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_;
#line 578 "../src/sudoku-cell.vala"
	gtk_label_set_label (_tmp5_, _tmp9_);
#line 578 "../src/sudoku-cell.vala"
	_g_free0 (_tmp9_);
#line 579 "../src/sudoku-cell.vala"
	gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 2869 "sudoku-cell.c"
	{
		gint num = 0;
#line 580 "../src/sudoku-cell.vala"
		num = 1;
#line 2874 "sudoku-cell.c"
		{
			gboolean _tmp10_ = FALSE;
#line 580 "../src/sudoku-cell.vala"
			_tmp10_ = TRUE;
#line 580 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2881 "sudoku-cell.c"
				gboolean* _tmp12_;
				gint _tmp12__length1;
				GtkLabel** _tmp13_;
				gint _tmp13__length1;
				GtkLabel* _tmp14_;
#line 580 "../src/sudoku-cell.vala"
				if (!_tmp10_) {
#line 2889 "sudoku-cell.c"
					gint _tmp11_;
#line 580 "../src/sudoku-cell.vala"
					_tmp11_ = num;
#line 580 "../src/sudoku-cell.vala"
					num = _tmp11_ + 1;
#line 2895 "sudoku-cell.c"
				}
#line 580 "../src/sudoku-cell.vala"
				_tmp10_ = FALSE;
#line 580 "../src/sudoku-cell.vala"
				_tmp12_ = marks;
#line 580 "../src/sudoku-cell.vala"
				_tmp12__length1 = marks_length1;
#line 580 "../src/sudoku-cell.vala"
				if (!(num <= _tmp12__length1)) {
#line 580 "../src/sudoku-cell.vala"
					break;
#line 2907 "sudoku-cell.c"
				}
#line 581 "../src/sudoku-cell.vala"
				_tmp13_ = self->priv->earmark_labels;
#line 581 "../src/sudoku-cell.vala"
				_tmp13__length1 = self->priv->earmark_labels_length1;
#line 581 "../src/sudoku-cell.vala"
				_tmp14_ = _tmp13_[num - 1];
#line 581 "../src/sudoku-cell.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp14_, "error");
#line 2917 "sudoku-cell.c"
			}
		}
	}
#line 575 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2923 "sudoku-cell.c"
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
#line 584 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 586 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 588 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->value_label;
#line 588 "../src/sudoku-cell.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 2939 "sudoku-cell.c"
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 606 "../src/sudoku-cell.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 2947 "sudoku-cell.c"
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gint value_width = 0;
	gint value_height = 0;
	GskTransform* center = NULL;
	GskTransform* _tmp2_;
	graphene_point_t _tmp3_ = {0};
	graphene_point_t _tmp4_;
	GskTransform* _tmp5_;
	GtkLabel* _tmp6_;
	GskTransform* _tmp7_;
	GskTransform* _tmp8_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	SudokuBoard* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	SudokuGame* _tmp14_;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint num = 0;
#line 591 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 595 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 595 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 595 "../src/sudoku-cell.vala"
	gtk_popover_present (_tmp1_);
#line 598 "../src/sudoku-cell.vala"
	value_height = MIN (width, height);
#line 598 "../src/sudoku-cell.vala"
	value_width = value_height;
#line 600 "../src/sudoku-cell.vala"
	sudoku_cell_set_font_size (self, &self->priv->value_label, height / SUDOKU_CELL_size_ratio);
#line 602 "../src/sudoku-cell.vala"
	_tmp2_ = gsk_transform_new ();
#line 602 "../src/sudoku-cell.vala"
	memset (&_tmp3_, 0, sizeof (graphene_point_t));
#line 602 "../src/sudoku-cell.vala"
	_tmp4_ = *graphene_point_init (&_tmp3_, (gfloat) ((width - value_width) / 2), (gfloat) ((height - value_height) / 2));
#line 602 "../src/sudoku-cell.vala"
	_tmp5_ = gsk_transform_translate (_tmp2_, &_tmp4_);
#line 602 "../src/sudoku-cell.vala"
	center = _tmp5_;
#line 606 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->value_label;
#line 606 "../src/sudoku-cell.vala"
	_tmp7_ = center;
#line 606 "../src/sudoku-cell.vala"
	_tmp8_ = _gsk_transform_ref0 (_tmp7_);
#line 606 "../src/sudoku-cell.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp6_, value_width, value_height, baseline, _tmp8_);
#line 609 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->game;
#line 609 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 609 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 609 "../src/sudoku-cell.vala"
	_tmp12_ = sudoku_board_get_block_cols (_tmp11_);
#line 609 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_;
#line 609 "../src/sudoku-cell.vala"
	earmark_width = width / _tmp13_;
#line 610 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->game;
#line 610 "../src/sudoku-cell.vala"
	_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 610 "../src/sudoku-cell.vala"
	_tmp16_ = _tmp15_;
#line 610 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_board_get_block_rows (_tmp16_);
#line 610 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 610 "../src/sudoku-cell.vala"
	earmark_height = height / _tmp18_;
#line 612 "../src/sudoku-cell.vala"
	num = 0;
#line 3040 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 613 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 3045 "sudoku-cell.c"
		{
			gboolean _tmp19_ = FALSE;
#line 613 "../src/sudoku-cell.vala"
			_tmp19_ = TRUE;
#line 613 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 3052 "sudoku-cell.c"
				SudokuGame* _tmp21_;
				SudokuBoard* _tmp22_;
				SudokuBoard* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 613 "../src/sudoku-cell.vala"
				if (!_tmp19_) {
#line 3060 "sudoku-cell.c"
					gint _tmp20_;
#line 613 "../src/sudoku-cell.vala"
					_tmp20_ = row_tmp;
#line 613 "../src/sudoku-cell.vala"
					row_tmp = _tmp20_ + 1;
#line 3066 "sudoku-cell.c"
				}
#line 613 "../src/sudoku-cell.vala"
				_tmp19_ = FALSE;
#line 613 "../src/sudoku-cell.vala"
				_tmp21_ = self->priv->game;
#line 613 "../src/sudoku-cell.vala"
				_tmp22_ = sudoku_game_get_board (_tmp21_);
#line 613 "../src/sudoku-cell.vala"
				_tmp23_ = _tmp22_;
#line 613 "../src/sudoku-cell.vala"
				_tmp24_ = sudoku_board_get_block_rows (_tmp23_);
#line 613 "../src/sudoku-cell.vala"
				_tmp25_ = _tmp24_;
#line 613 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp25_)) {
#line 613 "../src/sudoku-cell.vala"
					break;
#line 3084 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 615 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 3090 "sudoku-cell.c"
					{
						gboolean _tmp26_ = FALSE;
#line 615 "../src/sudoku-cell.vala"
						_tmp26_ = TRUE;
#line 615 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 3097 "sudoku-cell.c"
							SudokuGame* _tmp28_;
							SudokuBoard* _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							GskTransform* earmark_position = NULL;
							GskTransform* _tmp35_;
							graphene_point_t _tmp36_ = {0};
							SudokuGame* _tmp37_;
							SudokuBoard* _tmp38_;
							SudokuBoard* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							graphene_point_t _tmp42_;
							GskTransform* _tmp43_;
							GtkLabel** _tmp44_;
							gint _tmp44__length1;
							GtkLabel* _tmp45_;
							GskTransform* _tmp46_;
							GskTransform* _tmp47_;
#line 615 "../src/sudoku-cell.vala"
							if (!_tmp26_) {
#line 3123 "sudoku-cell.c"
								gint _tmp27_;
#line 615 "../src/sudoku-cell.vala"
								_tmp27_ = col_tmp;
#line 615 "../src/sudoku-cell.vala"
								col_tmp = _tmp27_ + 1;
#line 3129 "sudoku-cell.c"
							}
#line 615 "../src/sudoku-cell.vala"
							_tmp26_ = FALSE;
#line 615 "../src/sudoku-cell.vala"
							_tmp28_ = self->priv->game;
#line 615 "../src/sudoku-cell.vala"
							_tmp29_ = sudoku_game_get_board (_tmp28_);
#line 615 "../src/sudoku-cell.vala"
							_tmp30_ = _tmp29_;
#line 615 "../src/sudoku-cell.vala"
							_tmp31_ = sudoku_board_get_block_cols (_tmp30_);
#line 615 "../src/sudoku-cell.vala"
							_tmp32_ = _tmp31_;
#line 615 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp32_)) {
#line 615 "../src/sudoku-cell.vala"
								break;
#line 3147 "sudoku-cell.c"
							}
#line 617 "../src/sudoku-cell.vala"
							_tmp33_ = num;
#line 617 "../src/sudoku-cell.vala"
							num = _tmp33_ + 1;
#line 619 "../src/sudoku-cell.vala"
							_tmp34_ = self->priv->earmark_labels;
#line 619 "../src/sudoku-cell.vala"
							_tmp34__length1 = self->priv->earmark_labels_length1;
#line 619 "../src/sudoku-cell.vala"
							sudoku_cell_set_font_size (self, &_tmp34_[num - 1], (height / SUDOKU_CELL_size_ratio) / 2);
#line 621 "../src/sudoku-cell.vala"
							_tmp35_ = gsk_transform_new ();
#line 621 "../src/sudoku-cell.vala"
							memset (&_tmp36_, 0, sizeof (graphene_point_t));
#line 621 "../src/sudoku-cell.vala"
							_tmp37_ = self->priv->game;
#line 621 "../src/sudoku-cell.vala"
							_tmp38_ = sudoku_game_get_board (_tmp37_);
#line 621 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_;
#line 621 "../src/sudoku-cell.vala"
							_tmp40_ = sudoku_board_get_block_rows (_tmp39_);
#line 621 "../src/sudoku-cell.vala"
							_tmp41_ = _tmp40_;
#line 621 "../src/sudoku-cell.vala"
							_tmp42_ = *graphene_point_init (&_tmp36_, (gfloat) (col_tmp * earmark_width), (gfloat) (((_tmp41_ - row_tmp) - 1) * earmark_height));
#line 621 "../src/sudoku-cell.vala"
							_tmp43_ = gsk_transform_translate (_tmp35_, &_tmp42_);
#line 621 "../src/sudoku-cell.vala"
							earmark_position = _tmp43_;
#line 626 "../src/sudoku-cell.vala"
							_tmp44_ = self->priv->earmark_labels;
#line 626 "../src/sudoku-cell.vala"
							_tmp44__length1 = self->priv->earmark_labels_length1;
#line 626 "../src/sudoku-cell.vala"
							_tmp45_ = _tmp44_[num - 1];
#line 626 "../src/sudoku-cell.vala"
							_tmp46_ = earmark_position;
#line 626 "../src/sudoku-cell.vala"
							_tmp47_ = _gsk_transform_ref0 (_tmp46_);
#line 626 "../src/sudoku-cell.vala"
							gtk_widget_allocate ((GtkWidget*) _tmp45_, earmark_width, earmark_height, baseline, _tmp47_);
#line 615 "../src/sudoku-cell.vala"
							_gsk_transform_unref0 (earmark_position);
#line 3193 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 591 "../src/sudoku-cell.vala"
	_gsk_transform_unref0 (center);
#line 3202 "sudoku-cell.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 633 "../src/sudoku-cell.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 3210 "sudoku-cell.c"
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel** label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
#line 631 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 631 "../src/sudoku-cell.vala"
	g_return_if_fail (*label != NULL);
#line 633 "../src/sudoku-cell.vala"
	_tmp0_ = gtk_label_get_attributes (*label);
#line 633 "../src/sudoku-cell.vala"
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
#line 633 "../src/sudoku-cell.vala"
	attr_list = _tmp1_;
#line 634 "../src/sudoku-cell.vala"
	_tmp2_ = attr_list;
#line 634 "../src/sudoku-cell.vala"
	if (_tmp2_ == NULL) {
#line 3239 "sudoku-cell.c"
		PangoAttrList* _tmp3_;
#line 635 "../src/sudoku-cell.vala"
		_tmp3_ = pango_attr_list_new ();
#line 635 "../src/sudoku-cell.vala"
		_pango_attr_list_unref0 (attr_list);
#line 635 "../src/sudoku-cell.vala"
		attr_list = _tmp3_;
#line 3247 "sudoku-cell.c"
	}
#line 637 "../src/sudoku-cell.vala"
	_tmp4_ = attr_list;
#line 637 "../src/sudoku-cell.vala"
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
#line 637 "../src/sudoku-cell.vala"
	pango_attr_list_change (_tmp4_, _tmp5_);
#line 641 "../src/sudoku-cell.vala"
	_tmp6_ = attr_list;
#line 641 "../src/sudoku-cell.vala"
	gtk_label_set_attributes (*label, _tmp6_);
#line 631 "../src/sudoku-cell.vala"
	_pango_attr_list_unref0 (attr_list);
#line 3261 "sudoku-cell.c"
}

void
sudoku_cell_dismiss_popover (SudokuCell* self)
{
	GtkPopover* _tmp0_;
#line 644 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->_popover;
#line 646 "../src/sudoku-cell.vala"
	if (_tmp0_ != NULL) {
#line 3274 "sudoku-cell.c"
		GtkPopover* _tmp1_;
#line 647 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->_popover;
#line 647 "../src/sudoku-cell.vala"
		gtk_popover_popdown (_tmp1_);
#line 3280 "sudoku-cell.c"
	}
}

GtkPopover*
sudoku_cell_get_popover (SudokuCell* self)
{
	GtkPopover* result;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp3_;
#line 41 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->_popover;
#line 42 "../src/sudoku-cell.vala"
	if (_tmp0_ == NULL) {
#line 3296 "sudoku-cell.c"
		GtkPopover* _tmp1_;
		GtkPopover* _tmp2_;
#line 44 "../src/sudoku-cell.vala"
		_tmp1_ = (GtkPopover*) gtk_popover_new ();
#line 44 "../src/sudoku-cell.vala"
		g_object_ref_sink (_tmp1_);
#line 44 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->_popover);
#line 44 "../src/sudoku-cell.vala"
		self->priv->_popover = _tmp1_;
#line 45 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->_popover;
#line 45 "../src/sudoku-cell.vala"
		gtk_popover_set_autohide (_tmp2_, FALSE);
#line 3311 "sudoku-cell.c"
	}
#line 47 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->_popover;
#line 47 "../src/sudoku-cell.vala"
	result = _tmp3_;
#line 47 "../src/sudoku-cell.vala"
	return result;
#line 3319 "sudoku-cell.c"
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 60 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 60 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 60 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/sudoku-cell.vala"
	result = sudoku_board_get (_tmp2_, self->priv->row, self->priv->col);
#line 60 "../src/sudoku-cell.vala"
	return result;
#line 3341 "sudoku-cell.c"
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuBoard* _tmp3_;
#line 61 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 62 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_game_get_board (_tmp1_);
#line 62 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 62 "../src/sudoku-cell.vala"
	if (value == sudoku_board_get (_tmp3_, self->priv->row, self->priv->col)) {
#line 62 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 3364 "sudoku-cell.c"
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 62 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_is_fixed (self);
#line 62 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 62 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_;
#line 3374 "sudoku-cell.c"
	}
#line 62 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 65 "../src/sudoku-cell.vala"
		return;
#line 3380 "sudoku-cell.c"
	}
#line 68 "../src/sudoku-cell.vala"
	if (value != 0) {
#line 3384 "sudoku-cell.c"
		GtkLabel* _tmp6_;
#line 69 "../src/sudoku-cell.vala"
		_tmp6_ = self->priv->value_label;
#line 69 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 3390 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp7_;
#line 71 "../src/sudoku-cell.vala"
		_tmp7_ = self->priv->value_label;
#line 71 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 3397 "sudoku-cell.c"
	}
#line 73 "../src/sudoku-cell.vala"
	if (value == 0) {
#line 3401 "sudoku-cell.c"
		SudokuGame* _tmp8_;
		SudokuBoard* _tmp9_;
		SudokuBoard* _tmp10_;
#line 75 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->game;
#line 75 "../src/sudoku-cell.vala"
		_tmp9_ = sudoku_game_get_board (_tmp8_);
#line 75 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_;
#line 75 "../src/sudoku-cell.vala"
		if (sudoku_board_get (_tmp10_, self->priv->row, self->priv->col) != 0) {
#line 3413 "sudoku-cell.c"
			SudokuGame* _tmp11_;
#line 76 "../src/sudoku-cell.vala"
			_tmp11_ = self->priv->game;
#line 76 "../src/sudoku-cell.vala"
			sudoku_game_remove (_tmp11_, self->priv->row, self->priv->col);
#line 3419 "sudoku-cell.c"
		}
	} else {
		GtkLabel* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		SudokuGame* _tmp15_;
#line 80 "../src/sudoku-cell.vala"
		_tmp12_ = self->priv->value_label;
#line 80 "../src/sudoku-cell.vala"
		_tmp13_ = g_strdup_printf ("%i", value);
#line 80 "../src/sudoku-cell.vala"
		_tmp14_ = _tmp13_;
#line 80 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp12_, _tmp14_);
#line 80 "../src/sudoku-cell.vala"
		_g_free0 (_tmp14_);
#line 81 "../src/sudoku-cell.vala"
		_tmp15_ = self->priv->game;
#line 81 "../src/sudoku-cell.vala"
		sudoku_game_insert (_tmp15_, self->priv->row, self->priv->col, value);
#line 3440 "sudoku-cell.c"
	}
#line 61 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
#line 3444 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 99 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 99 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 99 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 99 "../src/sudoku-cell.vala"
	result = sudoku_board_get_is_fixed (_tmp2_, self->priv->row, self->priv->col);
#line 99 "../src/sudoku-cell.vala"
	return result;
#line 3466 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
#line 104 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 104 "../src/sudoku-cell.vala"
	result = self->priv->_selected;
#line 104 "../src/sudoku-cell.vala"
	return result;
#line 3479 "sudoku-cell.c"
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
#line 105 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/sudoku-cell.vala"
	self->priv->_selected = value;
#line 108 "../src/sudoku-cell.vala"
	sudoku_cell_set_fixed_css (self, !value);
#line 109 "../src/sudoku-cell.vala"
	if (value) {
#line 110 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
#line 3496 "sudoku-cell.c"
	} else {
#line 112 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
#line 3500 "sudoku-cell.c"
	}
#line 105 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
#line 3504 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_background (SudokuCell* self)
{
	gboolean result;
#line 118 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 118 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_background;
#line 118 "../src/sudoku-cell.vala"
	return result;
#line 3517 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_background (SudokuCell* self,
                                        gboolean value)
{
#line 119 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = value;
#line 122 "../src/sudoku-cell.vala"
	sudoku_cell_set_fixed_css (self, !value);
#line 123 "../src/sudoku-cell.vala"
	if (value) {
#line 124 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-bg");
#line 3534 "sudoku-cell.c"
	} else {
#line 126 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-bg");
#line 3538 "sudoku-cell.c"
	}
#line 119 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY]);
#line 3542 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_value (SudokuCell* self)
{
	gboolean result;
#line 132 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 132 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_value;
#line 132 "../src/sudoku-cell.vala"
	return result;
#line 3555 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_value (SudokuCell* self,
                                   gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 133 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = value;
#line 136 "../src/sudoku-cell.vala"
	if (value) {
#line 136 "../src/sudoku-cell.vala"
		_tmp0_ = !gtk_widget_has_css_class ((GtkWidget*) self, "error");
#line 3571 "sudoku-cell.c"
	} else {
#line 136 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 3575 "sudoku-cell.c"
	}
#line 136 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 137 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-label");
#line 3581 "sudoku-cell.c"
	} else {
#line 139 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-label");
#line 3585 "sudoku-cell.c"
	}
#line 133 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY]);
#line 3589 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_paused (SudokuCell* self)
{
	gboolean result;
#line 145 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/sudoku-cell.vala"
	result = self->priv->_paused;
#line 145 "../src/sudoku-cell.vala"
	return result;
#line 3602 "sudoku-cell.c"
}

void
sudoku_cell_set_paused (SudokuCell* self,
                        gboolean value)
{
#line 146 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/sudoku-cell.vala"
	self->priv->_paused = value;
#line 149 "../src/sudoku-cell.vala"
	if (value) {
#line 150 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "paused");
#line 3617 "sudoku-cell.c"
	} else {
#line 152 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "paused");
#line 3621 "sudoku-cell.c"
	}
#line 146 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_PAUSED_PROPERTY]);
#line 3625 "sudoku-cell.c"
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/sudoku-cell.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
#line 24 "../src/sudoku-cell.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
#line 24 "../src/sudoku-cell.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_POPOVER_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_POPOVER_PROPERTY] = g_param_spec_object ("popover", "popover", "popover", gtk_popover_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_PAUSED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL] = g_signal_new ("will-open-popover", TYPE_SUDOKU_CELL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 233 "../src/sudoku-cell.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
#line 3664 "sudoku-cell.c"
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel** _tmp4_;
#line 24 "../src/sudoku-cell.vala"
	self->priv = sudoku_cell_get_instance_private (self);
#line 34 "../src/sudoku-cell.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 34 "../src/sudoku-cell.vala"
	self->priv->button_controller = _tmp0_;
#line 35 "../src/sudoku-cell.vala"
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 35 "../src/sudoku-cell.vala"
	self->priv->long_press_controller = _tmp1_;
#line 36 "../src/sudoku-cell.vala"
	_tmp2_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 36 "../src/sudoku-cell.vala"
	self->priv->key_controller = _tmp2_;
#line 38 "../src/sudoku-cell.vala"
	self->priv->_popover = NULL;
#line 53 "../src/sudoku-cell.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
#line 53 "../src/sudoku-cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 53 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp3_);
#line 53 "../src/sudoku-cell.vala"
	self->priv->value_label = _tmp3_;
#line 56 "../src/sudoku-cell.vala"
	_tmp4_ = g_new0 (GtkLabel*, 8 + 1);
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = _tmp4_;
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels_length1 = 8;
#line 56 "../src/sudoku-cell.vala"
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
#line 102 "../src/sudoku-cell.vala"
	self->priv->_selected = FALSE;
#line 116 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = FALSE;
#line 130 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = FALSE;
#line 143 "../src/sudoku-cell.vala"
	self->priv->_paused = FALSE;
#line 3716 "sudoku-cell.c"
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
#line 24 "../src/sudoku-cell.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
#line 30 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 34 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 35 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 36 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 38 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->_popover);
#line 53 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
#line 3741 "sudoku-cell.c"
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_POPOVER_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_object (value, sudoku_cell_get_popover (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_int (value, sudoku_cell_get_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_background (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_PAUSED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_paused (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3818 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3824 "sudoku-cell.c"
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, g_value_get_int (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_background (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_value (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_PAUSED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_paused (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3868 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3874 "sudoku-cell.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

