/* sudoku-printer.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-printer.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <adwaita.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_PRINTER (sudoku_printer_get_type ())
#define SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinter))
#define SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))
#define IS_SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PRINTER))
#define IS_SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PRINTER))
#define SUDOKU_PRINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))

typedef struct _SudokuPrinter SudokuPrinter;
typedef struct _SudokuPrinterClass SudokuPrinterClass;
typedef struct _SudokuPrinterPrivate SudokuPrinterPrivate;
enum  {
	SUDOKU_PRINTER_0_PROPERTY,
	SUDOKU_PRINTER_NUM_PROPERTIES
};
static GParamSpec* sudoku_printer_properties[SUDOKU_PRINTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _SudokuPrinter {
	GObject parent_instance;
	SudokuPrinterPrivate * priv;
};

struct _SudokuPrinterClass {
	GObjectClass parent_class;
};

struct _SudokuPrinterPrivate {
	GeeList* boards;
	GtkWindow* window;
	gint margin;
	gint n_sudokus;
	gint sudokus_per_page;
	GtkPrintOperation* print_op;
};

static gint SudokuPrinter_private_offset;
static gpointer sudoku_printer_parent_class = NULL;

VALA_EXTERN GType sudoku_printer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuPrinter, g_object_unref)
VALA_EXTERN GtkPrintOperationResult sudoku_printer_print_sudoku (SudokuPrinter* self);
VALA_EXTERN SudokuPrinter* sudoku_printer_new (GeeList* boards,
                                   gint sudokus_per_page,
                                   GtkWindow* window);
VALA_EXTERN SudokuPrinter* sudoku_printer_construct (GType object_type,
                                         GeeList* boards,
                                         gint sudokus_per_page,
                                         GtkWindow* window);
static void sudoku_printer_begin_print_cb (SudokuPrinter* self,
                                    GtkPrintOperation* operation,
                                    GtkPrintContext* context);
static void _sudoku_printer_begin_print_cb_gtk_print_operation_begin_print (GtkPrintOperation* _sender,
                                                                     GtkPrintContext* context,
                                                                     gpointer self);
static void sudoku_printer_draw_page_cb (SudokuPrinter* self,
                                  GtkPrintOperation* operation,
                                  GtkPrintContext* context,
                                  gint page_nr);
static void _sudoku_printer_draw_page_cb_gtk_print_operation_draw_page (GtkPrintOperation* _sender,
                                                                 GtkPrintContext* context,
                                                                 gint page_nr,
                                                                 gpointer self);
static void sudoku_printer_set_label_font (SudokuPrinter* self,
                                    cairo_t* cr);
static gdouble sudoku_printer_fit_squares_in_rectangle (SudokuPrinter* self,
                                                 gdouble width,
                                                 gdouble height,
                                                 gdouble label_height,
                                                 gint margin,
                                                 guint* across,
                                                 guint* down);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void sudoku_printer_draw_sudoku (SudokuPrinter* self,
                                 cairo_t* cr,
                                 SudokuBoard* sudoku_board,
                                 gdouble size,
                                 gdouble offset_x,
                                 gdouble offset_y);
static void sudoku_printer_finalize (GObject * obj);
static GType sudoku_printer_get_type_once (void);

static inline gpointer
sudoku_printer_get_instance_private (SudokuPrinter* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuPrinter_private_offset);
}

GtkPrintOperationResult
sudoku_printer_print_sudoku (SudokuPrinter* self)
{
	GError* _inner_error0_ = NULL;
	GtkPrintOperationResult result;
#line 35 "../src/sudoku-printer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 157 "sudoku-printer.c"
	{
		GtkPrintOperationResult _result_ = 0;
		GtkPrintOperation* _tmp0_;
		GtkWindow* _tmp1_;
#line 39 "../src/sudoku-printer.vala"
		_tmp0_ = self->priv->print_op;
#line 39 "../src/sudoku-printer.vala"
		_tmp1_ = self->priv->window;
#line 39 "../src/sudoku-printer.vala"
		_result_ = gtk_print_operation_run (_tmp0_, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG, _tmp1_, &_inner_error0_);
#line 39 "../src/sudoku-printer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "sudoku-printer.c"
			goto __catch0_g_error;
		}
#line 40 "../src/sudoku-printer.vala"
		result = _result_;
#line 40 "../src/sudoku-printer.vala"
		return result;
#line 177 "sudoku-printer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		AdwMessageDialog* dialog = NULL;
		GtkWindow* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		AdwMessageDialog* _tmp7_;
		AdwMessageDialog* _tmp8_;
		AdwMessageDialog* _tmp9_;
		AdwMessageDialog* _tmp10_;
#line 37 "../src/sudoku-printer.vala"
		e = _inner_error0_;
#line 37 "../src/sudoku-printer.vala"
		_inner_error0_ = NULL;
#line 45 "../src/sudoku-printer.vala"
		_tmp2_ = self->priv->window;
#line 45 "../src/sudoku-printer.vala"
		_tmp3_ = e;
#line 45 "../src/sudoku-printer.vala"
		_tmp4_ = _tmp3_->message;
#line 45 "../src/sudoku-printer.vala"
		_tmp5_ = g_strdup_printf ("%s\n%s", _ ("Error printing file:"), _tmp4_);
#line 45 "../src/sudoku-printer.vala"
		_tmp6_ = _tmp5_;
#line 45 "../src/sudoku-printer.vala"
		_tmp7_ = (AdwMessageDialog*) adw_message_dialog_new (_tmp2_, _tmp6_, NULL);
#line 45 "../src/sudoku-printer.vala"
		g_object_ref_sink (_tmp7_);
#line 45 "../src/sudoku-printer.vala"
		_tmp8_ = _tmp7_;
#line 45 "../src/sudoku-printer.vala"
		_g_free0 (_tmp6_);
#line 45 "../src/sudoku-printer.vala"
		dialog = _tmp8_;
#line 46 "../src/sudoku-printer.vala"
		_tmp9_ = dialog;
#line 46 "../src/sudoku-printer.vala"
		adw_message_dialog_add_response (_tmp9_, "close", _ ("Close"));
#line 47 "../src/sudoku-printer.vala"
		_tmp10_ = dialog;
#line 47 "../src/sudoku-printer.vala"
		gtk_window_present ((GtkWindow*) _tmp10_);
#line 37 "../src/sudoku-printer.vala"
		_g_object_unref0 (dialog);
#line 37 "../src/sudoku-printer.vala"
		_g_error_free0 (e);
#line 229 "sudoku-printer.c"
	}
	__finally0:
#line 37 "../src/sudoku-printer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "../src/sudoku-printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "../src/sudoku-printer.vala"
		g_clear_error (&_inner_error0_);
#line 37 "../src/sudoku-printer.vala"
		return 0;
#line 240 "sudoku-printer.c"
	}
#line 50 "../src/sudoku-printer.vala"
	result = GTK_PRINT_OPERATION_RESULT_ERROR;
#line 50 "../src/sudoku-printer.vala"
	return result;
#line 246 "sudoku-printer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/sudoku-printer.vala"
	return self ? g_object_ref (self) : NULL;
#line 254 "sudoku-printer.c"
}

static void
_sudoku_printer_begin_print_cb_gtk_print_operation_begin_print (GtkPrintOperation* _sender,
                                                                GtkPrintContext* context,
                                                                gpointer self)
{
#line 62 "../src/sudoku-printer.vala"
	sudoku_printer_begin_print_cb ((SudokuPrinter*) self, _sender, context);
#line 264 "sudoku-printer.c"
}

static void
_sudoku_printer_draw_page_cb_gtk_print_operation_draw_page (GtkPrintOperation* _sender,
                                                            GtkPrintContext* context,
                                                            gint page_nr,
                                                            gpointer self)
{
#line 63 "../src/sudoku-printer.vala"
	sudoku_printer_draw_page_cb ((SudokuPrinter*) self, _sender, context, page_nr);
#line 275 "sudoku-printer.c"
}

SudokuPrinter*
sudoku_printer_construct (GType object_type,
                          GeeList* boards,
                          gint sudokus_per_page,
                          GtkWindow* window)
{
	SudokuPrinter * self = NULL;
	GeeList* _tmp0_;
	GtkWindow* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkPrintOperation* _tmp4_;
	GtkPrintOperation* _tmp5_;
	GtkPrintOperation* _tmp6_;
#line 53 "../src/sudoku-printer.vala"
	g_return_val_if_fail (boards != NULL, NULL);
#line 53 "../src/sudoku-printer.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 53 "../src/sudoku-printer.vala"
	self = (SudokuPrinter*) g_object_new (object_type, NULL);
#line 55 "../src/sudoku-printer.vala"
	_tmp0_ = _g_object_ref0 (boards);
#line 55 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->boards);
#line 55 "../src/sudoku-printer.vala"
	self->priv->boards = _tmp0_;
#line 56 "../src/sudoku-printer.vala"
	_tmp1_ = _g_object_ref0 (window);
#line 56 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->window);
#line 56 "../src/sudoku-printer.vala"
	self->priv->window = _tmp1_;
#line 57 "../src/sudoku-printer.vala"
	self->priv->margin = 25;
#line 58 "../src/sudoku-printer.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) boards);
#line 58 "../src/sudoku-printer.vala"
	_tmp3_ = _tmp2_;
#line 58 "../src/sudoku-printer.vala"
	self->priv->n_sudokus = _tmp3_;
#line 59 "../src/sudoku-printer.vala"
	self->priv->sudokus_per_page = sudokus_per_page;
#line 61 "../src/sudoku-printer.vala"
	_tmp4_ = gtk_print_operation_new ();
#line 61 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->print_op);
#line 61 "../src/sudoku-printer.vala"
	self->priv->print_op = _tmp4_;
#line 62 "../src/sudoku-printer.vala"
	_tmp5_ = self->priv->print_op;
#line 62 "../src/sudoku-printer.vala"
	g_signal_connect_object (_tmp5_, "begin-print", (GCallback) _sudoku_printer_begin_print_cb_gtk_print_operation_begin_print, self, 0);
#line 63 "../src/sudoku-printer.vala"
	_tmp6_ = self->priv->print_op;
#line 63 "../src/sudoku-printer.vala"
	g_signal_connect_object (_tmp6_, "draw-page", (GCallback) _sudoku_printer_draw_page_cb_gtk_print_operation_draw_page, self, 0);
#line 53 "../src/sudoku-printer.vala"
	return self;
#line 336 "sudoku-printer.c"
}

SudokuPrinter*
sudoku_printer_new (GeeList* boards,
                    gint sudokus_per_page,
                    GtkWindow* window)
{
#line 53 "../src/sudoku-printer.vala"
	return sudoku_printer_construct (TYPE_SUDOKU_PRINTER, boards, sudokus_per_page, window);
#line 346 "sudoku-printer.c"
}

static void
sudoku_printer_begin_print_cb (SudokuPrinter* self,
                               GtkPrintOperation* operation,
                               GtkPrintContext* context)
{
	gint pages = 0;
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (operation != NULL);
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (context != NULL);
#line 68 "../src/sudoku-printer.vala"
	pages = self->priv->n_sudokus / self->priv->sudokus_per_page;
#line 69 "../src/sudoku-printer.vala"
	while (TRUE) {
#line 69 "../src/sudoku-printer.vala"
		if (!((pages * self->priv->sudokus_per_page) < self->priv->n_sudokus)) {
#line 69 "../src/sudoku-printer.vala"
			break;
#line 369 "sudoku-printer.c"
		}
#line 70 "../src/sudoku-printer.vala"
		pages += 1;
#line 373 "sudoku-printer.c"
	}
#line 72 "../src/sudoku-printer.vala"
	gtk_print_operation_set_n_pages (operation, pages);
#line 377 "sudoku-printer.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 77 "../src/sudoku-printer.vala"
	return self ? cairo_reference (self) : NULL;
#line 385 "sudoku-printer.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 106 "../src/sudoku-printer.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 393 "sudoku-printer.c"
}

static void
sudoku_printer_draw_page_cb (SudokuPrinter* self,
                             GtkPrintOperation* operation,
                             GtkPrintContext* context,
                             gint page_nr)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble width = 0.0;
	gdouble height = 0.0;
	cairo_t* _tmp2_;
	cairo_text_extents_t label_extents = {0};
	cairo_t* _tmp3_;
	cairo_text_extents_t _tmp4_ = {0};
	guint n_across = 0U;
	guint n_down = 0U;
	gdouble best_square_size = 0.0;
	cairo_text_extents_t _tmp5_;
	guint _tmp6_ = 0U;
	guint _tmp7_ = 0U;
	gdouble _tmp8_;
	gdouble margin_x = 0.0;
	gdouble margin_y = 0.0;
	gint start = 0;
	gint end = 0;
	GeeList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GeeList* sudokus_on_page = NULL;
	GeeList* _tmp12_;
	GeeList* _tmp13_;
	guint index = 0U;
	PangoContext* pango_context = NULL;
	cairo_t* _tmp14_;
	PangoContext* _tmp15_;
	PangoContext* _tmp16_;
	GtkWindow* _tmp17_;
	cairo_font_options_t* _tmp18_;
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (operation != NULL);
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (context != NULL);
#line 77 "../src/sudoku-printer.vala"
	_tmp0_ = gtk_print_context_get_cairo_context (context);
#line 77 "../src/sudoku-printer.vala"
	_tmp1_ = _cairo_reference0 (_tmp0_);
#line 77 "../src/sudoku-printer.vala"
	cr = _tmp1_;
#line 78 "../src/sudoku-printer.vala"
	width = gtk_print_context_get_width (context);
#line 79 "../src/sudoku-printer.vala"
	height = gtk_print_context_get_height (context);
#line 81 "../src/sudoku-printer.vala"
	_tmp2_ = cr;
#line 81 "../src/sudoku-printer.vala"
	sudoku_printer_set_label_font (self, _tmp2_);
#line 83 "../src/sudoku-printer.vala"
	_tmp3_ = cr;
#line 83 "../src/sudoku-printer.vala"
	cairo_text_extents (_tmp3_, "Ww", &_tmp4_);
#line 83 "../src/sudoku-printer.vala"
	label_extents = _tmp4_;
#line 86 "../src/sudoku-printer.vala"
	_tmp5_ = label_extents;
#line 86 "../src/sudoku-printer.vala"
	_tmp8_ = sudoku_printer_fit_squares_in_rectangle (self, width, height, _tmp5_.height, self->priv->margin, &_tmp6_, &_tmp7_);
#line 86 "../src/sudoku-printer.vala"
	n_across = _tmp6_;
#line 86 "../src/sudoku-printer.vala"
	n_down = _tmp7_;
#line 86 "../src/sudoku-printer.vala"
	best_square_size = _tmp8_;
#line 87 "../src/sudoku-printer.vala"
	margin_x = (width - (best_square_size * n_across)) / (n_across + 1);
#line 88 "../src/sudoku-printer.vala"
	margin_y = (height - (best_square_size * n_down)) / (n_down + 1);
#line 90 "../src/sudoku-printer.vala"
	start = page_nr * self->priv->sudokus_per_page;
#line 91 "../src/sudoku-printer.vala"
	_tmp9_ = self->priv->boards;
#line 91 "../src/sudoku-printer.vala"
	_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
#line 91 "../src/sudoku-printer.vala"
	_tmp11_ = _tmp10_;
#line 91 "../src/sudoku-printer.vala"
	end = MIN (start + self->priv->sudokus_per_page, _tmp11_);
#line 92 "../src/sudoku-printer.vala"
	_tmp12_ = self->priv->boards;
#line 92 "../src/sudoku-printer.vala"
	_tmp13_ = gee_list_slice (_tmp12_, start, end);
#line 92 "../src/sudoku-printer.vala"
	sudokus_on_page = _tmp13_;
#line 94 "../src/sudoku-printer.vala"
	index = (guint) 0;
#line 96 "../src/sudoku-printer.vala"
	_tmp14_ = cr;
#line 96 "../src/sudoku-printer.vala"
	_tmp15_ = pango_cairo_create_context (_tmp14_);
#line 96 "../src/sudoku-printer.vala"
	pango_context = _tmp15_;
#line 97 "../src/sudoku-printer.vala"
	_tmp16_ = pango_context;
#line 97 "../src/sudoku-printer.vala"
	_tmp17_ = self->priv->window;
#line 97 "../src/sudoku-printer.vala"
	_tmp18_ = gtk_widget_get_font_options ((GtkWidget*) _tmp17_);
#line 97 "../src/sudoku-printer.vala"
	pango_cairo_context_set_font_options (_tmp16_, _tmp18_);
#line 507 "sudoku-printer.c"
	{
		GeeList* _sudoku_list = NULL;
		GeeList* _tmp19_;
		gint _sudoku_size = 0;
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _sudoku_index = 0;
#line 99 "../src/sudoku-printer.vala"
		_tmp19_ = sudokus_on_page;
#line 99 "../src/sudoku-printer.vala"
		_sudoku_list = _tmp19_;
#line 99 "../src/sudoku-printer.vala"
		_tmp20_ = _sudoku_list;
#line 99 "../src/sudoku-printer.vala"
		_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 99 "../src/sudoku-printer.vala"
		_tmp22_ = _tmp21_;
#line 99 "../src/sudoku-printer.vala"
		_sudoku_size = _tmp22_;
#line 99 "../src/sudoku-printer.vala"
		_sudoku_index = -1;
#line 99 "../src/sudoku-printer.vala"
		while (TRUE) {
#line 532 "sudoku-printer.c"
			gint _tmp23_;
			gint _tmp24_;
			SudokuBoard* sudoku = NULL;
			GeeList* _tmp25_;
			gpointer _tmp26_;
			gdouble left = 0.0;
			gdouble top = 0.0;
			cairo_text_extents_t _tmp27_;
			cairo_text_extents_t _tmp28_;
			gchar* label = NULL;
			SudokuBoard* _tmp29_;
			DifficultyCategory _tmp30_;
			DifficultyCategory _tmp31_;
			gchar* _tmp32_;
			PangoLayout* layout = NULL;
			PangoContext* _tmp33_;
			PangoLayout* _tmp34_;
			PangoLayout* _tmp35_;
			PangoFontDescription* _tmp36_;
			PangoFontDescription* _tmp37_;
			PangoLayout* _tmp38_;
			const gchar* _tmp39_;
			gint layout_width = 0;
			gint layout_height = 0;
			PangoLayout* _tmp40_;
			gint _tmp41_ = 0;
			gint _tmp42_ = 0;
			cairo_t* _tmp43_;
			cairo_t* _tmp44_;
			cairo_t* _tmp45_;
			PangoLayout* _tmp46_;
			cairo_t* _tmp47_;
			SudokuBoard* _tmp48_;
#line 99 "../src/sudoku-printer.vala"
			_sudoku_index = _sudoku_index + 1;
#line 99 "../src/sudoku-printer.vala"
			_tmp23_ = _sudoku_index;
#line 99 "../src/sudoku-printer.vala"
			_tmp24_ = _sudoku_size;
#line 99 "../src/sudoku-printer.vala"
			if (!(_tmp23_ < _tmp24_)) {
#line 99 "../src/sudoku-printer.vala"
				break;
#line 576 "sudoku-printer.c"
			}
#line 99 "../src/sudoku-printer.vala"
			_tmp25_ = _sudoku_list;
#line 99 "../src/sudoku-printer.vala"
			_tmp26_ = gee_list_get (_tmp25_, _sudoku_index);
#line 99 "../src/sudoku-printer.vala"
			sudoku = (SudokuBoard*) _tmp26_;
#line 101 "../src/sudoku-printer.vala"
			left = margin_x + ((index % n_across) * (best_square_size + margin_x));
#line 102 "../src/sudoku-printer.vala"
			_tmp27_ = label_extents;
#line 102 "../src/sudoku-printer.vala"
			_tmp28_ = label_extents;
#line 102 "../src/sudoku-printer.vala"
			top = (margin_y + _tmp27_.height) + ((index / n_across) * ((best_square_size + margin_y) + _tmp28_.height));
#line 104 "../src/sudoku-printer.vala"
			_tmp29_ = sudoku;
#line 104 "../src/sudoku-printer.vala"
			_tmp30_ = sudoku_board_get_difficulty_category (_tmp29_);
#line 104 "../src/sudoku-printer.vala"
			_tmp31_ = _tmp30_;
#line 104 "../src/sudoku-printer.vala"
			_tmp32_ = difficulty_category_to_string (_tmp31_);
#line 104 "../src/sudoku-printer.vala"
			label = _tmp32_;
#line 105 "../src/sudoku-printer.vala"
			_tmp33_ = pango_context;
#line 105 "../src/sudoku-printer.vala"
			_tmp34_ = pango_layout_new (_tmp33_);
#line 105 "../src/sudoku-printer.vala"
			layout = _tmp34_;
#line 106 "../src/sudoku-printer.vala"
			_tmp35_ = layout;
#line 106 "../src/sudoku-printer.vala"
			_tmp36_ = pango_font_description_from_string ("Sans Bold 9");
#line 106 "../src/sudoku-printer.vala"
			_tmp37_ = _tmp36_;
#line 106 "../src/sudoku-printer.vala"
			pango_layout_set_font_description (_tmp35_, _tmp37_);
#line 106 "../src/sudoku-printer.vala"
			__vala_PangoFontDescription_free0 (_tmp37_);
#line 107 "../src/sudoku-printer.vala"
			_tmp38_ = layout;
#line 107 "../src/sudoku-printer.vala"
			_tmp39_ = label;
#line 107 "../src/sudoku-printer.vala"
			pango_layout_set_text (_tmp38_, _tmp39_, -1);
#line 111 "../src/sudoku-printer.vala"
			_tmp40_ = layout;
#line 111 "../src/sudoku-printer.vala"
			pango_layout_get_size (_tmp40_, &_tmp41_, &_tmp42_);
#line 111 "../src/sudoku-printer.vala"
			layout_width = _tmp41_;
#line 111 "../src/sudoku-printer.vala"
			layout_height = _tmp42_;
#line 112 "../src/sudoku-printer.vala"
			layout_width /= PANGO_SCALE;
#line 113 "../src/sudoku-printer.vala"
			layout_height /= PANGO_SCALE;
#line 114 "../src/sudoku-printer.vala"
			_tmp43_ = cr;
#line 114 "../src/sudoku-printer.vala"
			cairo_move_to (_tmp43_, left + ((best_square_size - layout_width) / 2), top - layout_height);
#line 115 "../src/sudoku-printer.vala"
			_tmp44_ = cr;
#line 115 "../src/sudoku-printer.vala"
			cairo_set_source_rgb (_tmp44_, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 116 "../src/sudoku-printer.vala"
			_tmp45_ = cr;
#line 116 "../src/sudoku-printer.vala"
			_tmp46_ = layout;
#line 116 "../src/sudoku-printer.vala"
			pango_cairo_show_layout (_tmp45_, _tmp46_);
#line 118 "../src/sudoku-printer.vala"
			_tmp47_ = cr;
#line 118 "../src/sudoku-printer.vala"
			_tmp48_ = sudoku;
#line 118 "../src/sudoku-printer.vala"
			sudoku_printer_draw_sudoku (self, _tmp47_, _tmp48_, best_square_size, left, top);
#line 120 "../src/sudoku-printer.vala"
			index += (guint) 1;
#line 99 "../src/sudoku-printer.vala"
			_g_object_unref0 (layout);
#line 99 "../src/sudoku-printer.vala"
			_g_free0 (label);
#line 99 "../src/sudoku-printer.vala"
			_g_object_unref0 (sudoku);
#line 664 "sudoku-printer.c"
		}
	}
#line 75 "../src/sudoku-printer.vala"
	_g_object_unref0 (pango_context);
#line 75 "../src/sudoku-printer.vala"
	_g_object_unref0 (sudokus_on_page);
#line 75 "../src/sudoku-printer.vala"
	_cairo_destroy0 (cr);
#line 673 "sudoku-printer.c"
}

static void
sudoku_printer_set_label_font (SudokuPrinter* self,
                               cairo_t* cr)
{
#line 124 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/sudoku-printer.vala"
	g_return_if_fail (cr != NULL);
#line 126 "../src/sudoku-printer.vala"
	cairo_set_font_size (cr, (gdouble) 12);
#line 127 "../src/sudoku-printer.vala"
	cairo_select_font_face (cr, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 688 "sudoku-printer.c"
}

static gdouble
sudoku_printer_fit_squares_in_rectangle (SudokuPrinter* self,
                                         gdouble width,
                                         gdouble height,
                                         gdouble label_height,
                                         gint margin,
                                         guint* across,
                                         guint* down)
{
	guint _vala_across = 0U;
	guint _vala_down = 0U;
	gint n = 0;
	gdouble best_square_size = 0.0;
	gdouble square_size = 0.0;
	gdouble result;
#line 130 "../src/sudoku-printer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 132 "../src/sudoku-printer.vala"
	n = self->priv->sudokus_per_page;
#line 133 "../src/sudoku-printer.vala"
	best_square_size = 0.0;
#line 134 "../src/sudoku-printer.vala"
	square_size = 0.0;
#line 135 "../src/sudoku-printer.vala"
	_vala_across = (guint) 1;
#line 136 "../src/sudoku-printer.vala"
	_vala_down = (guint) n;
#line 718 "sudoku-printer.c"
	{
		gint n_across = 0;
#line 138 "../src/sudoku-printer.vala"
		n_across = 1;
#line 723 "sudoku-printer.c"
		{
			gboolean _tmp0_ = FALSE;
#line 138 "../src/sudoku-printer.vala"
			_tmp0_ = TRUE;
#line 138 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 730 "sudoku-printer.c"
				gint n_down = 0;
				gdouble across_size = 0.0;
				gdouble down_size = 0.0;
#line 138 "../src/sudoku-printer.vala"
				if (!_tmp0_) {
#line 736 "sudoku-printer.c"
					gint _tmp1_;
#line 138 "../src/sudoku-printer.vala"
					_tmp1_ = n_across;
#line 138 "../src/sudoku-printer.vala"
					n_across = _tmp1_ + 1;
#line 742 "sudoku-printer.c"
				}
#line 138 "../src/sudoku-printer.vala"
				_tmp0_ = FALSE;
#line 138 "../src/sudoku-printer.vala"
				if (!(n_across <= n)) {
#line 138 "../src/sudoku-printer.vala"
					break;
#line 750 "sudoku-printer.c"
				}
#line 140 "../src/sudoku-printer.vala"
				n_down = ((n + n_across) - 1) / n_across;
#line 141 "../src/sudoku-printer.vala"
				across_size = width - ((n_across + 1) * margin);
#line 142 "../src/sudoku-printer.vala"
				across_size = across_size / n_across;
#line 143 "../src/sudoku-printer.vala"
				down_size = (height - ((n_down + 1) * margin)) - (n_down * label_height);
#line 144 "../src/sudoku-printer.vala"
				down_size = down_size / n_down;
#line 146 "../src/sudoku-printer.vala"
				square_size = MIN (across_size, down_size);
#line 147 "../src/sudoku-printer.vala"
				if (square_size > best_square_size) {
#line 149 "../src/sudoku-printer.vala"
					best_square_size = square_size;
#line 150 "../src/sudoku-printer.vala"
					_vala_across = (guint) n_across;
#line 151 "../src/sudoku-printer.vala"
					_vala_down = (guint) n_down;
#line 772 "sudoku-printer.c"
				}
			}
		}
	}
#line 155 "../src/sudoku-printer.vala"
	result = best_square_size;
#line 155 "../src/sudoku-printer.vala"
	if (across) {
#line 155 "../src/sudoku-printer.vala"
		*across = _vala_across;
#line 783 "sudoku-printer.c"
	}
#line 155 "../src/sudoku-printer.vala"
	if (down) {
#line 155 "../src/sudoku-printer.vala"
		*down = _vala_down;
#line 789 "sudoku-printer.c"
	}
#line 155 "../src/sudoku-printer.vala"
	return result;
#line 793 "sudoku-printer.c"
}

static void
sudoku_printer_draw_sudoku (SudokuPrinter* self,
                            cairo_t* cr,
                            SudokuBoard* sudoku_board,
                            gdouble size,
                            gdouble offset_x,
                            gdouble offset_y)
{
#line 160 "../src/sudoku-printer.vala"
	static const gint SUDOKU_SIZE = 9;
#line 161 "../src/sudoku-printer.vala"
	static const gint N_BOXES = 3;
#line 162 "../src/sudoku-printer.vala"
	static const gdouble PENCIL_GREY[3] = {0.3, 0.3, 0.3};
#line 163 "../src/sudoku-printer.vala"
	static const gdouble BACKGROUND_COLOR[3] = {1.0, 1.0, 1.0};
#line 165 "../src/sudoku-printer.vala"
	static const gdouble BORDER_COLOR[3] = {1.0, 1.0, 1.0};
#line 166 "../src/sudoku-printer.vala"
	static const gdouble LINE_COLOR[3] = {0.0, 0.0, 0.0};
#line 816 "sudoku-printer.c"
	gdouble THIN = 0.0;
	gdouble THICK = 0.0;
	gdouble BORDER = 0.0;
	gdouble WHITE_SPACE = 0.0;
	gdouble SQUARE_SIZE = 0.0;
	gint FONT_SIZE = 0;
#line 175 "../src/sudoku-printer.vala"
	static const cairo_font_weight_t FONT_WEIGHT = CAIRO_FONT_WEIGHT_NORMAL;
#line 825 "sudoku-printer.c"
	gdouble* outer = NULL;
	gdouble* _tmp0_;
	gint outer_length1;
	gint _outer_size_;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble _tmp2_;
	gdouble* _tmp3_;
	gint _tmp3__length1;
	gdouble _tmp4_;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gdouble _tmp6_;
	gdouble* _tmp7_;
	gint _tmp7__length1;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble* _tmp15_;
	gint _tmp15__length1;
	gdouble _tmp16_;
	gdouble* _tmp17_;
	gint _tmp17__length1;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble* pos = NULL;
	gdouble* _tmp22_;
	gint pos_length1;
	gint _pos_size_;
	gdouble position = 0.0;
	gdouble* _tmp23_;
	gint _tmp23__length1;
	gdouble last_line = 0.0;
	gchar* letter = NULL;
	gchar* _tmp27_;
	cairo_text_extents_t extents = {0};
	gint* sudoku = NULL;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	gint* _tmp30_;
	gint sudoku_length1;
	gint sudoku_length2;
	gboolean invert = FALSE;
#line 158 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/sudoku-printer.vala"
	g_return_if_fail (cr != NULL);
#line 158 "../src/sudoku-printer.vala"
	g_return_if_fail (sudoku_board != NULL);
#line 168 "../src/sudoku-printer.vala"
	THIN = size / 500.0;
#line 169 "../src/sudoku-printer.vala"
	THICK = THIN * 5;
#line 170 "../src/sudoku-printer.vala"
	BORDER = THICK;
#line 171 "../src/sudoku-printer.vala"
	WHITE_SPACE = (((size - (2 * BORDER)) - (2 * THICK)) - ((N_BOXES - 1) * THICK)) - ((N_BOXES * 2) * THIN);
#line 172 "../src/sudoku-printer.vala"
	SQUARE_SIZE = WHITE_SPACE / SUDOKU_SIZE;
#line 174 "../src/sudoku-printer.vala"
	FONT_SIZE = ((gint) SQUARE_SIZE) / 2;
#line 177 "../src/sudoku-printer.vala"
	_tmp0_ = g_new0 (gdouble, 4);
#line 177 "../src/sudoku-printer.vala"
	_tmp0_[0] = offset_x;
#line 177 "../src/sudoku-printer.vala"
	_tmp0_[1] = offset_x + size;
#line 177 "../src/sudoku-printer.vala"
	_tmp0_[2] = offset_y;
#line 177 "../src/sudoku-printer.vala"
	_tmp0_[3] = offset_y + size;
#line 177 "../src/sudoku-printer.vala"
	outer = _tmp0_;
#line 177 "../src/sudoku-printer.vala"
	outer_length1 = 4;
#line 177 "../src/sudoku-printer.vala"
	_outer_size_ = outer_length1;
#line 180 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, 1.0, 1.0, 1.0);
#line 181 "../src/sudoku-printer.vala"
	_tmp1_ = outer;
#line 181 "../src/sudoku-printer.vala"
	_tmp1__length1 = outer_length1;
#line 181 "../src/sudoku-printer.vala"
	_tmp2_ = _tmp1_[0];
#line 181 "../src/sudoku-printer.vala"
	_tmp3_ = outer;
#line 181 "../src/sudoku-printer.vala"
	_tmp3__length1 = outer_length1;
#line 181 "../src/sudoku-printer.vala"
	_tmp4_ = _tmp3_[2];
#line 181 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, _tmp2_, _tmp4_, size, size);
#line 182 "../src/sudoku-printer.vala"
	cairo_fill (cr);
#line 185 "../src/sudoku-printer.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 186 "../src/sudoku-printer.vala"
	cairo_set_line_width (cr, BORDER);
#line 187 "../src/sudoku-printer.vala"
	_tmp5_ = outer;
#line 187 "../src/sudoku-printer.vala"
	_tmp5__length1 = outer_length1;
#line 187 "../src/sudoku-printer.vala"
	_tmp6_ = _tmp5_[0];
#line 187 "../src/sudoku-printer.vala"
	_tmp7_ = outer;
#line 187 "../src/sudoku-printer.vala"
	_tmp7__length1 = outer_length1;
#line 187 "../src/sudoku-printer.vala"
	_tmp8_ = _tmp7_[2];
#line 187 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, _tmp6_ + (BORDER / 2.0), _tmp8_ + (BORDER / 2.0), size - BORDER, size - BORDER);
#line 190 "../src/sudoku-printer.vala"
	_tmp9_ = BACKGROUND_COLOR[0];
#line 190 "../src/sudoku-printer.vala"
	_tmp10_ = BACKGROUND_COLOR[1];
#line 190 "../src/sudoku-printer.vala"
	_tmp11_ = BACKGROUND_COLOR[2];
#line 190 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp9_, _tmp10_, _tmp11_);
#line 191 "../src/sudoku-printer.vala"
	cairo_fill_preserve (cr);
#line 193 "../src/sudoku-printer.vala"
	_tmp12_ = BORDER_COLOR[0];
#line 193 "../src/sudoku-printer.vala"
	_tmp13_ = BORDER_COLOR[1];
#line 193 "../src/sudoku-printer.vala"
	_tmp14_ = BORDER_COLOR[2];
#line 193 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp12_, _tmp13_, _tmp14_);
#line 194 "../src/sudoku-printer.vala"
	cairo_stroke (cr);
#line 197 "../src/sudoku-printer.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_MITER);
#line 198 "../src/sudoku-printer.vala"
	cairo_set_line_width (cr, THICK);
#line 199 "../src/sudoku-printer.vala"
	_tmp15_ = outer;
#line 199 "../src/sudoku-printer.vala"
	_tmp15__length1 = outer_length1;
#line 199 "../src/sudoku-printer.vala"
	_tmp16_ = _tmp15_[0];
#line 199 "../src/sudoku-printer.vala"
	_tmp17_ = outer;
#line 199 "../src/sudoku-printer.vala"
	_tmp17__length1 = outer_length1;
#line 199 "../src/sudoku-printer.vala"
	_tmp18_ = _tmp17_[2];
#line 199 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, (_tmp16_ + BORDER) + (THICK / 2.0), (_tmp18_ + BORDER) + (THICK / 2.0), (size - (BORDER * 2)) - THICK, (size - (BORDER * 2)) - THICK);
#line 200 "../src/sudoku-printer.vala"
	_tmp19_ = LINE_COLOR[0];
#line 200 "../src/sudoku-printer.vala"
	_tmp20_ = LINE_COLOR[1];
#line 200 "../src/sudoku-printer.vala"
	_tmp21_ = LINE_COLOR[2];
#line 200 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp19_, _tmp20_, _tmp21_);
#line 201 "../src/sudoku-printer.vala"
	cairo_stroke (cr);
#line 203 "../src/sudoku-printer.vala"
	_tmp22_ = g_new0 (gdouble, SUDOKU_SIZE + 1);
#line 203 "../src/sudoku-printer.vala"
	pos = _tmp22_;
#line 203 "../src/sudoku-printer.vala"
	pos_length1 = SUDOKU_SIZE + 1;
#line 203 "../src/sudoku-printer.vala"
	_pos_size_ = pos_length1;
#line 204 "../src/sudoku-printer.vala"
	position = BORDER + THICK;
#line 205 "../src/sudoku-printer.vala"
	_tmp23_ = pos;
#line 205 "../src/sudoku-printer.vala"
	_tmp23__length1 = pos_length1;
#line 205 "../src/sudoku-printer.vala"
	_tmp23_[0] = position + (SQUARE_SIZE / 2.0);
#line 206 "../src/sudoku-printer.vala"
	last_line = 0.0;
#line 1011 "sudoku-printer.c"
	{
		gint n = 0;
#line 208 "../src/sudoku-printer.vala"
		n = 1;
#line 1016 "sudoku-printer.c"
		{
			gboolean _tmp24_ = FALSE;
#line 208 "../src/sudoku-printer.vala"
			_tmp24_ = TRUE;
#line 208 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 1023 "sudoku-printer.c"
				gdouble* _tmp26_;
				gint _tmp26__length1;
#line 208 "../src/sudoku-printer.vala"
				if (!_tmp24_) {
#line 1028 "sudoku-printer.c"
					gint _tmp25_;
#line 208 "../src/sudoku-printer.vala"
					_tmp25_ = n;
#line 208 "../src/sudoku-printer.vala"
					n = _tmp25_ + 1;
#line 1034 "sudoku-printer.c"
				}
#line 208 "../src/sudoku-printer.vala"
				_tmp24_ = FALSE;
#line 208 "../src/sudoku-printer.vala"
				if (!(n <= SUDOKU_SIZE)) {
#line 208 "../src/sudoku-printer.vala"
					break;
#line 1042 "sudoku-printer.c"
				}
#line 210 "../src/sudoku-printer.vala"
				if ((n % N_BOXES) == 0) {
#line 212 "../src/sudoku-printer.vala"
					cairo_set_line_width (cr, THICK);
#line 213 "../src/sudoku-printer.vala"
					position += (SQUARE_SIZE + (last_line / 2.0)) + (THICK / 2.0);
#line 214 "../src/sudoku-printer.vala"
					last_line = THICK;
#line 1052 "sudoku-printer.c"
				} else {
#line 218 "../src/sudoku-printer.vala"
					cairo_set_line_width (cr, THIN);
#line 219 "../src/sudoku-printer.vala"
					position += (SQUARE_SIZE + (last_line / 2.0)) + (THIN / 2.0);
#line 220 "../src/sudoku-printer.vala"
					last_line = THIN;
#line 1060 "sudoku-printer.c"
				}
#line 223 "../src/sudoku-printer.vala"
				_tmp26_ = pos;
#line 223 "../src/sudoku-printer.vala"
				_tmp26__length1 = pos_length1;
#line 223 "../src/sudoku-printer.vala"
				_tmp26_[n] = (position + (last_line / 2.0)) + (SQUARE_SIZE / 2.0);
#line 224 "../src/sudoku-printer.vala"
				cairo_move_to (cr, (BORDER + (THICK / 2.0)) + offset_x, position + offset_y);
#line 225 "../src/sudoku-printer.vala"
				cairo_line_to (cr, ((size - BORDER) - (THICK / 2.0)) + offset_x, position + offset_y);
#line 226 "../src/sudoku-printer.vala"
				cairo_move_to (cr, position + offset_x, (BORDER + (THICK / 2.0)) + offset_y);
#line 227 "../src/sudoku-printer.vala"
				cairo_line_to (cr, position + offset_x, ((size - BORDER) - (THICK / 2.0)) + offset_y);
#line 228 "../src/sudoku-printer.vala"
				cairo_stroke (cr);
#line 1078 "sudoku-printer.c"
			}
		}
	}
#line 231 "../src/sudoku-printer.vala"
	cairo_set_font_size (cr, (gdouble) FONT_SIZE);
#line 232 "../src/sudoku-printer.vala"
	_tmp27_ = g_strdup ("");
#line 232 "../src/sudoku-printer.vala"
	letter = _tmp27_;
#line 234 "../src/sudoku-printer.vala"
	_tmp30_ = sudoku_board_get_cells (sudoku_board, &_tmp28_, &_tmp29_);
#line 234 "../src/sudoku-printer.vala"
	sudoku = _tmp30_;
#line 234 "../src/sudoku-printer.vala"
	sudoku_length1 = _tmp28_;
#line 234 "../src/sudoku-printer.vala"
	sudoku_length2 = _tmp29_;
#line 236 "../src/sudoku-printer.vala"
	invert = gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL;
#line 1098 "sudoku-printer.c"
	{
		gint x = 0;
#line 238 "../src/sudoku-printer.vala"
		x = 0;
#line 1103 "sudoku-printer.c"
		{
			gboolean _tmp31_ = FALSE;
#line 238 "../src/sudoku-printer.vala"
			_tmp31_ = TRUE;
#line 238 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 1110 "sudoku-printer.c"
				gint _tmp33_ = 0;
				gint real_x = 0;
#line 238 "../src/sudoku-printer.vala"
				if (!_tmp31_) {
#line 1115 "sudoku-printer.c"
					gint _tmp32_;
#line 238 "../src/sudoku-printer.vala"
					_tmp32_ = x;
#line 238 "../src/sudoku-printer.vala"
					x = _tmp32_ + 1;
#line 1121 "sudoku-printer.c"
				}
#line 238 "../src/sudoku-printer.vala"
				_tmp31_ = FALSE;
#line 238 "../src/sudoku-printer.vala"
				if (!(x < SUDOKU_SIZE)) {
#line 238 "../src/sudoku-printer.vala"
					break;
#line 1129 "sudoku-printer.c"
				}
#line 240 "../src/sudoku-printer.vala"
				if (invert) {
#line 240 "../src/sudoku-printer.vala"
					_tmp33_ = (SUDOKU_SIZE - x) - 1;
#line 1135 "sudoku-printer.c"
				} else {
#line 240 "../src/sudoku-printer.vala"
					_tmp33_ = x;
#line 1139 "sudoku-printer.c"
				}
#line 240 "../src/sudoku-printer.vala"
				real_x = _tmp33_;
#line 1143 "sudoku-printer.c"
				{
					gint y = 0;
#line 241 "../src/sudoku-printer.vala"
					y = 0;
#line 1148 "sudoku-printer.c"
					{
						gboolean _tmp34_ = FALSE;
#line 241 "../src/sudoku-printer.vala"
						_tmp34_ = TRUE;
#line 241 "../src/sudoku-printer.vala"
						while (TRUE) {
#line 1155 "sudoku-printer.c"
							gdouble* _tmp36_;
							gint _tmp36__length1;
							gdouble _tmp37_;
							gdouble* _tmp38_;
							gint _tmp38__length1;
							gdouble _tmp39_;
							gchar* _tmp40_;
							gint* _tmp41_;
							gint _tmp41__length1;
							gint _tmp41__length2;
							gint _tmp42_;
#line 241 "../src/sudoku-printer.vala"
							if (!_tmp34_) {
#line 1169 "sudoku-printer.c"
								gint _tmp35_;
#line 241 "../src/sudoku-printer.vala"
								_tmp35_ = y;
#line 241 "../src/sudoku-printer.vala"
								y = _tmp35_ + 1;
#line 1175 "sudoku-printer.c"
							}
#line 241 "../src/sudoku-printer.vala"
							_tmp34_ = FALSE;
#line 241 "../src/sudoku-printer.vala"
							if (!(y < SUDOKU_SIZE)) {
#line 241 "../src/sudoku-printer.vala"
								break;
#line 1183 "sudoku-printer.c"
							}
#line 243 "../src/sudoku-printer.vala"
							_tmp36_ = pos;
#line 243 "../src/sudoku-printer.vala"
							_tmp36__length1 = pos_length1;
#line 243 "../src/sudoku-printer.vala"
							_tmp37_ = _tmp36_[x];
#line 243 "../src/sudoku-printer.vala"
							_tmp38_ = pos;
#line 243 "../src/sudoku-printer.vala"
							_tmp38__length1 = pos_length1;
#line 243 "../src/sudoku-printer.vala"
							_tmp39_ = _tmp38_[y];
#line 243 "../src/sudoku-printer.vala"
							cairo_move_to (cr, _tmp37_ + offset_x, _tmp39_ + offset_y);
#line 244 "../src/sudoku-printer.vala"
							_tmp40_ = g_strdup ("");
#line 244 "../src/sudoku-printer.vala"
							_g_free0 (letter);
#line 244 "../src/sudoku-printer.vala"
							letter = _tmp40_;
#line 246 "../src/sudoku-printer.vala"
							_tmp41_ = sudoku;
#line 246 "../src/sudoku-printer.vala"
							_tmp41__length1 = sudoku_length1;
#line 246 "../src/sudoku-printer.vala"
							_tmp41__length2 = sudoku_length2;
#line 246 "../src/sudoku-printer.vala"
							_tmp42_ = _tmp41_[(y * _tmp41__length2) + real_x];
#line 246 "../src/sudoku-printer.vala"
							if (_tmp42_ != 0) {
#line 1215 "sudoku-printer.c"
								gint* _tmp43_;
								gint _tmp43__length1;
								gint _tmp43__length2;
								gint _tmp44_;
								gchar* _tmp45_;
								const gchar* _tmp49_;
								cairo_text_extents_t _tmp50_ = {0};
								gdouble* _tmp51_;
								gint _tmp51__length1;
								gdouble _tmp52_;
								cairo_text_extents_t _tmp53_;
								gdouble* _tmp54_;
								gint _tmp54__length1;
								gdouble _tmp55_;
								cairo_text_extents_t _tmp56_;
								const gchar* _tmp57_;
#line 248 "../src/sudoku-printer.vala"
								_tmp43_ = sudoku;
#line 248 "../src/sudoku-printer.vala"
								_tmp43__length1 = sudoku_length1;
#line 248 "../src/sudoku-printer.vala"
								_tmp43__length2 = sudoku_length2;
#line 248 "../src/sudoku-printer.vala"
								_tmp44_ = _tmp43_[(y * _tmp43__length2) + real_x];
#line 248 "../src/sudoku-printer.vala"
								_tmp45_ = g_strdup_printf ("%i", _tmp44_);
#line 248 "../src/sudoku-printer.vala"
								_g_free0 (letter);
#line 248 "../src/sudoku-printer.vala"
								letter = _tmp45_;
#line 250 "../src/sudoku-printer.vala"
								if (sudoku_board_get_is_fixed (sudoku_board, y, real_x)) {
#line 252 "../src/sudoku-printer.vala"
									cairo_select_font_face (cr, "Sans", CAIRO_FONT_SLANT_NORMAL, FONT_WEIGHT);
#line 253 "../src/sudoku-printer.vala"
									cairo_set_source_rgb (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 1252 "sudoku-printer.c"
								} else {
									gdouble _tmp46_;
									gdouble _tmp47_;
									gdouble _tmp48_;
#line 257 "../src/sudoku-printer.vala"
									cairo_select_font_face (cr, "Sans", CAIRO_FONT_SLANT_ITALIC, FONT_WEIGHT);
#line 258 "../src/sudoku-printer.vala"
									_tmp46_ = PENCIL_GREY[0];
#line 258 "../src/sudoku-printer.vala"
									_tmp47_ = PENCIL_GREY[1];
#line 258 "../src/sudoku-printer.vala"
									_tmp48_ = PENCIL_GREY[2];
#line 258 "../src/sudoku-printer.vala"
									cairo_set_source_rgb (cr, _tmp46_, _tmp47_, _tmp48_);
#line 1267 "sudoku-printer.c"
								}
#line 260 "../src/sudoku-printer.vala"
								_tmp49_ = letter;
#line 260 "../src/sudoku-printer.vala"
								cairo_text_extents (cr, _tmp49_, &_tmp50_);
#line 260 "../src/sudoku-printer.vala"
								extents = _tmp50_;
#line 261 "../src/sudoku-printer.vala"
								_tmp51_ = pos;
#line 261 "../src/sudoku-printer.vala"
								_tmp51__length1 = pos_length1;
#line 261 "../src/sudoku-printer.vala"
								_tmp52_ = _tmp51_[x];
#line 261 "../src/sudoku-printer.vala"
								_tmp53_ = extents;
#line 261 "../src/sudoku-printer.vala"
								_tmp54_ = pos;
#line 261 "../src/sudoku-printer.vala"
								_tmp54__length1 = pos_length1;
#line 261 "../src/sudoku-printer.vala"
								_tmp55_ = _tmp54_[y];
#line 261 "../src/sudoku-printer.vala"
								_tmp56_ = extents;
#line 261 "../src/sudoku-printer.vala"
								cairo_move_to (cr, (_tmp52_ + offset_x) - (_tmp53_.x_advance / 2.0), (_tmp55_ + offset_y) + (_tmp56_.height / 2.0));
#line 262 "../src/sudoku-printer.vala"
								_tmp57_ = letter;
#line 262 "../src/sudoku-printer.vala"
								cairo_show_text (cr, _tmp57_);
#line 1297 "sudoku-printer.c"
							}
						}
					}
				}
			}
		}
	}
#line 158 "../src/sudoku-printer.vala"
	sudoku = (g_free (sudoku), NULL);
#line 158 "../src/sudoku-printer.vala"
	_g_free0 (letter);
#line 158 "../src/sudoku-printer.vala"
	pos = (g_free (pos), NULL);
#line 158 "../src/sudoku-printer.vala"
	outer = (g_free (outer), NULL);
#line 1313 "sudoku-printer.c"
}

static void
sudoku_printer_class_init (SudokuPrinterClass * klass,
                           gpointer klass_data)
{
#line 24 "../src/sudoku-printer.vala"
	sudoku_printer_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/sudoku-printer.vala"
	g_type_class_adjust_private_offset (klass, &SudokuPrinter_private_offset);
#line 24 "../src/sudoku-printer.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_printer_finalize;
#line 1326 "sudoku-printer.c"
}

static void
sudoku_printer_instance_init (SudokuPrinter * self,
                              gpointer klass)
{
#line 24 "../src/sudoku-printer.vala"
	self->priv = sudoku_printer_get_instance_private (self);
#line 1335 "sudoku-printer.c"
}

static void
sudoku_printer_finalize (GObject * obj)
{
	SudokuPrinter * self;
#line 24 "../src/sudoku-printer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_PRINTER, SudokuPrinter);
#line 26 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->boards);
#line 27 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->window);
#line 33 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->print_op);
#line 24 "../src/sudoku-printer.vala"
	G_OBJECT_CLASS (sudoku_printer_parent_class)->finalize (obj);
#line 1352 "sudoku-printer.c"
}

static GType
sudoku_printer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuPrinterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_printer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuPrinter), 0, (GInstanceInitFunc) sudoku_printer_instance_init, NULL };
	GType sudoku_printer_type_id;
	sudoku_printer_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuPrinter", &g_define_type_info, 0);
	SudokuPrinter_private_offset = g_type_add_instance_private (sudoku_printer_type_id, sizeof (SudokuPrinterPrivate));
	return sudoku_printer_type_id;
}

GType
sudoku_printer_get_type (void)
{
	static volatile gsize sudoku_printer_type_id__once = 0;
	if (g_once_init_enter (&sudoku_printer_type_id__once)) {
		GType sudoku_printer_type_id;
		sudoku_printer_type_id = sudoku_printer_get_type_once ();
		g_once_init_leave (&sudoku_printer_type_id__once, sudoku_printer_type_id);
	}
	return sudoku_printer_type_id__once;
}

